/**
 * \file
 *
 * \brief ߓLWۯǗ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CHIP_GENCLK_H_INCLUDED
#define CHIP_GENCLK_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

// zˑ邽߂dfll.hͲݸٰނ܂B
extern void dfll_enable_config_defaults(uint32_t dfll_id);

/**
 * \weakgroup genclk_group
 * @{
 */

//! \name ߓLWۯ`
//@{

#define GENCLK_DIV_MAX		256

#ifndef __ASSEMBLY__

#include <compiler.h>
#include <osc.h>
#include <pll.h>

enum genclk_source {
	GENCLK_SRC_RCSYS		= 0,	//!< RCU
	GENCLK_SRC_OSC32K		= 1,	//!< 32kHzU
	GENCLK_SRC_DFLL			= 2,	//!< DFLL
	GENCLK_SRC_OSC0			= 3,	//!< U0
	GENCLK_SRC_RC80M		= 4,	//!< 80MHz RCU
	GENCLK_SRC_RCFAST		= 5,	//!< 4-8-12MHz RCU
	GENCLK_SRC_RC1M			= 6,	//!< 1MHz RCU
	GENCLK_SRC_CLK_CPU		= 7,	//!< CPUۯ
	GENCLK_SRC_CLK_HSB		= 8,	//!< ޽ ۯ
	GENCLK_SRC_CLK_PBA		= 9,	//!< ޽Aۯ
	GENCLK_SRC_CLK_PBB		= 10,	//!< ޽Bۯ
	GENCLK_SRC_CLK_PBC		= 11,	//!< ޽Cۯ
	GENCLK_SRC_CLK_PBD		= 12,	//!< ޽Dۯ
	GENCLK_SRC_RC32K		= 13,	//!< 32kHz RCU
	GENCLK_SRC_CLK_1K		= 15,	//!< OSC32K1kHzo
	GENCLK_SRC_PLL0			= 16,	//!< PLL0
	GENCLK_SRC_HRPCLK		= 17,	//!< @\Ou
	GENCLK_SRC_FPCLK		= 18,	//!< Ou
	GENCLK_SRC_GCLKIN0		= 19,	//!< GCLKIN0
	GENCLK_SRC_GCLKIN1		= 20,	//!< GCLKIN1
	GENCLK_SRC_GCLK11		= 21,	//!< GCLK11
};

//@}

struct genclk_config {
	uint32_t ctrl;
};

static inline void genclk_config_defaults(struct genclk_config *cfg,
		uint32_t id)
{
	UNUSED(id);
	cfg->ctrl = 0;
}

static inline void genclk_config_read(struct genclk_config *cfg,
		uint32_t id)
{
	cfg->ctrl = SCIF->SCIF_GCCTRL[id].SCIF_GCCTRL;
}

static inline void genclk_config_write(const struct genclk_config *cfg,
		uint32_t id)
{
	SCIF->SCIF_GCCTRL[id].SCIF_GCCTRL = cfg->ctrl;
}

static inline void genclk_config_set_source(struct genclk_config *cfg,
		enum genclk_source src)
{
	cfg->ctrl = (cfg->ctrl & ~SCIF_GCCTRL_OSCSEL_Msk)
			| SCIF_GCCTRL_OSCSEL(src);
}

static inline void genclk_config_set_divider(struct genclk_config *cfg,
		uint32_t divider)
{
	Assert(divider > 0 && divider <= GENCLK_DIV_MAX);

	/* ύX悤ƂSޯĂ */
	cfg->ctrl &= ~(SCIF_GCCTRL_DIVEN
			| SCIF_GCCTRL_DIV_Msk);

	if (divider > 1) {
		cfg->ctrl |= SCIF_GCCTRL_DIVEN;
		cfg->ctrl |= SCIF_GCCTRL_DIV(((divider + 1) / 2) - 1);
	}
}

static inline void genclk_enable(const struct genclk_config *cfg,
		uint32_t id)
{
	 SCIF->SCIF_GCCTRL[id].SCIF_GCCTRL = cfg->ctrl | SCIF_GCCTRL_CEN;
}

static inline void genclk_disable(uint32_t id)
{
	SCIF->SCIF_GCCTRL[id].SCIF_GCCTRL = 0;
}

static inline void genclk_enable_source(enum genclk_source src)
{
	switch (src) {
	case GENCLK_SRC_RCSYS:
	case GENCLK_SRC_CLK_CPU:
	case GENCLK_SRC_CLK_HSB:
	case GENCLK_SRC_CLK_PBA:
	case GENCLK_SRC_CLK_PBB:
	case GENCLK_SRC_CLK_PBC:
	case GENCLK_SRC_CLK_PBD:
		// 邱ƂȂ
		break;

#ifdef BOARD_OSC32_HZ
	case GENCLK_SRC_OSC32K:
	case GENCLK_SRC_CLK_1K: // OSC32KɌq1KHz
		if (!osc_is_ready(OSC_ID_OSC32)) {
			osc_enable(OSC_ID_OSC32);
			osc_wait_ready(OSC_ID_OSC32);
		}
		break;
#endif

	case GENCLK_SRC_RC80M:
		if (!osc_is_ready(OSC_ID_RC80M)) {
			osc_enable(OSC_ID_RC80M);
			osc_wait_ready(OSC_ID_RC80M);
		}
		break;

	case GENCLK_SRC_RCFAST:
		if (!osc_is_ready(OSC_ID_RCFAST)) {
			osc_enable(OSC_ID_RCFAST);
			osc_wait_ready(OSC_ID_RCFAST);
		}
		break;

	case GENCLK_SRC_RC1M:
		if (!osc_is_ready(OSC_ID_RC1M)) {
			osc_enable(OSC_ID_RC1M);
			osc_wait_ready(OSC_ID_RC1M);
		}
		break;

	case GENCLK_SRC_RC32K:
		if (!osc_is_ready(OSC_ID_RC32K)) {
			osc_enable(OSC_ID_RC32K);
			osc_wait_ready(OSC_ID_RC32K);
		}
		break;

#ifdef CONFIG_DFLL0_SOURCE
	case GENCLK_SRC_DFLL:
		dfll_enable_config_defaults(0);
		break;
#endif

#ifdef BOARD_OSC0_HZ
	case GENCLK_SRC_OSC0:
		if (!osc_is_ready(OSC_ID_OSC0)) {
			osc_enable(OSC_ID_OSC0);
			osc_wait_ready(OSC_ID_OSC0);
		}
		break;
#endif

# ifdef CONFIG_PLL0_SOURCE
	case GENCLK_SRC_PLL0: {
		pll_enable_config_defaults(0);
		break;
	}
# endif

	default:
		Assert(false);
		break;
	}
}

#endif /* __ASSEMBLY__ */

//! @}

#ifdef __cplusplus
}
#endif

#endif /* CHIP_GENCLK_H_INCLUDED */
