/**
 * \file
 *
 * \brief USBu(UDC)
 *
 * 쌠 (c) 2009 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "usb_protocol.h"
#include "udd.h"
#include "udc_desc.h"
#include "udi.h"
#include "udc.h"

/**
 * \ingroup udc_group
 * \defgroup udc_group_interne UDC̎
 *
 * Internal 
 * @{
 */

//! \name USBuǗ邽߂̓ϐ
//! @{

//! u(usb_protocol.husb_device_status񋓂B)
static le16_t udc_device_status;

//! USBνĂɂđI΂ꂽu`Ԑݒԍ
static uint8_t udc_num_configuration = 0;

//! I΂ꂽx̑uӐݒւ̈ʒuwq
static udc_config_speed_t UDC_DESC_STORAGE *udc_ptr_conf;

//! SETUPvɂĎgp̪Lqq̈ʒuwq
static usb_iface_desc_t UDC_DESC_STORAGE *udc_ptr_iface;

//! @}


//! \name USBu啶i[\
//! @{

/**
 * \brief USBǔꎯʎq(ɂUSʎq)
 */
COMPILER_WORD_ALIGNED
static UDC_DESC_STORAGE usb_str_lgid_desc_t udc_string_desc_languageid = {
	.desc.bLength = sizeof(usb_str_lgid_desc_t),
	.desc.bDescriptorType = USB_DT_STRING,
	.string = {LE16(USB_LANGID_EN_US)}
};

/**
 * \brief USBuƎҖL
 * USBp`ԐݒɂUSB_DEVICE_MANUFACTURE_NAME錾ꍇ
 * 蓖Ă܂B
 */
#ifdef USB_DEVICE_MANUFACTURE_NAME
static uint8_t udc_string_manufacturer_name[] = USB_DEVICE_MANUFACTURE_NAME;
#  define USB_DEVICE_MANUFACTURE_NAME_SIZE  \
	(sizeof(udc_string_manufacturer_name)-1)
#else
#  define USB_DEVICE_MANUFACTURE_NAME_SIZE  0
#endif

/**
 * \brief USBuiL
 * USBp`ԐݒɂUSB_DEVICE_PRODUCT_NAME錾ꍇɂ
 * 蓖Ă܂B
 */
#ifdef USB_DEVICE_PRODUCT_NAME
static uint8_t udc_string_product_name[] = USB_DEVICE_PRODUCT_NAME;
#  define USB_DEVICE_PRODUCT_NAME_SIZE  (sizeof(udc_string_product_name)-1)
#else
#  define USB_DEVICE_PRODUCT_NAME_SIZE  0
#endif

/**
 * \brief USBuʔԂ擾
 *
 * ÓIʔԂݒ肷ɂUSB_DEVICE_SERIAL_NAME`gpĂB
 *
 * IʔԂɂĂUSB_DEVICE_GET_SERIAL_NAME_POINTER`K؂Ȉʒuwq
 * ݒ肵ĂBUSB_DEVICE_GET_SERIAL_NAME_LENGTHʔԒ`v
 * B
 */
#if defined USB_DEVICE_GET_SERIAL_NAME_POINTER
	static const uint8_t *udc_get_string_serial_name(void)
	{
		return (const uint8_t *)USB_DEVICE_GET_SERIAL_NAME_POINTER;
	}
#  define USB_DEVICE_SERIAL_NAME_SIZE \
	USB_DEVICE_GET_SERIAL_NAME_LENGTH
#elif defined USB_DEVICE_SERIAL_NAME
	static const uint8_t *udc_get_string_serial_name(void)
	{
		return (const uint8_t *)USB_DEVICE_SERIAL_NAME;
	}
#  define USB_DEVICE_SERIAL_NAME_SIZE \
	(sizeof(USB_DEVICE_SERIAL_NAME)-1)
#else
#  define USB_DEVICE_SERIAL_NAME_SIZE  0
#endif

/**
 * \brief USBuLqq
 * SACIIUSBLqq\̂ɓ]̂Ɏgp\
 */
struct udc_string_desc_t {
	usb_str_desc_t header;
	le16_t string[Max(Max(USB_DEVICE_MANUFACTURE_NAME_SIZE, \
			USB_DEVICE_PRODUCT_NAME_SIZE), USB_DEVICE_SERIAL_NAME_SIZE)];
};
COMPILER_WORD_ALIGNED
static UDC_DESC_STORAGE struct udc_string_desc_t udc_string_desc = {
	.header.bDescriptorType = USB_DT_STRING
};
//! @}

usb_iface_desc_t UDC_DESC_STORAGE *udc_get_interface_desc(void)
{
	return udc_ptr_iface;
}

/**
 * \brief USB`ԐݒLqq̍Ō𒲂ׂlԂB
 *
 * \return USB`ԐݒLqq̍ŏI޲Č̱ڽ
 */
static usb_conf_desc_t UDC_DESC_STORAGE *udc_get_eof_conf(void)
{
	return (UDC_DESC_STORAGE usb_conf_desc_t *) ((uint8_t *)
			udc_ptr_conf->desc +
			le16_to_cpu(udc_ptr_conf->desc->wTotalLength));
}

#if (0!=USB_DEVICE_MAX_EP)
/**
 * \brief S̲̪LqqœLqq
 *
 * \param  desc    ̪Lqq܂͒OɌLqq̱ڽ
 * \param  desc_id Lqqʎq
 *
 * \return Lqq̱ڽ
 * \return S̲̪Lqq̍Ō̏ꍇNULL
 */
static usb_conf_desc_t UDC_DESC_STORAGE *udc_next_desc_in_iface(usb_conf_desc_t
		UDC_DESC_STORAGE * desc, uint8_t desc_id)
{
	usb_conf_desc_t UDC_DESC_STORAGE *ptr_eof_desc;

	ptr_eof_desc = udc_get_eof_conf();
	// ̋Lqq֍sB
	desc = (UDC_DESC_STORAGE usb_conf_desc_t *) ((uint8_t *) desc +
			desc->bLength);
	// `ԐݒLqq̍Ō𒲍
	while (ptr_eof_desc > desc) {
		// V̪LqqȂȂ݂S̲̪Lqq̍Ō
		// łB
		if (USB_DT_INTERFACE == desc->bDescriptorType) {
			break;			// S̲̪Lqq̍Ō
		}
		if (desc_id == desc->bDescriptorType) {
			return desc;	// Lqq
		}
		// ̋Lqq֍sB
		desc = (UDC_DESC_STORAGE usb_conf_desc_t *) ((uint8_t *) desc +
				desc->bLength);
	}
	return NULL;			// LqqȂ
}
#endif

/**
 * \brief ̪Lqq
 * ٰ݂udc_ptr_ifaceʒuwqXV܂B
 *
 * \param  iface_num   `ԐݒLqqŌ̪ԍ
 * \param  setting_num ̪̐ݒԍ
 *
 * \return ꍇ1AȂꍇ0
 */
static bool udc_update_iface_desc(uint8_t iface_num, uint8_t setting_num)
{
	usb_conf_desc_t UDC_DESC_STORAGE *ptr_end_desc;

	if (0 == udc_num_configuration) {
		return false;
	}

	if (iface_num >= udc_ptr_conf->desc->bNumInterfaces) {
		return false;
	}

	// `ԐݒLqq̎n߂ŊJn
	udc_ptr_iface = (UDC_DESC_STORAGE usb_iface_desc_t *)
			udc_ptr_conf->desc;

	// `ԐݒLqq̍Ō𒲍
	ptr_end_desc = udc_get_eof_conf();
	while (ptr_end_desc >
			(UDC_DESC_STORAGE usb_conf_desc_t *) udc_ptr_iface) {
		if (USB_DT_INTERFACE == udc_ptr_iface->bDescriptorType) {
			// ̪Lqq
			// ̪Ƒ֐ݒԍ𒲍
			if ((iface_num == udc_ptr_iface->bInterfaceNumber) &&
					(setting_num ==
					udc_ptr_iface->bAlternateSetting)) {
				return true;	// ̪
			}
		}
		// ̋Lqq֍sB
		udc_ptr_iface = (UDC_DESC_STORAGE usb_iface_desc_t *) (
				(uint8_t *) udc_ptr_iface +
				udc_ptr_iface->bLength);
	}
	return false;	// ̪Ȃ
}

/**
 * \brief USBu-̪(UDI)֎~
 * ٰ݂Ͳ̪-ԍɑΉUDIĂт܂B
 *
 * \param  iface_num ֎~̪ԍ
 *
 * \return I1A̪炸0
 */
static bool udc_iface_disable(uint8_t iface_num)
{
	udi_api_t UDC_DESC_STORAGE *udi_api;

	// iface->getsetting()ĂԑOudc_ptr_ifaceXV̪̍ŏ̑
	// ݒI
	if (!udc_update_iface_desc(iface_num, 0)) {
		return false;
	}

	// ݂̑֐ݒŲ̪I
	udi_api = udc_ptr_conf->udi_apis[iface_num];

#if (0!=USB_DEVICE_MAX_EP)
	if (!udc_update_iface_desc(iface_num, udi_api->getsetting())) {
		return false;
	}

	// ̪Lqq̎n߂ŊJn
	{
		usb_ep_desc_t UDC_DESC_STORAGE *ep_desc;
		ep_desc = (UDC_DESC_STORAGE usb_ep_desc_t *) udc_ptr_iface;
		while (1) {
			// S̲̪LqqɊ܂܂߲ċLqq
			ep_desc = (UDC_DESC_STORAGE usb_ep_desc_t *)
					udc_next_desc_in_iface((UDC_DESC_STORAGE
					usb_conf_desc_t *)
					ep_desc, USB_DT_ENDPOINT);
			if (NULL == ep_desc) {
				break;
			}
			// ̪ɂĎgp߲
			udd_ep_free(ep_desc->bEndpointAddress);
		}
	}
#endif

	// ̪֎~
	udi_api->disable();
	return true;
}

/**
 * \brief USBu̪(UDI)
 * ٰ݂Ͳ̪ƐݒԍɑΉUDIĂт܂B
 *
 * \param  iface_num   -̪ԍ
 * \param  setting_num ݒԍ
 *
 * \return I1A̪Ȃꍇ0
 */
static bool udc_iface_enable(uint8_t iface_num, uint8_t setting_num)
{
	// Select the interface descriptor
	if (!udc_update_iface_desc(iface_num, setting_num)) {
		return false;
	}

#if (0!=USB_DEVICE_MAX_EP)
	usb_ep_desc_t UDC_DESC_STORAGE *ep_desc;

	// S̲̪Lqq̎n߂ŊJn
	ep_desc = (UDC_DESC_STORAGE usb_ep_desc_t *) udc_ptr_iface;
	while (1) {
		// S̲̪LqqɊ܂܂߲ċLqq
		ep_desc = (UDC_DESC_STORAGE usb_ep_desc_t *)
				udc_next_desc_in_iface((UDC_DESC_STORAGE
						usb_conf_desc_t *) ep_desc,
				USB_DT_ENDPOINT);
		if (NULL == ep_desc)
			break;
		// ̪ɂĎgp߲Ă蓖
		if (!udd_ep_alloc(ep_desc->bEndpointAddress,
				ep_desc->bmAttributes,
				le16_to_cpu
				(ep_desc->wMaxPacketSize))) {
			return false;
		}
	}
#endif
	// ̪
	return udc_ptr_conf->udi_apis[iface_num]->enable();
}

/*! \brief USBuKwJn
 */
void udc_start(void)
{
	udd_enable();
}

/*! \brief USBuKw~
 */
void udc_stop(void)
{
	udd_disable();
	udc_reset();
}

/**
 * \brief USBǔ݂̌`Ԑݒؾ
 * ٰ݂USBRESETNUDDɂČĂ΂꓾܂B
 */
void udc_reset(void)
{
	uint8_t iface_num;

	if (udc_num_configuration) {
		for (iface_num = 0;
				iface_num < udc_ptr_conf->desc->bNumInterfaces;
				iface_num++) {
			udc_iface_disable(iface_num);
		}
	}
	udc_num_configuration = 0;
#if (USB_CONFIG_ATTR_REMOTE_WAKEUP \
	== (USB_DEVICE_ATTR & USB_CONFIG_ATTR_REMOTE_WAKEUP))
	if (CPU_TO_LE16(USB_DEV_STATUS_REMOTEWAKEUP) & udc_device_status) {
		// uNǍɂ֎~
		UDC_REMOTEWAKEUP_DISABLE();
	}
#endif
	udc_device_status =
#if (USB_DEVICE_ATTR & USB_CONFIG_ATTR_SELF_POWERED)
			CPU_TO_LE16(USB_DEV_STATUS_SELF_POWERED);
#else
			CPU_TO_LE16(USB_DEV_STATUS_BUS_POWERED);
#endif
}

void udc_sof_notify(void)
{
	uint8_t iface_num;

	if (udc_num_configuration) {
		for (iface_num = 0;
				iface_num < udc_ptr_conf->desc->bNumInterfaces;
				iface_num++) {
			if (udc_ptr_conf->udi_apis[iface_num]->sof_notify != NULL) {
				udc_ptr_conf->udi_apis[iface_num]->sof_notify();
			}
		}
	}
}

/**
 * \brief uԂ𓾂邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_get_status(void)
{
	if (udd_g_ctrlreq.req.wLength != sizeof(udc_device_status)) {
		return false;
	}

	udd_set_setup_payload( (uint8_t *) & udc_device_status,
			sizeof(udc_device_status));
	return true;
}

#if (0!=USB_DEVICE_MAX_EP)
/**
 * \brief ߲ďԂ𓾂邽߂̕W߲ėv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_ep_get_status(void)
{
	static le16_t udc_ep_status;

	if (udd_g_ctrlreq.req.wLength != sizeof(udc_ep_status)) {
		return false;
	}

	udc_ep_status = udd_ep_is_halted(udd_g_ctrlreq.req.
			wIndex & 0xFF) ? CPU_TO_LE16(USB_EP_STATUS_HALTED) : 0;

	udd_set_setup_payload( (uint8_t *) & udc_ep_status,
			sizeof(udc_ep_status));
	return true;
}
#endif

/**
 * \brief uԂύX邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_clear_feature(void)
{
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}

	if (udd_g_ctrlreq.req.wValue == USB_DEV_FEATURE_REMOTE_WAKEUP) {
		udc_device_status &= CPU_TO_LE16(~(uint32_t)USB_DEV_STATUS_REMOTEWAKEUP);
#if (USB_CONFIG_ATTR_REMOTE_WAKEUP \
	== (USB_DEVICE_ATTR & USB_CONFIG_ATTR_REMOTE_WAKEUP))
		UDC_REMOTEWAKEUP_DISABLE();
#endif
		return true;
	}
	return false;
}

#if (0!=USB_DEVICE_MAX_EP)
/**
 * \brief ߲ċ@\邽߂̕W߲ėv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_ep_clear_feature(void)
{
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}

	if (udd_g_ctrlreq.req.wValue == USB_EP_FEATURE_HALT) {
		return udd_ep_clear_halt(udd_g_ctrlreq.req.wIndex & 0xFF);
	}
	return false;
}
#endif

/**
 * \brief @\ݒ肷邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_set_feature(void)
{
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}

	switch (udd_g_ctrlreq.req.wValue) {

	case USB_DEV_FEATURE_REMOTE_WAKEUP:
#if (USB_CONFIG_ATTR_REMOTE_WAKEUP \
	== (USB_DEVICE_ATTR & USB_CONFIG_ATTR_REMOTE_WAKEUP))
		udc_device_status |= CPU_TO_LE16(USB_DEV_STATUS_REMOTEWAKEUP);
		UDC_REMOTEWAKEUP_ENABLE();
		return true;
#else
		return false;
#endif

#ifdef USB_DEVICE_HS_SUPPORT
	case USB_DEV_FEATURE_TEST_MODE:
		if (!udd_is_high_speed()) {
			break;
		}
		if (udd_g_ctrlreq.req.wIndex & 0xff) {
			break;
		}
		// u`ԐݒASĂ̐is̗vI
		udc_reset();
		switch ((udd_g_ctrlreq.req.wIndex >> 8) & 0xFF) {
		case USB_DEV_TEST_MODE_J:
			udd_g_ctrlreq.callback = udd_test_mode_j;
			return true;

		case USB_DEV_TEST_MODE_K:
			udd_g_ctrlreq.callback = udd_test_mode_k;
			return true;

		case USB_DEV_TEST_MODE_SE0_NAK:
			udd_g_ctrlreq.callback = udd_test_mode_se0_nak;
			return true;

		case USB_DEV_TEST_MODE_PACKET:
			udd_g_ctrlreq.callback = udd_test_mode_packet;
			return true;

		case USB_DEV_TEST_MODE_FORCE_ENABLE:	//  ߰ĂɌp
		default:
			break;
		}
		break;
#endif
	default:
		break;
	}
	return false;
}

/**
 * \brief ߲Ē~̂߂̕W߲ėv
 *
 * \return Ȃtrue
 */
#if (0!=USB_DEVICE_MAX_EP)
static bool udc_req_std_ep_set_feature(void)
{
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}
	if (udd_g_ctrlreq.req.wValue == USB_EP_FEATURE_HALT) {
		udd_ep_abort(udd_g_ctrlreq.req.wIndex & 0xFF);
		return udd_ep_set_halt(udd_g_ctrlreq.req.wIndex & 0xFF);
	}
	return false;
}
#endif

/**
 * \brief u̱ڽύX
 * ڽݒv̍ŌŌĂ΂Ăі߂
 */
static void udc_valid_address(void)
{
	udd_set_address(udd_g_ctrlreq.req.wValue & 0x7F);
}

/**
 * \brief uڽݒ肷邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_set_address(void)
{
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}

	// ڽ޼SETUPv̍ŌŕύXȂ΂Ȃ炸Ǎڽ
	// ύX̂ɌĂі߂g܂B
	udd_g_ctrlreq.callback = udc_valid_address;
	return true;
}

/**
 * \brief uLqq𓾂邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_get_str_desc(void)
{
	uint8_t i;
	const uint8_t *str;
	uint8_t str_length = 0;

	// vɑΉ镶{̂ւ̈ʒuwqɌq
	switch (udd_g_ctrlreq.req.wValue & 0xff) {
	case 0:
		udd_set_setup_payload((uint8_t *) &udc_string_desc_languageid,
				sizeof(udc_string_desc_languageid));
		break;

#ifdef USB_DEVICE_MANUFACTURE_NAME
	case 1:
		str_length = USB_DEVICE_MANUFACTURE_NAME_SIZE;
		str = udc_string_manufacturer_name;
		break;
#endif
#ifdef USB_DEVICE_PRODUCT_NAME
	case 2:
		str_length = USB_DEVICE_PRODUCT_NAME_SIZE;
		str = udc_string_product_name;
		break;
#endif
#if defined USB_DEVICE_SERIAL_NAME || defined USB_DEVICE_GET_SERIAL_NAME_POINTER
	case 3:
		str_length = USB_DEVICE_SERIAL_NAME_SIZE;
		str = udc_get_string_serial_name();
		break;
#endif
	default:
#ifdef UDC_GET_EXTRA_STRING
		if (UDC_GET_EXTRA_STRING()) {
			break;
		}
#endif
		return false;
	}

	if (str_length) {
		for(i = 0; i < str_length; i++) {
			udc_string_desc.string[i] = cpu_to_le16((le16_t)str[i]);
		}

		udc_string_desc.header.bLength = 2 + (str_length) * 2;
		udd_set_setup_payload(
			(uint8_t *) &udc_string_desc,
			udc_string_desc.header.bLength);
	}

	return true;
}

/**
 * \brief USBuɂĂ̋Lqq𓾂邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_get_descriptor(void)
{
	uint8_t conf_num;

	conf_num = udd_g_ctrlreq.req.wValue & 0xff;

	// Lqqʎq𒲍
	switch ((uint8_t) (udd_g_ctrlreq.req.wValue >> 8)) {
	case USB_DT_DEVICE:
		// vꂽuLqq
#ifdef USB_DEVICE_HS_SUPPORT
		if (!udd_is_high_speed()) {
			udd_set_setup_payload(
				(uint8_t *) udc_config.confdev_hs,
				udc_config.confdev_hs->bLength);
		} else
#endif
		{
			udd_set_setup_payload(
				(uint8_t *) udc_config.confdev_lsfs,
				udc_config.confdev_lsfs->bLength);
		}
		break;

	case USB_DT_CONFIGURATION:
		// vꂽ`ԐݒLqq
#ifdef USB_DEVICE_HS_SUPPORT
		if (udd_is_high_speed()) {
			// HSLqq
			if (conf_num >= udc_config.confdev_hs->
					bNumConfigurations) {
				return false;
			}
			udd_set_setup_payload(
				(uint8_t *)udc_config.conf_hs[conf_num].desc,
				le16_to_cpu(udc_config.conf_hs[conf_num].desc->wTotalLength));
		} else
#endif
		{
			// FSLqq
			if (conf_num >= udc_config.confdev_lsfs->
					bNumConfigurations) {
				return false;
			}
			udd_set_setup_payload(
				(uint8_t *)udc_config.conf_lsfs[conf_num].desc,
				le16_to_cpu(udc_config.conf_lsfs[conf_num].desc->wTotalLength));
		}
		((usb_conf_desc_t *) udd_g_ctrlreq.payload)->bDescriptorType =
				USB_DT_CONFIGURATION;
		break;

#ifdef USB_DEVICE_HS_SUPPORT
	case USB_DT_DEVICE_QUALIFIER:
		// vꂽuCqLqq
		udd_set_setup_payload( (uint8_t *) udc_config.qualifier,
				udc_config.qualifier->bLength);
		break;

	case USB_DT_OTHER_SPEED_CONFIGURATION:
		// vꂽ̌`ԐݒLqq
		if (!udd_is_high_speed()) {
			// HSLqq
			if (conf_num >= udc_config.confdev_hs->
					bNumConfigurations) {
				return false;
			}
			udd_set_setup_payload(
				(uint8_t *)udc_config.conf_hs[conf_num].desc,
				le16_to_cpu(udc_config.conf_hs[conf_num].desc->wTotalLength));
		} else {
			// FSLqq
			if (conf_num >= udc_config.confdev_lsfs->
					bNumConfigurations) {
				return false;
			}
			udd_set_setup_payload(
				(uint8_t *)udc_config.conf_lsfs[conf_num].desc,
				le16_to_cpu(udc_config.conf_lsfs[conf_num].desc->wTotalLength));
		}
		((usb_conf_desc_t *) udd_g_ctrlreq.payload)->bDescriptorType =
				USB_DT_OTHER_SPEED_CONFIGURATION;
		break;
#endif

	case USB_DT_STRING:
		// vꂽLqq
		if (!udc_req_std_dev_get_str_desc()) {
			return false;
		}
		break;

	default:
		// vꂽm̋Lqq
		return false;
	}
	// vꂽLqq傫ꍇA炷B
	if (udd_g_ctrlreq.req.wLength < udd_g_ctrlreq.payload_size) {
		udd_g_ctrlreq.payload_size = udd_g_ctrlreq.req.wLength;
	}
	return true;
}

/**
 * \brief `Ԑݒԍ𓾂邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_get_configuration(void)
{
	if (udd_g_ctrlreq.req.wLength != 1) {
		return false;
	}

	udd_set_setup_payload(&udc_num_configuration,1);
	return true;
}

/**
 * \brief `Ԑݒ邽߂̕Wuv
 *
 * \return Ȃtrue
 */
static bool udc_req_std_dev_set_configuration(void)
{
	uint8_t iface_num;

	// v𒲍
	if (udd_g_ctrlreq.req.wLength) {
		return false;
	}
	// ڽLȏꍇɂ`ԐݒF
	if (!udd_getaddress()) {
		return false;
	}
	// vꂽ`Ԑݒԍ𒲍
#ifdef USB_DEVICE_HS_SUPPORT
	if (udd_is_high_speed()) {
		// HSLqq
		if ((udd_g_ctrlreq.req.wValue & 0xFF) >
				udc_config.confdev_hs->bNumConfigurations) {
			return false;
		}
	} else
#endif
	{
		// FSLqq
		if ((udd_g_ctrlreq.req.wValue & 0xFF) >
				udc_config.confdev_lsfs->bNumConfigurations) {
			return false;
		}
	}

	// ݂̌`Ԑݒؾ
	udc_reset();

	// V`Ԑݒ
	udc_num_configuration = udd_g_ctrlreq.req.wValue & 0xFF;
	if (udc_num_configuration == 0) {
		return true;	// vꂽ̋`Ԑݒ
	}
	// `ԐݒLqq̈ʒuwqXV
#ifdef USB_DEVICE_HS_SUPPORT
	if (udd_is_high_speed()) {
		// HSLqq
		udc_ptr_conf = &udc_config.conf_hs[udc_num_configuration - 1];
	} else
#endif
	{
		// FSLqq
		udc_ptr_conf = &udc_config.conf_lsfs[udc_num_configuration - 1];
	}
	// I񂾌`Ԑݒ̑SĂ̊荞݂
	for (iface_num = 0; iface_num < udc_ptr_conf->desc->bNumInterfaces;
			iface_num++) {
		if (!udc_iface_enable(iface_num, 0)) {
			return false;
		}
	}
	return true;
}

/**
 * \brief ̪̑֐ݒԍ𓾂邽߂̕W̪v
 *
 * \return Ȃtrue
 */
static bool udc_req_std_iface_get_setting(void)
{
	static uint8_t udc_iface_setting;
	uint8_t iface_num;
	udi_api_t UDC_DESC_STORAGE *udi_api;

	if (udd_g_ctrlreq.req.wLength != 1) {
		return false;	// vňُ
	}
	if (!udc_num_configuration) {
		return false;	// u͖`Ԑݒ肳ĂԂł͂ȂB
	}

	// vɊ܂܂̪-ԍ𒲍
	iface_num = udd_g_ctrlreq.req.wIndex & 0xFF;
	if (iface_num >= udc_ptr_conf->desc->bNumInterfaces) {
		return false;
	}

	// iface->getsetting()ĂԑOudc_ptr_ifaceXV̪̍ŏ̑
	// ݒI
	if (!udc_update_iface_desc(iface_num, 0)) {
		return false;
	}
	// UDI֐ݒ擾
	udi_api = udc_ptr_conf->udi_apis[iface_num];
	udc_iface_setting = udi_api->getsetting();

	// v̖{̈ʒuwq֒lqB
	udd_set_setup_payload(&udc_iface_setting,1);
	return true;
}

/**
 * \brief ̪̑֐ݒݒ肷邽߂̕W̪v
 *
 * \return Ȃtrue
 */
static bool udc_req_std_iface_set_setting(void)
{
	uint8_t iface_num, setting_num;

	if (udd_g_ctrlreq.req.wLength) {
		return false;	// vňُ
	}
	if (!udc_num_configuration) {
		return false;	// u͖`Ԑݒ肳ĂԂł͂ȂB
	}

	iface_num = udd_g_ctrlreq.req.wIndex & 0xFF;
	setting_num = udd_g_ctrlreq.req.wValue & 0xFF;

	// ݂̐ݒ֎~
	if (!udc_iface_disable(iface_num)) {
		return false;
	}

	// Vݒ
	return udc_iface_enable(iface_num, setting_num);
}

/**
 * \brief WUSB SETUPvǗٰ
 *
 * \return vxĂtrue
 */
static bool udc_reqstd(void)
{
	if (Udd_setup_is_in()) {
		// Wv擾
		if (udd_g_ctrlreq.req.wLength == 0) {
			return false;	// USBνĂɑ΂Ĉُ
		}

		if (USB_REQ_RECIP_DEVICE == Udd_setup_recipient()) {
			// Wu擾v
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_GET_STATUS:
				return udc_req_std_dev_get_status();
			case USB_REQ_GET_DESCRIPTOR:
				return udc_req_std_dev_get_descriptor();
			case USB_REQ_GET_CONFIGURATION:
				return udc_req_std_dev_get_configuration();
			default:
				break;
			}
		}

		if (USB_REQ_RECIP_INTERFACE == Udd_setup_recipient()) {
			// W^-̪擾v
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_GET_INTERFACE:
				return udc_req_std_iface_get_setting();
			default:
				break;
			}
		}
#if (0!=USB_DEVICE_MAX_EP)
		if (USB_REQ_RECIP_ENDPOINT == Udd_setup_recipient()) {
			// W߲Ď擾v
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_GET_STATUS:
				return udc_req_std_ep_get_status();
			default:
				break;
			}
		}
#endif
	} else {
		// Wvݒ
		if (USB_REQ_RECIP_DEVICE == Udd_setup_recipient()) {
			// Wuݒv
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_SET_ADDRESS:
				return udc_req_std_dev_set_address();
			case USB_REQ_CLEAR_FEATURE:
				return udc_req_std_dev_clear_feature();
			case USB_REQ_SET_FEATURE:
				return udc_req_std_dev_set_feature();
			case USB_REQ_SET_CONFIGURATION:
				return udc_req_std_dev_set_configuration();
			case USB_REQ_SET_DESCRIPTOR:
				/* x(USB2.0dlɂĔCӂƂĒ`) */
				break;
			default:
				break;
			}
		}

		if (USB_REQ_RECIP_INTERFACE == Udd_setup_recipient()) {
			// W̪ݒv
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_SET_INTERFACE:
				return udc_req_std_iface_set_setting();
			default:
				break;
			}
		}
#if (0!=USB_DEVICE_MAX_EP)
		if (USB_REQ_RECIP_ENDPOINT == Udd_setup_recipient()) {
			// W߲Đݒv
			switch (udd_g_ctrlreq.req.bRequest) {
			case USB_REQ_CLEAR_FEATURE:
				return udc_req_std_ep_clear_feature();
			case USB_REQ_SET_FEATURE:
				return udc_req_std_ep_set_feature();
			default:
				break;
			}
		}
#endif
	}
	return false;
}

/**
 * \brief UDIɲ̪SETUPv𑗏o
 *
 * \return vxȂtrue
 */
static bool udc_req_iface(void)
{
	uint8_t iface_num;
	udi_api_t UDC_DESC_STORAGE *udi_api;

	if (0 == udc_num_configuration) {
		return false;	// u͖Ԃ`Ԑݒ肳ĂȂB
	}
	// ̪ԍ
	iface_num = udd_g_ctrlreq.req.wIndex & 0xFF;
	if (iface_num >= udc_ptr_conf->desc->bNumInterfaces) {
		return false;
	}

	//* vőI΂ꂽ-̪udc_ptr_ifaceXVɂudi_api->getsetting()
	//  ĂԑOudc_ptr_ifaceXV邽߂ɲ̪̍ŏ̑֐ݒI
	//  B
	if (!udc_update_iface_desc(iface_num, 0)) {
		return false;
	}
	// ݂̑֐ݒ²̪I
	udi_api = udc_ptr_conf->udi_apis[iface_num];
	if (!udc_update_iface_desc(iface_num, udi_api->getsetting())) {
		return false;
	}

	// ̪ԍɑΉUDISETUPv𑗏o
	return udi_api->setup();
}

/**
 * \brief UDIɲ̪SETUPv𑗏o
 *
 * \return vxȂtrue
 */
static bool udc_req_ep(void)
{
	uint8_t iface_num;
	udi_api_t UDC_DESC_STORAGE *udi_api;

	if (0 == udc_num_configuration) {
		return false;	// u͖Ԃ`Ԑݒ肳ĂȂB
	}
	// ꂽSĂ̲̪ł̗v𑗏o
	iface_num = udd_g_ctrlreq.req.wIndex & 0xFF;
	for (iface_num = 0; iface_num < udc_ptr_conf->desc->bNumInterfaces;
			iface_num++) {
		// ݂̑֐ݒ²̪I
		udi_api = udc_ptr_conf->udi_apis[iface_num];
		if (!udc_update_iface_desc(iface_num, udi_api->getsetting())) {
			return false;
		}

		// UDISETUPv𑗏o
		if (udi_api->setup()) {
			return true;
		}
	}
	return false;
}

/**
 * \brief USB SETUPvǗٰ
 *
 * ̊֐USB SETUPv͂ēK؂ȕԓνĂ֒oAްSETUP OUT
 * v̏ꍇAް{̂󂯎邽߂̊ɏՕ܂B
 *
 * USB 2.0KiɂĒ`ȕWvIɏ܂B̪v
 * UDI֑Av͓艞pĂі߂֑܂B
 *
 * \return vxȂtrueAȂΗvUDDɂĒ~܂B
 */
bool udc_process_setup(void)
{
	// ɂ(M)ްȂAo^ꂽĂі߂Ȃ
	udd_g_ctrlreq.payload_size = 0;
	udd_g_ctrlreq.callback = NULL;
	udd_g_ctrlreq.over_under_run = NULL;

	if (Udd_setup_is_in()) {
		if (udd_g_ctrlreq.req.wLength == 0) {
			return false;	// USBνĂُ̈
		}
	}

	// WvȂAUDCł̕s
	if (Udd_setup_type() == USB_REQ_TYPE_STANDARD) {
		if (udc_reqstd()) {
			return true;
		}
	}

	// ̪vȂAUDIł̕s
	if (Udd_setup_recipient() == USB_REQ_RECIP_INTERFACE) {
		if (udc_req_iface()) {
			return true;
		}
	}

	// ߲ėvȂAUDIł̕s
	if (Udd_setup_recipient() == USB_REQ_RECIP_ENDPOINT) {
		if (udc_req_ep()) {
			return true;
		}
	}

	// UDCUDIɂĖmSETUPv
#ifdef USB_DEVICE_SPECIFIC_REQUEST
	// Ăі߂ŕs
	return USB_DEVICE_SPECIFIC_REQUEST();	// :޸v
#else
	return false;
#endif
}

//! @}
