/**
 * \file
 *
 * \brief SAMpEICײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "eic.h"
#include "sysclk.h"
#include "sleepmgr.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/**
 * \defgroup sam_drivers_eic_group O荞ݐ(EIC)
 *
 * \ref sam_eic_quickstart B
 *
 * EIC͊O荞݂ƂČ`Ԑݒ肳邱Ƃ݂ɋ܂B
 *
 * @{
 */

/**
 * \internal
 * \brief EICĂі߂֐ʒuwqz
 */
eic_callback_t eic_callback_pointer[EIC_NUMBER_OF_LINES];

/**
 * \brief EICʰ޳w肵`Ԑݒlŏ
 *
 * \param  eic           EICPʕ̊ڽ
 * \param  eic_line_conf EICPʕ̌`ԐݒҰ(\ref eic_line_config 
 *                       B)
 * \param  line_number   `Ԑݒ肷ԍ
 */
void eic_line_set_config(Eic *eic, uint8_t line_number,
	struct eic_line_config *eic_line_conf)
{
		/* ٍ\ݒ */
		eic->EIC_MODE = (eic_line_conf->eic_mode == EIC_MODE_LEVEL_TRIGGERED)
				? (eic->EIC_MODE | (1 << line_number))
				: (eic->EIC_MODE & ~(1 << line_number));
		/* [^\ݒ */
		eic->EIC_EDGE = (eic_line_conf->eic_edge == EIC_EDGE_RISING_EDGE)
				? (eic->EIC_EDGE | (1 << line_number))
				: (eic->EIC_EDGE & ~(1 << line_number));
		/* ٍ\ݒ */
		eic->EIC_LEVEL = (eic_line_conf->eic_level == EIC_LEVEL_HIGH_LEVEL)
				? (eic->EIC_LEVEL | (1 << line_number))
				: (eic->EIC_LEVEL & ~(1 << line_number));
		/* hg킪gpꍇɍ\ݒ */
		eic->EIC_FILTER = (eic_line_conf->eic_filter == EIC_FILTER_ENABLED)
				? (eic->EIC_FILTER | (1 << line_number))
				: (eic->EIC_FILTER & ~(1 << line_number));
		/* gpǂꂩ̓\ݒ: 񓯊/ */
		eic->EIC_ASYNC = (eic_line_conf->eic_async == EIC_ASYNCH_MODE)
				? (eic->EIC_ASYNC | (1 << line_number))
				: (eic->EIC_ASYNC & ~(1 << line_number));

}

/**
 * \brief EICPʕ֎~
 *
 * \param  eic EICPʕ̊ڽ
 */
void eic_disable(Eic *eic)
{
	sysclk_disable_peripheral_clock(eic);
	sleepmgr_unlock_mode(SLEEPMGR_BACKUP);
}

/**
 * \brief EICPʕ
 *
 * \param  eic EICPʕ̊ڽ
 */
void eic_enable(Eic *eic)
{
	sysclk_enable_peripheral_clock(eic);
	sleepmgr_lock_mode(SLEEPMGR_BACKUP);
}

/**
 * \brief ^ꂽEICɑ΂ČĂі߂ݒ
 *
 * \param  eic         EICPʕ̊ڽ
 * \param  line_number ԍ
 * \param  callback    Ăі߂֐ʒuwq
 * \param  irq_line    荞ݐ
 * \param  irq_level   荞
 */
void eic_line_set_callback(Eic *eic, uint8_t line_number,
	eic_callback_t callback, uint8_t irq_line, uint8_t irq_level)
{
	eic_callback_pointer[line_number] = callback;
	irq_register_handler((IRQn_Type)irq_line, irq_level);
	eic_line_enable_interrupt(eic, line_number);
}

/**
 * \internal
 * \brief EIC荞ݏ
 *
 * 荞ݏɂĎgpCӑǏĂі߂eic_line_set_callback()
 * ֐ɂĐݒ肳܂B
 *
 * \param  line_number 荞݂EICԍ
 */
static void eic_line_interrupt(uint8_t line_number)
{
	if (eic_callback_pointer[line_number]) {
		eic_callback_pointer[line_number]();
	} else {
		Assert(false); /* \ʊ荞ݎ󂯎 */
	}
}

/**
 * \brief EIC NMIp荞ݏ
 */
void NMI_Handler(void)
{
	eic_line_interrupt(0);
}

/**
 * \brief EIC1p荞ݏ
 */
void EIC_1_Handler(void)
{
	eic_line_interrupt(1);
}

/**
 * \brief EIC2p荞ݏ
 */
void EIC_2_Handler(void)
{
	eic_line_interrupt(2);
}

/**
 * \brief EIC3p荞ݏ
 */
void EIC_3_Handler(void)
{
	eic_line_interrupt(3);
}

/**
 * \brief EIC4p荞ݏ
 */
void EIC_4_Handler(void)
{
	eic_line_interrupt(4);
}

/**
 * \brief EIC5p荞ݏ
 */
void EIC_5_Handler(void)
{
	eic_line_interrupt(5);
}

/**
 * \brief EIC6p荞ݏ
 */
void EIC_6_Handler(void)
{
	eic_line_interrupt(6);
}

/**
 * \brief EIC7p荞ݏ
 */
void EIC_7_Handler(void)
{
	eic_line_interrupt(7);
}

/**
 * \brief EIC8p荞ݏ
 */
void EIC_8_Handler(void)
{
	eic_line_interrupt(8);
}

//@}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
