/**
 * \file
 *
 * \brief SAM4LpFlashCALWײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "flashcalw.h"
#include "sysclk.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/**
 * \defgroup group_sam_drivers_flashcalw FLASHCALW - FLASH {
 *
 * \ref sam_flashcalw_quickstart B
 *
 * FLASHCALW32ޯēHSB޽ׯ̪܂B
 *
 * \{
 */

/*! \name ׯ
 */
//! @{

/*! \brief ׯzŜ̑傫擾
 *
 * \return ׯzŜ޲Ăł̑傫
 */
uint32_t flashcalw_get_flash_size(void)
{
	const uint16_t flash_size[(FLASHCALW_FPR_FSZ_Msk >>
	FLASHCALW_FPR_FSZ_Pos) + 1] = {
		4,
		8,
		16,
		32,
		48,
		64,
		96,
		128,
		192,
		256,
		384,
		512,
		768,
		1024,
		2048,
	};
	return ((uint32_t)flash_size[(HFLASHC->FLASHCALW_FPR &
	       FLASHCALW_FPR_FSZ_Msk) >> FLASHCALW_FPR_FSZ_Pos] << 10);
}

/*! \brief ׯz߰ޑ擾
 *
 * \return ׯz߰ޑ
 */
uint32_t flashcalw_get_page_count(void)
{
	return flashcalw_get_flash_size() / FLASH_PAGE_SIZE;
}

/*! \brief eׯ̈߰ސ擾
 *
 * \return eׯ̈߰ސ
 */
uint32_t flashcalw_get_page_count_per_region(void)
{
	return flashcalw_get_page_count() / FLASH_NB_OF_REGIONS;
}

/*! \brief ߰ނ̗̈ԍ擾
 *
 * \param  page_number ߰ޔԍ
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 *
 * \return w肵߰ނ̗̈ԍ
 */
uint32_t flashcalw_get_page_region(int32_t page_number)
{
	return ((page_number >= 0) ? page_number
			: (int32_t)flashcalw_get_page_number())
			/ flashcalw_get_page_count_per_region();
}

/*! \brief ̈̍ŏ߰ނ̔ԍ擾
 *
 * \param  region ̈ԍ: \c 0 ` <tt>(FLASHCALW_REGIONS - 1)</tt>
 *
 * \return w肵̈̍ŏ߰ނ̔ԍ
 */
uint32_t flashcalw_get_region_first_page_number(uint32_t region)
{
	return region * flashcalw_get_page_count_per_region();
}

//! @}

/*! \name FLASHC
 */
//! @{

/*! \brief ׯǂݍݱ̑҂Ԑ擾
 *
 * \return ׯǂݍݱ̑҂Ԑ
 */
uint32_t flashcalw_get_wait_state(void)
{
	return (HFLASHC->FLASHCALW_FCR & FLASHCALW_FCR_FWS ? 1 : 0);
}

/*! \brief ׯǂݍݱ̑҂Ԑݒ
 *
 * \param  wait_state ׯǂݍݱ̑҂Ԑ: \c 0 ` \c 1
 */
void flashcalw_set_wait_state(uint32_t wait_state)
{
	HFLASHC->FLASHCALW_FCR = (HFLASHC->FLASHCALW_FCR & ~FLASHCALW_FCR_FWS)
			| (wait_state ? FLASHCALW_FCR_FWS_1 :
			FLASHCALW_FCR_FWS_0);
}

#define FLASH_FWS_0_MAX_FREQ		CHIP_FREQ_FWS_0
#define FLASH_FWS_1_MAX_FREQ		CHIP_FREQ_FWS_1
#define FLASH_HSEN_FWS_0_MAX_FREQ	CHIP_FREQ_FLASH_HSEN_FWS_0
#define FLASH_HSEN_FWS_1_MAX_FREQ	CHIP_FREQ_FLASH_HSEN_FWS_1

/*! \brief CPUgAd͊gkANオ蓮ɈˑāAׯǂ
 *         ݱ̑҂Ԃݒ肵čǂݍݓ܂͋֎~܂B
 *
 * \param  cpu_f_hz       CPUg
 * \param  ps_value       d͊gkl(0,1)
 * \param  is_fwu_enabled (ްْl)ANオ蓮삪Ă邩ۂ
 */
void flashcalw_set_flash_waitstate_and_readmode(uint32_t cpu_f_hz,
		uint32_t ps_value, bool is_fwu_enabled)
{
#ifdef CONFIG_FLASH_READ_MODE_HIGH_SPEED_ENABLE
	UNUSED(ps_value);
	UNUSED(is_fwu_enabled);

	if (cpu_f_hz > FLASH_FREQ_PS2_FWS_0_MAX_FREQ) { /* >24MHz */
		/* ҂Ԑݒ */
		flashcalw_set_wait_state(1);
	} else {
		/* ҂ԂȂ */
		flashcalw_set_wait_state(0);
	}

	/* ǂݍݓ싖 */
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_HSEN, -1);
#else
	if (ps_value == 0) {
		if (cpu_f_hz > FLASH_FREQ_PS0_FWS_0_MAX_FREQ) {
			// >18MHz
			if (cpu_f_hz <= FLASH_FREQ_PS0_FWS_1_MAX_FREQ) {
				// <=36MHz
				/* ҂ԐݒAǂݍݓ֎~ */
				flashcalw_set_wait_state(1);
				flashcalw_issue_command(
						FLASHCALW_FCMD_CMD_HSDIS, -1);
			} else {
				// > 36MHz
				/* ҂ԐݒAǂݍݓ싖 */
				flashcalw_set_wait_state(1);
				flashcalw_issue_command(FLASHCALW_FCMD_CMD_HSEN,
						-1);
			}
		} else { // <=18MHz
			if((is_fwu_enabled == true) &&
				(cpu_f_hz <= FLASH_FREQ_PS1_FWS_1_FWU_MAX_FREQ))
			{
				// <=12MHz
				/* ҂ԐݒAǂݍݓ֎~ */
				flashcalw_set_wait_state(1);
				flashcalw_issue_command(
						FLASHCALW_FCMD_CMD_HSDIS, -1);
			} else {
				/* ҂ԂȂAǂݍݓ֎~ */
				flashcalw_set_wait_state(0);
				flashcalw_issue_command(
					FLASHCALW_FCMD_CMD_HSDIS, -1);
			}
		}
	} else { /* ps_value == 1 */
		if (cpu_f_hz > FLASH_FREQ_PS0_FWS_0_MAX_FREQ) { /* >8MHz */
			/* ҂Ԑݒ */
			flashcalw_set_wait_state(1);
		} else {
			/* ҂ԂȂ */
			flashcalw_set_wait_state(0);
		}

		/* ǂݍݓ֎~ */
		flashcalw_issue_command(FLASHCALW_FCMD_CMD_HSDIS, -1);
	}
#endif
}

/*! \brief ׯ荞݂ĂǂB
 *
 * \return ׯ荞݂Ăǂ
 */
bool flashcalw_is_ready_int_enabled(void)
{
	return ((HFLASHC->FLASHCALW_FCR & FLASHCALW_FCR_FRDY) != 0);
}

/*! \brief ׯ荞݂܂͋֎~
 *
 * \param  enable ׯ荞݂邩ǂ:
 *                \c true ܂ \c false
 */
void flashcalw_enable_ready_int(bool enable)
{
	HFLASHC->FLASHCALW_FCR
		&= ((enable &
			FLASHCALW_FCR_FRDY) | (~FLASHCALW_FCR_FRDY));
}

/*! \brief {ُ튄荞݂Ă邩ǂB
 *
 * \return {ُ튄荞݂Ă邩ǂ
 */
bool flashcalw_is_lock_error_int_enabled(void)
{
	return ((HFLASHC->FLASHCALW_FCR & FLASHCALW_FCR_LOCKE) != 0);
}

/*! \brief {ُ튄荞݂܂͋֎~
 *
 * \param  enable {ُ튄荞݂邩ǂ: \c true ܂ \c false
 */
void flashcalw_enable_lock_error_int(bool enable)
{
	HFLASHC->FLASHCALW_FCR
		&= ((enable &
			FLASHCALW_FCR_LOCKE) | (~FLASHCALW_FCR_LOCKE));
}

/*! \brief ۸ݸވُ튄荞݂Ă邩ǂB
 *
 * \return ۸ݸވُ튄荞݂Ă邩ǂ
 */
bool flashcalw_is_prog_error_int_enabled(void)
{
	return ((HFLASHC->FLASHCALW_FCR & FLASHCALW_FCR_PROGE) != 0);
}

/*! \brief ۸ݸވُ튄荞݂܂͋֎~
 *
 * \param  enable ۸ݸވُ튄荞݂邩ǂ:
 *                \c true ܂ \c false
 */
void flashcalw_enable_prog_error_int(bool enable)
{
	HFLASHC->FLASHCALW_FCR &= ((enable &
			FLASHCALW_FCR_PROGE) | (~FLASHCALW_FCR_PROGE));
}

//! @}

/*! \name FLASHCALW
 */
//! @{

/*! \brief FLASHCALWVwߑs̏ǂB
 *
 * \return FLASHCALWVwߑs̏ǂ
 */
bool flashcalw_is_ready(void)
{
	return ((HFLASHC->FLASHCALW_FSR & FLASHCALW_FSR_FRDY) != 0);
}

/*! \brief FLASHCALWVwߑs̏ɂȂ܂Ŋɑ҂B
 *
 * \ref flashcalw_wait_until_ready Ɋ蓖Ăꂽ֐łB
 */
void flashcalw_default_wait_until_ready(void)
{
	while (!flashcalw_is_ready()) {
	}
}

/**
 * \brief FLASHCALWVwߑs̏ɂȂ܂ő҂ƂKvȎײ
 *        ɂĎgp֐ւ̈ʒuwq
 *
 * ֐\ref flashcalw_default_wait_until_ready łBgp҂͕ʂ̎g
 * p邽߂ɂ̈ʒuwqύX邩܂B
 */
void(*volatile flashcalw_wait_until_ready) (void)
	= flashcalw_default_wait_until_ready;

/**
 * \internal
 * \brief FLASHCALẄُԂ擾
 *
 * \return \c FLASHCALW_FSR_LOCKE \c FLASHCALW_FSR_PROGE\zꂽ
 *         FLASHCALẄُ
 *
 * \warning ʰ޳ُԂׯڼ޽(FSR)ǂޑSĂ̊֐ɂĉ
 *          ܂B̊֐͏]đ݂\ref flashcalw_is_lock_error 
 *          \ref flashcalw_is_programming_error ɑײނAPÏꕔł͂
 *          ܂B
 */
static uint32_t flashcalw_get_error_status(void)
{
	return HFLASHC->FLASHCALW_FSR &
	       (FLASHCALW_FSR_LOCKE | FLASHCALW_FSR_PROGE);
}

/**
 * \internal
 * FLASHCALW̊łȈُ
 *
 * ̕ϐFLASHCALWw߂𔭍s֐ɂčXV܂B͊֐ɂ
 * ĔsꂽSĂFLASHCALWw߂̗ݐςFLASHCALWُԂ܂݂܂B
 */
static uint32_t flashcalw_error_status = 0;

/*! \brief 1ȏFLASHCALWw߂𔭍sŌ̊֐Ă΂ԂɎ{ُ킪N
 *         ǂB
 *
 * \return 1ȏFLASHCALWw߂𔭍sŌ̊֐Ă΂ԂɎ{ُ킪N
 *         ǂ
 */
bool flashcalw_is_lock_error(void)
{
	return ((flashcalw_error_status & FLASHCALW_FSR_LOCKE) != 0);
}

/*! \brief 1ȏFLASHCALWw߂𔭍sŌ̊֐Ă΂Ԃ۸ݸވ
 *         킪NǂB
 *
 * \return 1ȏFLASHCALWw߂𔭍sŌ̊֐Ă΂Ԃ۸ݸވ
 *         킪Nǂ
 */
bool flashcalw_is_programming_error(void)
{
	return ((flashcalw_error_status & FLASHCALW_FSR_PROGE) != 0);
}

//! @}

/*! \name FLASHCALWwߐ
 */
//! @{

/*! \brief ŌɔsꂽFLASHCALWw߂擾
 *
 * \return ŌɔsꂽFLASHCALWw
 */
uint32_t flashcalw_get_command(void)
{
	return (HFLASHC->FLASHCALW_FCMD & FLASHCALW_FCMD_CMD_Msk);
}

/*! \brief ݂FLASHCALW߰ޔԍ擾
 *
 * \return ݂FLASHCALW߰ޔԍ
 */
uint32_t flashcalw_get_page_number(void)
{
	return ((HFLASHC->FLASHCALW_FCMD & FLASHCALW_FCMD_PAGEN_Msk)
			>> FLASHCALW_FCMD_PAGEN_Pos);
}

/*! \brief FLASHCALWw𔭍s
 *
 * \param  command     w: \c FLASHCALW_FCMD_CMD_x.
 * \param  page_number w߂Kp߰ޔԍ:
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯzׯ ߰ޔԍ;
 *                     \arg <tt>< 0</tt>: w߂݂߰ޔԍɓKpA܂
 *                     ͎w߂ǂ߰ޔԍɂKpȂꍇɂgp;
 *                     \arg ͎̈w߂ɏ]đ̈Ӗ܂B
 *                     MCUްĂFLASHCALW߂B
 *
 * \warning {ُ͎w߂ی@\ᔽ̏ꍇɔs܂B
 *
 * \warning ۸ݸވُ͎w߂̏ꍇɔs܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂXV܂B
 */
void flashcalw_issue_command(uint32_t command, int page_number)
{
	uint32_t tempo;

	flashcalw_wait_until_ready();
	tempo = HFLASHC->FLASHCALW_FCMD;
	/* wޯė̈ */
	tempo &= ~FLASHCALW_FCMD_CMD_Msk;
	if (page_number >= 0) {
		tempo = (FLASHCALW_FCMD_KEY_KEY
				| FLASHCALW_FCMD_PAGEN(page_number) | command);
	} else {
		tempo |= (FLASHCALW_FCMD_KEY_KEY | command);
	}

	HFLASHC->FLASHCALW_FCMD = tempo;
	flashcalw_error_status = flashcalw_get_error_status();
	flashcalw_wait_until_ready();
}

//! @}

/*! \name FLASHCALWS̎w
 */
//! @{

/*! \brief FLASHCALWɖw߂𔭍s
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂXV܂B
 */
void flashcalw_no_operation(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_NOP, -1);
}

/*! \brief FLASHCALWɑSw߂𔭍s
 *
 * ̎w߂ׯz̑SޯāAėp˭ ޯāAیޯĂ܂Bgp
 * ߰ނ͏܂B
 *
 * ̎w߂͕یޯĂ(A)Oڼ޽ ̧قRAM̂悤ȑS
 * ̊؂邱Ƃۏ؂܂B
 *
 * \warning Œ1̗̈悪{A܂ް۰ޕی삪L̏ꍇɎ{ُ
 *          s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error 
 *       ĕԂFLASHCALWُԂXV܂B
 *
 * \note ޯĂݒ肾ł܂B
 */
void flashcalw_erase_all(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_EA, -1);
}

//! @}

/*! \name FLASHCALWی@\
 */
//! @{

/*! \brief یޯĂLǂB
 *
 * \return یޯĂLǂ
 */
bool flashcalw_is_security_bit_active(void)
{
	return ((HFLASHC->FLASHCALW_FSR & FLASHCALW_FSR_SECURITY) != 0);
}

/*! \brief یޯĂL
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error 
 *       ĕԂFLASHCALWُԂXV܂B
 */
void flashcalw_set_security_bit(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_SSB, -1);
}

/*! \brief ߰ނ̗̈悪{Ă邩ǂB
 *
 * \param  page_number ߰ޔԍ
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ;
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 *
 * \return ߰ނ̗̈悪{Ă邩ǂ
 */
bool flashcalw_is_page_region_locked(uint32_t page_number)
{
	return flashcalw_is_region_locked(flashcalw_get_page_region(page_number));
}

/*! \brief ̈悪{Ă邩ǂB
 *
 * \param  region ̈ԍ: \c 0 ` <tt>(FLASHCALW_REGIONS - 1)</tt>
 *
 * \return ̈悪{Ă邩ǂ
 */
bool flashcalw_is_region_locked(uint32_t region)
{
	return ((HFLASHC->FLASHCALW_FSR & FLASHCALW_FSR_LOCK0
			<< (region & (FLASHCALW_REGIONS - 1))) != 0);
}

/*! \brief ߰ނ̗̈{܂͉
 *
 * \param  page_number ߰ޔԍ:
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ;
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 * \param  lock        w肵߰ނ̗̈{ǂ:
 *                     \c true ܂ \c false
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
void flashcalw_lock_page_region(int page_number, bool lock)
{
	flashcalw_issue_command(
			(lock) ? FLASHCALW_FCMD_CMD_LP : FLASHCALW_FCMD_CMD_UP,
			page_number);
}

/*! \brief ̈{܂͉
 *
 * \param  region ̈ԍ: \c 0 ` <tt>(FLASHCALW_REGIONS - 1)</tt>
 * \param  lock   w肵̈{邩ǂ: \c true ܂ \c false
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
void flashcalw_lock_region(uint32_t region, bool lock)
{
	flashcalw_lock_page_region(flashcalw_get_region_first_page_number(
			region), lock);
}

/*! \brief SĂ̗̈{܂͉
 *
 * \param  lock   w肵̈{邩ǂ: \c true ܂ \c false
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
void flashcalw_lock_all_regions(bool lock)
{
	uint32_t error_status = 0;
	uint32_t region = FLASHCALW_REGIONS;

	while (region) {
		flashcalw_lock_region(--region, lock);
		error_status |= flashcalw_error_status;
	}
	flashcalw_error_status = error_status;
}

//! @}

/*! \name ėp˭ނւ̱
 */
//! @{

/*! \brief ėp˭ ޯēǂݍ
 *
 * \param  gp_fuse_bit ėp˭ ޯ: \c 0 ` \c 63
 *
 * \return w肵ėp˭ ޯĂ̒l
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
bool flashcalw_read_gp_fuse_bit(uint32_t gp_fuse_bit)
{
	return ((flashcalw_read_all_gp_fuses() & (uint64_t)1 << (gp_fuse_bit & 0x3F))
		!= 0);
}

/*! \brief ėp˭ ޯė̈ǂݍ
 *
 * \param  pos   ėp˭ ޯė̈ޯĈʒu: \c 0 ` \c 63
 * \param  width ėp˭ ޯė̈ޯĕ: \c 0 ` \c 64
 *
 * \return w肵ėp˭ ޯė̈̒l
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
uint64_t flashcalw_read_gp_fuse_bitfield(uint32_t pos, uint32_t width)
{
	return flashcalw_read_all_gp_fuses() >> (pos & 0x3F)
		& (((uint64_t)1 << Min(width, 64)) - 1);
}

/*! \brief ėp˭ ޲ēǂݍ
 *
 * \param  gp_fuse_byte ėp˭ ޲: \c 0 ` \c 7
 *
 * \return w肵ėp˭ ޲Ă̒l
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
uint8_t flashcalw_read_gp_fuse_byte(uint32_t gp_fuse_byte)
{
	return flashcalw_read_all_gp_fuses() >> ((gp_fuse_byte & 0x07) << 3);
}

/*! \brief SĂ̔ėp˭ޓǂݍ
 *
 * \return ƂđSĂ̔ėp˭ނ̒l
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
uint64_t flashcalw_read_all_gp_fuses(void)
{
	uint32_t fuselo = HFLASHC->FLASHCALW_FGPFRLO;
	return fuselo |	(uint64_t)HFLASHC->FLASHCALW_FGPFRHI << 32;
}

/*! \brief ėp˭ ޯď
 *
 * \param  gp_fuse_bit ėp˭ ޯ: \c 0 ` \c 63
 * \param  check       邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
bool flashcalw_erase_gp_fuse_bit(uint32_t gp_fuse_bit, bool check)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_EGPB, gp_fuse_bit & 0x3F);
	return (check) ? flashcalw_read_gp_fuse_bit(gp_fuse_bit) : true;
}

/*! \brief ėp˭ ޯė̈
 *
 * \param  pos   ėp˭ ޯė̈ޯĈʒu: \c 0 ` \c 63
 * \param  width ėp˭ ޯė̈ޯĕ: \c 0 ` \c 64
 * \param  check 邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
bool flashcalw_erase_gp_fuse_bitfield(uint32_t pos, uint32_t width, bool check)
{
	uint32_t error_status = 0;
	uint32_t gp_fuse_bit;

	pos &= 0x3F;
	width = Min(width, 64);

	for (gp_fuse_bit = pos; gp_fuse_bit < pos + width; gp_fuse_bit++) {
		flashcalw_erase_gp_fuse_bit(gp_fuse_bit, false);
		error_status |= flashcalw_error_status;
	}
	flashcalw_error_status = error_status;
	return (check) ? (flashcalw_read_gp_fuse_bitfield(pos, width)
		== ((uint64_t)1 << width) - 1) : true;
}

/*! \brief ėp˭ ޲Ă
 *
 * \param  gp_fuse_byte ėp˭ ޲: \c 0 ` \c 7
 * \param  check        邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
bool flashcalw_erase_gp_fuse_byte(uint32_t gp_fuse_byte, bool check)
{
	uint32_t error_status;
	uint32_t current_gp_fuse_byte;
	uint64_t value = flashcalw_read_all_gp_fuses();

	flashcalw_erase_all_gp_fuses(false);
	error_status = flashcalw_error_status;
	for (current_gp_fuse_byte = 0; current_gp_fuse_byte < 8;
			current_gp_fuse_byte++, value >>= 8) {
		if (current_gp_fuse_byte != gp_fuse_byte) {
			flashcalw_write_gp_fuse_byte(current_gp_fuse_byte,
					value);
			error_status |= flashcalw_error_status;
		}
	}
	flashcalw_error_status = error_status;
	return (check) ? (flashcalw_read_gp_fuse_byte(gp_fuse_byte) == 0xFF)
		: true;
}

/*! \brief SĂ̔ėp˭ނ
 *
 * \param  check 邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
bool flashcalw_erase_all_gp_fuses(bool check)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_EAGPF, -1);
	/**
	 * ߲قł̌x邽߂0xFFFFFFFFFFFFFFFFULL̑(uint64_t)-1
	 * gp
	 */
	return (check) ? (flashcalw_read_all_gp_fuses() ==
		(uint64_t)-1) : true;
}

/*! \brief ėp˭ ޯĂ
 *
 * \param  gp_fuse_bit ėp˭ ޯ: \c 0 ` \c 63.
 * \param  value       w肵ėp˭ ޯĂ̒l
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_write_gp_fuse_bit(uint32_t gp_fuse_bit, bool value)
{
	if (!value) {
		flashcalw_issue_command(FLASHCALW_FCMD_CMD_WGPB, gp_fuse_bit
				& 0x3F);
	}
}

/*! \brief ėp˭ ޯė̈
 *
 * \param  pos   ėp˭ ޯė̈ޯĈʒu: \c 0 ` \c 63
 * \param  width ėp˭ ޯė̈ޯĕ: \c 0 ` \c 64
 * \param  value w肵ėp˭ ޯė̈̒l
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_write_gp_fuse_bitfield(uint32_t pos, uint32_t width,
		uint64_t value)
{
	uint32_t error_status = 0;
	uint32_t gp_fuse_bit;

	pos &= 0x3F;
	width = Min(width, 64);

	for (gp_fuse_bit = pos; gp_fuse_bit < pos + width;
			gp_fuse_bit++, value >>= 1) {
		flashcalw_write_gp_fuse_bit(gp_fuse_bit, value & 0x01);
		error_status |= flashcalw_error_status;
	}
	flashcalw_error_status = error_status;
}

/*! \brief ėp˭ ޲Ă
 *
 * \param  gp_fuse_byte ėp˭ ޲: \c 0 ` \c 7.
 * \param  value        w肵ėp˭ ޲Ă̒l
 *
 * \warning یޯĂLȏꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_write_gp_fuse_byte(uint32_t gp_fuse_byte, uint8_t value)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_PGPFB, (gp_fuse_byte & 0x07)
			| value << 3);
}

/*! \brief SĂ̔ėp˭ނ
 *
 * \param  value ƂđSĂ̔ėp˭ނ̒l
 *
 * \warning یޯĂLȏꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_write_all_gp_fuses(uint64_t value)
{
	uint32_t error_status = 0;
	uint32_t gp_fuse_byte;

	for (gp_fuse_byte = 0; gp_fuse_byte < 8; gp_fuse_byte++, value >>= 8) {
		flashcalw_write_gp_fuse_byte(gp_fuse_byte, value);
		error_status |= flashcalw_error_status;
	}
	flashcalw_error_status = error_status;
}

/*! \brief K؂ȏƏݑŔėp˭ ޯĂݒ
 *
 * \param  gp_fuse_bit ėp˭ ޯ: \c 0 ` \c 63
 * \param  value       w肵ėp˭ ޯĂ̒l
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_set_gp_fuse_bit(uint32_t gp_fuse_bit, bool value)
{
	if (value) {
		flashcalw_erase_gp_fuse_bit(gp_fuse_bit, false);
	} else {
		flashcalw_write_gp_fuse_bit(gp_fuse_bit, false);
	}
}

/*! \brief K؂ȏƏݑŔėp˭ ޯė̈ݒ
 *
 * \param  pos   ėp˭ ޯė̈ޯĈʒu: \c 0 ` \c 63
 * \param  width ėp˭ ޯė̈ޯĕ: \c 0 ` \c 64
 * \param  value w肵ėp˭ ޯė̈̒l
 *
 * \warning یޯĂLŎw߂BOOTPROTɓKpꍇɎ{ُ킪s
 *          ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_set_gp_fuse_bitfield(uint32_t pos, uint32_t width,
		uint64_t value)
{
	uint32_t error_status = 0;
	uint32_t gp_fuse_bit;

	pos &= 0x3F;
	width = Min(width, 64);

	for (gp_fuse_bit = pos; gp_fuse_bit < pos + width;
			gp_fuse_bit++, value >>= 1) {
		flashcalw_set_gp_fuse_bit(gp_fuse_bit, value & 0x01);
		error_status |= flashcalw_error_status;
	}
	flashcalw_error_status = error_status;
}

/*! \brief K؂ȏƏݑŔėp˭ ޲Ăݒ
 *
 * \param  gp_fuse_byte ėp˭ ޲: \c 0 ` \c 7
 * \param  value        w肵ėp˭ ޲Ă̒l
 *
 * \warning یޯĂLȏꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_set_gp_fuse_byte(uint32_t gp_fuse_byte, uint8_t value)
{
	uint32_t error_status;

	switch (value) {
	case 0xFF:
		flashcalw_erase_gp_fuse_byte(gp_fuse_byte, false);
		break;

	case 0x00:
		flashcalw_write_gp_fuse_byte(gp_fuse_byte, 0x00);
		break;

	default:
		flashcalw_erase_gp_fuse_byte(gp_fuse_byte, false);
		error_status = flashcalw_error_status;
		flashcalw_write_gp_fuse_byte(gp_fuse_byte, value);
		flashcalw_error_status |= error_status;
		break;
	}
}

/*! \brief K؂ȏƏݑőSĂ̔ėp˭ނݒ
 *
 * \param  value ƂđSĂ̔ėp˭ނ̒l
 *
 * \warning یޯĂLȏꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ʰ޳ɂĎۂ̔ėp˭ ޯĐ\c FLASH_GPF_NUM 
 *       ė^܂B64̑ޯĂʰ޳ɂ1ɌŒ艻܂B
 */
void flashcalw_set_all_gp_fuses(uint64_t value)
{
	uint32_t error_status;

	switch (value) {
	/**
	 * ߲قł̌x邽߂0xFFFFFFFFFFFFFFFFULL̑(uint64_t)-1
	 * gp
	 */
	case (uint64_t)-1:
		flashcalw_erase_all_gp_fuses(false);
		break;

	case (uint64_t)0:
		flashcalw_write_all_gp_fuses((uint64_t)0);
		break;

	default:
		flashcalw_erase_all_gp_fuses(false);
		error_status = flashcalw_error_status;
		flashcalw_write_all_gp_fuses(value);
		flashcalw_error_status |= error_status;
		break;
	}
}

//! @}

/*! \name ׯ ߰ނւ̱
 */
//! @{

/*! \brief ߰ފɏՕ
 *
 * ̎w߂߰ފɏՕ̑SޯĂ1ؾĂ܂B߰ފɏՕւ̏ݱ
 * ߰ފɏՕޯĂ10ɂύX邱Ƃł܂B
 *
 * \warning ߰ފɏՕ߰ޏ݌㎩IؾĂ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
void flashcalw_clear_page_buffer(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_CPB, -1);
}

/*! \brief Ō̐v߰ޓǂݍ݂܂͐v߰ޓǂݍݎgp߰ނ̂ǂ炩
 *         ̎w߂Kpꂽ߰ނꂽǂB
 *
 * \return Ō̐v߰ޓǂݍ݂܂͐v߰ޓǂݍݎgp߰ނ̂ǂ炩
 *         ̎w߂Kpꂽ߰ނꂽǂ
 */
bool flashcalw_is_page_erased(void)
{
	return ((HFLASHC->FLASHCALW_FSR & FLASHCALW_FSR_QPRR) != 0);
}

/*! \brief v߰ޓǂݍݎw߂߰ނɓKp
 *
 * \param  page_number ߰ޔԍ:
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ;
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 *
 * \return w肵߰ނꂽǂ
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
bool flashcalw_quick_page_read(int page_number)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_QPR, page_number);
	return flashcalw_is_page_erased();
}

/*! \brief ߰ޏ
 *
 * \param  page_number ߰ޔԍ:
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ;
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 * \param  check       邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 */
bool flashcalw_erase_page(int page_number, bool check)
{
	bool page_erased = true;

	flashcalw_issue_command(FLASHCALW_FCMD_CMD_EP, page_number);

	if (check) {
		uint32_t error_status = flashcalw_error_status;
		page_erased = flashcalw_quick_page_read(-1);
		flashcalw_error_status |= error_status;
	}

	return page_erased;
}

/*! \brief ׯz̑S߰ނ
 *
 * \param  check 邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \warning Œ1̗̈悪{A܂ް۰ޕی삪L̏ꍇɎ{ُ
 *          s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 */
bool flashcalw_erase_all_pages(bool check)
{
	bool all_pages_erased = true;
	uint32_t error_status = 0;
	uint32_t page_number = flashcalw_get_page_count();

	while (page_number) {
		all_pages_erased &= flashcalw_erase_page(--page_number, check);
		error_status |= flashcalw_error_status;
	}

	flashcalw_error_status = error_status;
	return all_pages_erased;
}

/*! \brief ߰ފɏՕ߰ނ
 *
 * \param  page_number ߰ޔԍ:
 *                     \arg \c 0 ` <tt>(flashcalw_get_page_count() - 1)</tt>:
 *                     ׯz߰ޔԍ;
 *                     \arg <tt>< 0</tt>: ݂߰ޔԍ
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \warning ߰ފɏՕ߰ޏ݌㎩IؾĂ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 */
void flashcalw_write_page(int page_number)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_WP, page_number);
}

/*! \brief FLASHCALWɐv߰ޓǂݍݎgp߰ގw߂𔭍s
 *
 * \return gp߰ނ΂Ă邩ǂ
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
bool flashcalw_quick_user_page_read(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_QPRUP, -1);
	return flashcalw_is_page_erased();
}

/*! \brief gp߰ޏ
 *
 * \param  check 邩ǂ: \c true ܂ \c false
 *
 * \return ǂA܂͏vȂꍇ͏\c true
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ޯĂ̐ݒ肾ł܂B
 */
bool flashcalw_erase_user_page(bool check)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_EUP, -1);
	return (check) ? flashcalw_quick_user_page_read() : true;
}

/*! \brief ߰ފɏՕgp߰ނ
 *
 * \warning ߰ފɏՕ߰ޏ݌㎩IؾĂ܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 *
 * \note ݑޯẲłAƁAޯĂ1ɐ
 *       肳邱ƂKvȏꍇAŏɏ삪sȂ΂Ȃ܂B
 */
void flashcalw_write_user_page(void)
{
	flashcalw_issue_command(FLASHCALW_FCMD_CMD_WUP, -1);
}

/*! \brief JԂ\a src \a dst ɂĎwׯ]
 *         \a nbytes ޲Ă𕡎
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst    ׯ]ւ̈ʒuwq(߲)
 * \param  src    ޲
 * \param  nbytes ݒ肷޲Đ
 * \param  erase  Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
volatile void *flashcalw_memset8(volatile void *dst, uint8_t src, size_t nbytes,
		bool erase)
{
	return flashcalw_memset16(dst, src | (uint16_t)src << 8, nbytes, erase);
}

/*! \brief JԂ\a src ޯ޴ި݋ꂩ\a dst ɂĎw
 *         ׯ]\a nbytes ޲Ă𕡎
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst    ׯ]ւ̈ʒuwq(߲)
 * \param  src    
 * \param  nbytes ݒ肷޲Đ
 * \param  erase  Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
volatile void *flashcalw_memset16(volatile void *dst, uint16_t src,
		size_t nbytes, bool erase)
{
	return flashcalw_memset32(dst, src | (uint32_t)src << 16, nbytes,
			erase);
}

/*! \brief JԂ\a src ޯ޴ި݋ꂩ\a dst ɂĎw
 *         ׯ]\a nbytes ޲Ă𕡎
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst    ׯ]ւ̈ʒuwq(߲)
 * \param  src    
 * \param  nbytes ݒ肷޲Đ
 * \param  erase  Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
volatile void *flashcalw_memset32(volatile void *dst, uint32_t src,
		size_t nbytes, bool erase)
{
	return flashcalw_memset64(dst, src | (uint64_t)src << 32, nbytes,
			erase);
}

/*! \brief JԂ\a src ޯ޴ި݋{ꂩ\a dst ɂĎw
 *         ׯ]\a nbytes ޲Ă𕡎
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst    ׯ]ւ̈ʒuwq(߲)
 * \param  src    {
 * \param  nbytes ݒ肷޲Đ
 * \param  erase  Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
volatile void *flashcalw_memset64(volatile void *dst, uint64_t src,
		size_t nbytes, bool erase)
{
	/* ڽŗp\Ȃ̐߂ɏW񂳂ꂽ߲gp */
	UnionCVPtr flash_array_end;
	UnionVPtr dest;
	Union64 source = {0};
	StructCVPtr dest_end;
	UnionCVPtr flash_page_source_end;
	bool incomplete_flash_page_end;
	Union64 flash_dword;
	UnionVPtr tmp;
	uint32_t error_status = 0;
	uint32_t i;

	/* Đݒ */
	flash_array_end.u8ptr = ((uint8_t *)FLASH_ADDR)
			+ flashcalw_get_flash_size();
	dest.u8ptr = dst;
	for (i = (Get_align((uint32_t)dest.u8ptr, sizeof(uint64_t)) - 1)
			& (sizeof(uint64_t) - 1); src;
			i = (i - 1) & (sizeof(uint64_t) - 1)) {
		source.u8[i] = src;
		src >>= 8;
	}
	dest_end.u8ptr = dest.u8ptr + nbytes;

	/* ]悪ׯOȂAΎׯ ߰ނ֍sB */
	if (dest.u8ptr < (uint8_t *)FLASH_ADDR) {
		dest.u8ptr = (uint8_t *)FLASH_ADDR;
	} else if (flash_array_end.u8ptr <= dest.u8ptr &&
			dest.u8ptr < (uint8_t *)FLASH_USER_PAGE_ADDR) {
		dest.u8ptr = (uint8_t *)FLASH_USER_PAGE_ADDR;
	}

	/* ]̍ŌオׯOȂA΂Oׯ ߰ނ̍ŌɈړ */
	if (dest_end.u8ptr >
			(((uint8_t *)FLASH_USER_PAGE_ADDR) + FLASH_PAGE_SIZE)) {
		dest_end.u8ptr = (uint8_t *)FLASH_USER_PAGE_ADDR
				+ FLASH_PAGE_SIZE;
	} else if ((uint8_t *)FLASH_USER_PAGE_ADDR >= dest_end.u8ptr &&
			dest_end.u8ptr > flash_array_end.u8ptr) {
		dest_end.u8ptr = flash_array_end.u8ptr;
	}

	/* ̖{̋EŊe]߲̍Ō𐮗 */
	dest_end.u16ptr = (uint16_t *)Align_down((uint32_t)dest_end.u8ptr,
			sizeof(uint16_t));
	dest_end.u32ptr = (uint32_t *)Align_down((uint32_t)dest_end.u16ptr,
			sizeof(uint32_t));
	dest_end.u64ptr = (uint64_t *)Align_down((uint32_t)dest_end.u32ptr,
			sizeof(uint64_t));

	/* ]̍ŌオBȂԂɁ` */
	while (dest.u8ptr < dest_end.u8ptr) {
		/* ׯ ߰ޏ݂ް̂߂߰ފɏՕ */
		flashcalw_clear_page_buffer();
		error_status |= flashcalw_error_status;

		/* ް݂ׯ ߰ނŏI邩𔻒 */
		flash_page_source_end.u64ptr
			= (uint64_t *)Min((uint32_t)dest_end.u64ptr,
				Align_down((uint32_t)dest.u8ptr,
				(uint32_t)FLASH_PAGE_SIZE) + FLASH_PAGE_SIZE);

		/* ݂̓]߰ނsȍŌ𔻒 */
		incomplete_flash_page_end
			= (Align_down((uint32_t)dest.u8ptr,
				(uint32_t)FLASH_PAGE_SIZE)
				>= Align_down((uint32_t)dest_end.u8ptr,
				(uint32_t)FLASH_PAGE_SIZE));

		/* 񂵂ĂȂ𘨗̂ׯ{ɏՕgp */
		flash_dword.u64 = source.u64;

		/* ]悪݂ׯ ߰ނ̐擪wꂢȂꍇ */
		if (!Test_align((uint32_t)dest.u8ptr, FLASH_PAGE_SIZE)) {
			/* ݂ׯ ߰ ް߰ފɏՕ̐擪𖞂܂B͊
			 * ɏꂽׯ ߰ނ̏ꂽɐɏƂł
			 * ߂ɁAႦ߰ޏvȂꍇłʰ޳ɂĕKv
			 * ܂B */
			for (tmp.u8ptr = (uint8_t *)Align_down((uint32_t)dest.u8ptr,
							(uint32_t)FLASH_PAGE_SIZE);
					tmp.u64ptr < (uint64_t *)Align_down(
					(uint32_t)dest.u8ptr,
					sizeof(uint64_t));
					tmp.u64ptr++) {
				*tmp.u32ptr = *tmp.u32ptr;
				*(tmp.u32ptr + 1) = *(tmp.u32ptr + 1);
			}

			/* ]悪64ޯĐłȂ΁A */
			if (!Test_align((uint32_t)dest.u8ptr,
					sizeof(uint64_t))) {
				/* ݂ׯ ߰ ްׯ{ɏՕ̐擪𖞂܂B
				 * ͊ɏꂽׯ ߰ނ̏ꂽɐɏ
				 * Ƃł邽߂ɁAႦ߰ޏvȂꍇłʰ
				 * ɂĕKvƂ܂B */
				for (i = 0; i < Get_align((uint32_t)dest.u8ptr,
						sizeof(uint64_t)); i++) {
					flash_dword.u8[i] = *tmp.u8ptr++;
				}

				/* 64ޯċEœ]߲𐮗 */
				dest.u64ptr = (uint64_t *)Align_down((uint32_t)dest.u8ptr,
						sizeof(uint64_t));

				/* ݂̔{ꂪŌ̂̂łȂ΁A */
				if (dest.u64ptr < dest_end.u64ptr) {
					/* ߰ޏݑ̕sްp΍ */
					*(volatile uint64_t*)((uint32_t)dest.u64ptr) = (uint64_t)-1;
					/* ׯ{ɏՕ߰ފɏՕɏĂ */
					*dest.u64ptr++ = flash_dword.u64;
					flash_dword.u64 = source.u64;
				}
			}
		}

		/* ް64ޯĐ߰ފɏՕɏ */
		for (i = flash_page_source_end.u64ptr - dest.u64ptr; i; i--) {
			/* ߰ޏݑ̕sްp΍ */
			*(volatile uint64_t*)((uint32_t)dest.u64ptr)
					= (uint64_t)-1;
			*dest.u64ptr++ = source.u64;
		}

		/* ݂̓]߰ނsȍŌȂA */
		if (incomplete_flash_page_end) {
			/* ͊ɏꂽׯ ߰ނ̏ꂽɐɏ
			 * ł邽߂ɁAႦ߰ޏvȂꍇłʰ޳ɂ
			 * ĕKvƂ܂B */
			{
				tmp.u8ptr = (volatile uint8_t *)dest_end.u8ptr;

				/* ]̍Ōオ64ޯĐ񂳂Ȃꍇ */
				if (!Test_align((uint32_t)dest_end.u8ptr,
						sizeof(uint64_t))) {
					/* ׯ{ɏՕ̍Ō݂ׯ ߰ ްŖB */
					for (i = Get_align(
							(uint32_t)dest_end.u8ptr,
							sizeof(uint64_t));
							i < sizeof(uint64_t);
							i++) {
						flash_dword.u8[i] = *tmp.u8ptr++;
					}

					/* ߰ޏݑ̕sްp΍ */
					*(volatile uint64_t*)((uint32_t)dest.u64ptr) = (uint64_t)-1;
					/* ׯ{ɏՕ߰ފɏՕɏ */
					*dest.u64ptr++ = flash_dword.u64;
				}

				/* ߰ފɏՕ̍Ō݂ׯ ߰ ްŖB */
				for (; !Test_align((uint32_t)tmp.u64ptr,
						FLASH_PAGE_SIZE); tmp.u64ptr++){
					*tmp.u32ptr = *tmp.u32ptr;
					*(tmp.u32ptr + 1) = *(tmp.u32ptr + 1);
				}
			}
		}

		/* ݂ׯ ߰ނׯzȂA */
		if (dest.u8ptr <= (uint8_t *)FLASH_USER_PAGE_ADDR) {
			/* vꂽȂ猻݂߰ނ߰ފɏՕ炻 */
			if (erase) {
				flashcalw_erase_page(-1, false);
				error_status |= flashcalw_error_status;
			}

			flashcalw_write_page(-1);
			error_status |= flashcalw_error_status;

			/* ׯz̍ŌɓBȂAgp߰ނ֍sB */
			if (dest.u8ptr >= flash_array_end.u8ptr) {
				dest.u8ptr = (uint8_t *)FLASH_USER_PAGE_ADDR;
			}
		} else {
			/* vꂽȂgp߰ނ߰ފɏՕ炻 */
			if (erase) {
				flashcalw_erase_user_page(false);
				error_status |= flashcalw_error_status;
			}

			flashcalw_write_user_page();
			error_status |= flashcalw_error_status;
		}
	}

	/* FLASHCُԂXV */
	flashcalw_error_status = error_status;

	/* Wmemset֐Ɠlɏ]߲ԂB */
	return dst;
}

/*! \brief \a src ɂĎw]\a dst ɂĎwׯ]
 *         \a nbytes ޲Ă𕡎
 *
 * ׯzłȂ܂͎gp߰ނ̓]̈Assert()ɂĎ󂯎~
 * ܂B
 *
 * SĂ߲Ƒ傫񂪎x܂B
 *
 * \param  dst    ׯ]ւ̈ʒuwq(߲)
 * \param  src    ]ްւ̈ʒuwq(߲)
 * \param  nbytes ݒ肷޲Đ
 * \param  erase  Oɏ邩ǂ: \c true ܂ \c false
 *
 * \return \a dst ̒l
 *
 * \warning d̈ԂŕʂsꍇA͖̓łB
 *
 * \warning ̊֐͓]悪ꂽꂾŐꍇɂ\c false ɐݒ肳
 *          ꂽ\a erase ŌĂ΂邩ꂸAÅ֐͈ȑOɏꂽ
 *          1ޯĂɂ̂Ɏgp邱Ƃ͂ł܂BႦ΁A
 *          \c 0x00000001Ǎ\c 0xFFFFFFFE ꂽꍇAׯ̌ʒl
 *          \c 0x00000000 ƈႤ܂B
 *
 * \warning w߂{ꂽ̈܂۰ޕیɑ߰ނɎw߂Kp
 *          ꍇɎ{ُ킪s܂B
 *
 * \note \ref flashcalw_is_lock_error \ref flashcalw_is_programming_error
 *       ĕԂFLASHCALWُԂ͍XV܂B
 */
volatile void *flashcalw_memcpy(volatile void *dst, const void *src,
		size_t nbytes, bool erase)
{
	uint16_t page_pos;
	Union64 flash_dword;
	uint8_t i;
	bool b_user_page;
	uint32_t error_status = 0;
	volatile uint8_t *flash_add;
	volatile uint8_t *dest_add = (uint8_t *)dst;
	const uint8_t *src_buf = (const uint8_t *)src;

	/* ʗ̈ׯz܂͎gp߰ޓłȂ΂Ȃ܂B */
	Assert((((uint8_t *)dst >= (uint8_t *)FLASH_ADDR) &&
			(((uint8_t *)dst + nbytes)
			<= (((uint8_t *)FLASH_ADDR)
			+ flashcalw_get_flash_size()))) ||
			(((uint8_t *)dst >= (uint8_t *)FLASH_USER_PAGE_ADDR) &&
			(((uint8_t *)dst + nbytes)
			<= (((uint8_t *)FLASH_USER_PAGE_ADDR)
			+ FLASH_PAGE_SIZE))));

	b_user_page = (volatile uint8_t *)dst
			>= (uint8_t *)FLASH_USER_PAGE_ADDR;

	flash_add = (uint8_t *)((uint32_t)dest_add
			- ((uint32_t)dest_add % FLASH_PAGE_SIZE));

	while (nbytes) {
		/* ׯ ߰ޏݗpް̂߂߰ފɏՕ */
		flashcalw_clear_page_buffer();
		error_status |= flashcalw_error_status;

		/* ߰ޓJԂ */
		for (page_pos = 0; page_pos < FLASH_PAGE_SIZE;
				page_pos += sizeof(uint64_t)) {
			/* ׯ{ɏՕǂݍ */
			flash_dword.u64 = *(volatile uint64_t *)((uint32_t)flash_add);

			/* KvȂΔ{XV */
			for (i = 0; i < sizeof(uint64_t); i++) {
				if (nbytes && (flash_add == dest_add)) {
					/* ]ް߰ނXV */
					flash_dword.u8[i] = *src_buf++;
					dest_add++;
					nbytes--;
				}

				flash_add++;
			}

			/* ߰ޏݑ̕sްp΍ */
			*(volatile uint64_t*)((uint32_t)flash_add - sizeof(uint64_t))
					= (uint64_t)-1;
			
			/* ׯ{ɏՕ߰ފɏՕ֏ */
			*(volatile uint64_t *)((uint32_t)flash_add - sizeof(uint64_t))
					= flash_dword.u64;
		}

		/* vꂽꍇɌ݂߰ނ߰ފɏՕ炻 */
		if (erase) {
			(b_user_page) ? flashcalw_erase_user_page(false)
			: flashcalw_erase_page(-1, false);
			error_status |= flashcalw_error_status;
		}

		/* ߰ޏ */
		(b_user_page) ? flashcalw_write_user_page()
		: flashcalw_write_page(-1);
		error_status |= flashcalw_error_status;
	}
	/* FLASHCُԂXV */
	flashcalw_error_status = error_status;

	/* Wmemcpy֐Ɠlɏ]߲ԂB */
	return dst;
}

/** @} */

/*! \name PicoCache̪
 */
//! @{

/**
 * \brief PicoCache
 */
void flashcalw_picocache_enable(void)
{
	sysclk_enable_peripheral_clock(HCACHE);
	HCACHE->HCACHE_CTRL = HCACHE_CTRL_CEN_YES;

	while (!(flashcalw_picocache_get_status() & HCACHE_SR_CSTS_EN)) {
	}
}

/**
 * \brief PicoCache֎~
 */
void flashcalw_picocache_disable(void)
{
	HCACHE->HCACHE_MAINT0 = HCACHE_MAINT0_INVALL_YES;
	HCACHE->HCACHE_CTRL = HCACHE_CTRL_CEN_NO;

	while (flashcalw_picocache_get_status() != HCACHE_SR_CSTS_DIS) {
	}

	sysclk_disable_peripheral_clock(HCACHE);
}

/**
 * \brief PicoCacheԎ擾
 *
 * \return PicoCaheȂ1AȂ΋֎~
 */
uint32_t flashcalw_picocache_get_status(void)
{
	return HCACHE->HCACHE_SR;
}

/**
 * \brief SĂPicoCache𖳌
 */
void flashcalw_picocache_invalid_all(void)
{
	HCACHE->HCACHE_MAINT0 = HCACHE_MAINT0_INVALL_YES;
}

/**
 * \brief PicoCache𖳌
 *
 * \param  index 
 */
void flashcalw_picocache_invalid_line(uint32_t index)
{
	/* ֎~ */
	HCACHE->HCACHE_CTRL = HCACHE_CTRL_CEN_NO;

	/* ֎~ҋ@ */
	while (flashcalw_picocache_get_status() != HCACHE_SR_CSTS_DIS) {
	}

	/* 𖳌 */
	HCACHE->HCACHE_MAINT1 = index;

	/* Ăы */
	HCACHE->HCACHE_CTRL = HCACHE_CTRL_CEN_YES;
}

/**
 * \brief PicoCacheĎݒ
 *
 * \param  mode PicoCache`ԁA0Aߓ1Aް2
 *hit.
 */
void flashcalw_picocache_set_monitor_mode(uint32_t mode)
{
	HCACHE->HCACHE_MCFG = mode;
}

/**
 * \brief PicoCacheĎ
 */
void flashcalw_picocache_enable_monitor(void)
{
	HCACHE->HCACHE_MEN = HCACHE_MEN_MENABLE_EN;
}

/**
 * \brief PicoCacheĎ֎~
 */
void flashcalw_picocache_disable_monitor(void)
{
	HCACHE->HCACHE_MEN = HCACHE_MEN_MENABLE_DIS;
}

/**
 * \brief PicoCacheĎؾ
 */
void flashcalw_picocache_reset_monitor( void )
{
	HCACHE->HCACHE_MCTRL = HCACHE_MCTRL_SWRST_YES;
}

/**
 * \brief PicoCacheĎv擾
 *
 * \return Ďvl
 */
uint32_t flashcalw_picocache_get_monitor_cnt( void )
{
	return HCACHE->HCACHE_MSR;
}

/**
 * \brief PicoCacheŔԍ擾
 *
 * \return PicoCacheŔԍ
 */
uint32_t flashcalw_picocache_get_version( void )
{
	return HCACHE->HCACHE_VERSION;
}

/** @} */

/**
 * \}
 */

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
