/**
 * \file
 *
 * \brief GPIOײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "gpio.h"

/**
 * \ingroup group_sam_drivers_gpio
 *
 * @{
 */

/**
 * `邱Ƃłő劄荞݌B̒萔͑₷Ƃł܂A
 * ̒l͑SĂ̊ۼުĂɓK\ȍŏ̂̂łB
 */
#ifndef GPIO_MAX_INTERRUPT_SOURCES
#define GPIO_MAX_INTERRUPT_SOURCES		6
#endif

/** GPIO荞ݐ8̌QɌQ܂B */
#define GPIO_INT_GROUP_MASK				0xFFu

/**
 * GPIO݊荞݌p\
 */
struct gpio_interrupt_source {
	uint32_t pin;					/**< ݔԍ */
	gpio_pin_callback_t callback;	/**< 荞݌Ăі߂֐ */
};

/* 荞݌̍Ō */
static struct gpio_interrupt_source gpio_int_sources[GPIO_MAX_INTERRUPT_SOURCES];

/* ݒ`ꂽ荞݌ */
static uint32_t gpio_nb_sources = 0;

/**
 * \brief ^ꂽGPIOݗpĂі߂ݒ
 *
 * \param  pin The   ݔԍ
 * \param  callback  Ăі߂֐ʒuwq
 * \param  irq_level 荞
 *
 * \retval \c true  ݒ萬
 * \retval \c false sҰ܂͍ő吔z銄荞݌`ꂽB
 */
bool gpio_set_pin_callback(ioport_pin_t pin, gpio_pin_callback_t callback,
		uint8_t irq_level)
{
	int8_t i;
	int8_t irq_line;

	if (gpio_nb_sources >= GPIO_MAX_INTERRUPT_SOURCES) {
		return false;
	}

	/*
	 * ^ꂽ݂ɑ΂IRQ擾
	 *
	 * \note 荞ݐ8̌QɌQAeGPIO߰Ăɑ΂4̈قȂ銄荞
	 *       ݏt邱Ƃł܂B
	 */
	for (i = 0; i < 4; i++) {
		if (ioport_pin_to_mask(pin) & (GPIO_INT_GROUP_MASK << (i * 8))) {
			break;
		}
	}
	irq_line = GPIO_0_IRQn + ioport_pin_to_port_id(pin) * 4 + i;

	gpio_int_sources[gpio_nb_sources].pin = pin;
	gpio_int_sources[gpio_nb_sources].callback = callback;
	NVIC_ClearPendingIRQ((IRQn_Type)irq_line);
	NVIC_SetPriority((IRQn_Type)irq_line, irq_level);
	NVIC_EnableIRQ((IRQn_Type)irq_line);

	gpio_nb_sources++;

	return true;
}

/**
 * GPIO
 */
static void gpio_common_handler(uint32_t port_id, uint32_t port_mask)
{
	GpioPort *gpio_port = &(GPIO->GPIO_PORT[port_id]);
	uint32_t i;
	uint32_t int_flags;
	ioport_pin_t pin;

	int_flags = gpio_port->GPIO_IFR;
	gpio_port->GPIO_IFRC = (int_flags & port_mask);

	for (i = 0; i < gpio_nb_sources; i++) {
		pin = gpio_int_sources[i].pin;
		if ((ioport_pin_to_port_id(pin) == port_id) &&
				(ioport_pin_to_mask(pin) & int_flags)) {
			if (gpio_int_sources[i].callback != NULL) {
				gpio_int_sources[i].callback();
			} else {
				Assert(false);	/* \ʊ荞݂󂯎 */
			}
		}
	}
}

/**
 * GPIO handler 0 (PA 0..7)
 */
void GPIO_0_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOA, GPIO_INT_GROUP_MASK);
}

/**
 * GPIO handler 1 (PA 8..15)
 */
void GPIO_1_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOA, (GPIO_INT_GROUP_MASK << 8));
}

/**
 * GPIO handler 2 (PA 16..23)
 */
void GPIO_2_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOA, (GPIO_INT_GROUP_MASK << 16));
}

/**
 * GPIO handler 3 (PA 24..31)
 */
void GPIO_3_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOA, (GPIO_INT_GROUP_MASK << 23));
}

/**
 * GPIO handler 4 (PB 0..7)
 */
void GPIO_4_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOB, GPIO_INT_GROUP_MASK);
}

/**
 * GPIO handler 5 (PB 8..15)
 */
void GPIO_5_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOB, (GPIO_INT_GROUP_MASK << 8));
}

/**
 * GPIO handler 6 (PB 16..23)
 */
void GPIO_6_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOB, (GPIO_INT_GROUP_MASK << 16));
}

/**
 * GPIO handler 7 (PB 24..31)
 */
void GPIO_7_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOB, (GPIO_INT_GROUP_MASK << 24));
}

/**
 * GPIO handler 8 (PC 0..7)
 */
void GPIO_8_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOC, GPIO_INT_GROUP_MASK);
}

/**
 * GPIO handler 9 (PC 8..15)
 */
void GPIO_9_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOC, (GPIO_INT_GROUP_MASK << 8));
}

/**
 * GPIO handler 10 (PC 16..23)
 */
void GPIO_10_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOC, (GPIO_INT_GROUP_MASK << 16));
}

/**
 * GPIO handler 11 (PC 24..31)
 */
void GPIO_11_Handler(void)
{
	gpio_common_handler(IOPORT_GPIOC, (GPIO_INT_GROUP_MASK << 24));
}

/** @} */
