/**
 * \file
 *
 * \brief SAM4Lpޯ (WDT)ײ
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "wdt_sam4l.h"
#include "sysclk.h"

/**
 * \ingroup group_sam_drivers_wdt_sam4l
 * @{
 */

#define WDT_FIRST_KEY		0x55ul	/**< ޯސڼ޽1݌ */
#define WDT_SECOND_KEY		0xAAul	/**< ޯސڼ޽2݌ */

/**
 * \brief ޯ όɂĳޯ ϐڼ޽\a ctrl lɐݒ
 *
 * \param  ctrl ޯ ϐڼ޽ɐݒ肷l
 */
static void wdt_set_ctrl(uint32_t ctrl)
{
	volatile uint32_t dly;

	/* pxvZA44.1.2. WDTQB */
	if ((WDT->WDT_CTRL & WDT_CTRL_CSSEL) == WDT_CLK_SRC_RCSYS) {
		dly = div_ceil(sysclk_get_cpu_hz() * 2, OSC_RCSYS_NOMINAL_HZ);
	} else {	/* WDT_CLK_SRC_32K */
		dly = div_ceil(sysclk_get_cpu_hz() * 2, OSC_RC32K_NOMINAL_HZ);
	}
	dly >>= 3;	/* 1whileJԂɑ΂ā`8 */
	while(dly--);
	WDT->WDT_CTRL = ctrl | WDT_CTRL_KEY(WDT_FIRST_KEY);
	WDT->WDT_CTRL = ctrl | WDT_CTRL_KEY(WDT_SECOND_KEY);
}

/**
 * \brief ޯ ό`Ԑݒ\̂ɏ
 *
 * ^ꂽޯ ό`Ԑݒ\̂m̊l̑gɏB̊֐
 * gp҉pɂĕύXOɂ̌`Ԑݒ\̂̑SĂ̐V̂Ō
 * ΂ׂłB
 *
 * `Ԑݒ͎̒ʂłB:
 * - ۯƂRCSYSUI
 * - XȂ()`Ԑݒ߂Ɏ{Ȃ
 * - 131072ۯ̐ԊԂ̳ޯޒPʕۯ(1s)
 * - ޯތvłؾĂ邱Ƃł悤ɑԂȂ
 *
 *  \param  cfg lɏ`Ԑݒ\
 */
void wdt_get_config_defaults(struct wdt_config *const cfg)
{
	/* 팟 */
	Assert(cfg);

	/* `Ԑݒl */
	cfg->clk_src = WDT_CLK_SRC_RCSYS;
	cfg->wdt_mode = WDT_MODE_BASIC;
	cfg->timeout_period = WDT_PERIOD_131072_CLK;
	cfg->window_period = WDT_PERIOD_NONE;
	cfg->disable_flash_cali = true;
	cfg->disable_wdt_after_reset = true;
	cfg->always_on = false;
}

/**
 * \brief WDTPʕ
 *
 * \param  dev_inst ޲\̈ʒuwq
 * \param  wdt      WDT̂̊ڽ
 * \param  cfg      WDT`Ԑݒւ̈ʒuwq
 *
 * \retval true  ꍇ
 * \retval false s̏ꍇ
 */
bool wdt_init(
		struct wdt_dev_inst *const dev_inst,
		Wdt *const wdt,
		struct wdt_config *const cfg)
{
	/* 팟 */
	Assert(dev_inst);
	Assert(wdt);
	Assert(cfg);

	dev_inst->hw_dev = wdt;
	dev_inst->wdt_cfg = cfg;

	/* WDTpAPBۯ */
	sysclk_enable_peripheral_clock(wdt);

	/* SFVޯĒ:SFVޯĂݒȂAڼ޽͎{Ă܂B */
	if (wdt->WDT_CTRL & WDT_CTRL_SFV) {
		return false;
	}

	/* WDT֎~ */
	if (wdt->WDT_CTRL & WDT_CTRL_EN) {
		wdt_set_ctrl(wdt->WDT_CTRL & ~WDT_CTRL_EN);
		while (wdt->WDT_CTRL & WDT_CTRL_EN) {
		}
	}
	/* WDTۯ֎~ */
	if (wdt->WDT_CTRL & WDT_CTRL_CEN) {
		wdt_set_ctrl(wdt->WDT_CTRL & ~WDT_CTRL_CEN);
		while (wdt->WDT_CTRL & WDT_CTRL_CEN) {
		}
	}

	/* V`ԐݒWDT */
	wdt_set_ctrl(cfg->clk_src |
			cfg->wdt_mode |
			WDT_CTRL_PSEL(cfg->timeout_period) |
			WDT_CTRL_TBAN(cfg->window_period) |
			(cfg->disable_flash_cali ? WDT_CTRL_FCD : 0) |
			(cfg->disable_wdt_after_reset ? WDT_CTRL_DAR : 0)
	);
	wdt_set_ctrl(wdt->WDT_CTRL | WDT_CTRL_CEN);
	while (!(wdt->WDT_CTRL & WDT_CTRL_CEN)) {
	}

	/* WDTpAPBۯ֎~ */
	sysclk_disable_peripheral_clock(wdt);

	return true;
}

/**
 * \brief WDTPʕ
 *
 * \param  dev_inst ޲\̈ʒuwq
 */
void wdt_enable(struct wdt_dev_inst *const dev_inst)
{
	Wdt *wdt = dev_inst->hw_dev;
	struct wdt_config *cfg = dev_inst->wdt_cfg;

	/* WDTpAPBۯ */
	sysclk_enable_peripheral_clock(wdt);

	/* WDTAKvȂWDTڼ޽{ */
	wdt_set_ctrl(wdt->WDT_CTRL | WDT_CTRL_EN |
		(cfg->always_on ? WDT_CTRL_SFV : 0));
	while ((WDT->WDT_CTRL & WDT_CTRL_EN) != WDT_CTRL_EN) {
	}
}

/**
 * \brief WDTPʕ֎~
 *
 * \param  dev_inst ޲\̈ʒuwq
 */
void wdt_disable(struct wdt_dev_inst *const dev_inst)
{
	Wdt *wdt = dev_inst->hw_dev;

	/* WDT֎~ */
	wdt_set_ctrl(wdt->WDT_CTRL & ~WDT_CTRL_EN);
	while (wdt->WDT_CTRL & WDT_CTRL_EN) {
	}

	/* WDTpAPBۯ֎~ */
	sysclk_disable_peripheral_clock(wdt);
}

/**
 * \brief ޯ ύĎn
 *
 * \param  dev_inst ޲\̈ʒuwq
 */
void wdt_clear(struct wdt_dev_inst *const dev_inst)
{
	Wdt *wdt = dev_inst->hw_dev;

	while ((wdt->WDT_SR & WDT_SR_CLEARED) != WDT_SR_CLEARED);
	wdt->WDT_CLR = WDT_CLR_KEY(WDT_FIRST_KEY) | WDT_CLR_WDTCLR;
	wdt->WDT_CLR = WDT_CLR_KEY(WDT_SECOND_KEY) | WDT_CLR_WDTCLR;
}

/**
 * \brief \Ȍ蒼WDTؾĂ𐶐邱ƂɂMCUؾ
 *
 * \note ̊֐SFVޯĂɐݒ肳ꂽꍇɓ܂(WDT`Ԑݒ肪Ɏ{
 *       Ă܂)B
 *
 * \return \b false WDTؾĂMCUؾĂłȂAȂMCUؾ
 */
bool wdt_reset_mcu(void)
{
	struct wdt_dev_inst wdt_inst;
	struct wdt_config   wdt_cfg;

	/*
	 * ŏ(ޯ ؾĂ𓾂ő̕@)ųޯދ
	 */
	wdt_get_config_defaults(&wdt_cfg);
	wdt_cfg.timeout_period = WDT_PERIOD_MIN_CLK;
	wdt_cfg.disable_wdt_after_reset = true;
	if (!wdt_init(&wdt_inst, WDT, &wdt_cfg)) {
		return false;
	}
	Disable_global_interrupt();
	wdt_enable(&wdt_inst);

	while (1) {
		/* ޯ ؾđҋ@
	}
}

/**
 * @}
 */
