/**************************************************************************//**
 * @file		core_cm4.h
 * @brief		CMSIS Cortex-M4jӋ@\wͯ ̧
 * @version		V3.00
 * @date		2012N23
 *
 * @note
 * 쌠 (C) 2009-2012 ARM Limited. s
 *
 * @par
 * ARM Limited (ARM)Cortex-M۾ɊÂϲ ۰ׂŎgp邽߂ɂ̿ĳ
 * Ă܂B̧ق͂̂悤ARMɊÂ۾xJ°ٓ
 * Rɕz邱Ƃł܂B
 *
 * @par
 * ̿ĳ"󂻂̂܂"Œ񋟂܂Bۏ؁AI܂َ͖I܂͖@
 * Iǂ܂݂܂AɐꂸAړÎ߂̎sꐫƓK
 * ÖٓIȕۏ؂͂̿ĳɓKp܂BARM͉ꂩ̔@Ȃ闝RɂĂ
 * ̂悤ȏ󋵂łʓIAtIAhIQ̐ӔC𕉂܂B
 *
 ******************************************************************************/
#if defined ( __ICCARM__ )
 #pragma system_include		/* MISRAp ݸٰ ̧قƂĈ܂B */
#endif

#ifdef __cplusplus
 extern "C" {
#endif

#ifndef __CORE_CM4_H_GENERIC
#define __CORE_CM4_H_GENERIC

/** \page CMSIS_MISRA_Exceptions  MISRA-C:2004KO
  CMSIS͈ȉMISRA-C:2004KɈᔽ܂B

   \li KvƂK8.5, ͯ ̵̧ٓ޼ު/֐`<br>
     ͯ ̧ٓ̊֐`'inlining'̂Ɏgp܂B

   \li KvƂK18.4, p̌^̐錾܂͋p̌^̵޼ު: '{...}'.<br>
     p̂͊jڼ޽̗Lȕ\̂߂Ɏgp܂B

   \li K19.7, ֐lϸے`<br>
     ֐lϸۂ͂ƌIȺނ̂Ɏgp܂B
 */


/*******************************************************************************
 *                 CMSIS`
 ******************************************************************************/
/** \ingroup Cortex_M4
  @{
 */

/*  CMSIS CM4 ` */
#define __CM4_CMSIS_VERSION_MAIN	(0x03)									/*!< [31:16] CMSIS HAL */
#define __CM4_CMSIS_VERSION_SUB		(0x00)									/*!< [15:0]  CMSIS HAL */
#define __CM4_CMSIS_VERSION			((__CM4_CMSIS_VERSION_MAIN << 16) | \
									  __CM4_CMSIS_VERSION_SUB          )	/*!< CMSIS HALŔԍ */

#define __CORTEX_M					(0x04)									/*!< Cortex-Mj */


#if   defined ( __CC_ARM )
  #define __ASM				__asm				/*!< ARM߲חpasmܰ */
  #define __INLINE			__inline			/*!< ARM߲חpinlineܰ */
  #define __STATIC_INLINE	static __inline

#elif defined ( __ICCARM__ )
  #define __ASM				__asm				/*!< IAR߲חpasmܰ */
  #define __INLINE			inline				/*!< IAR߲חpinlineܰށBœKłp\! */
  #define __STATIC_INLINE	static inline

#elif defined ( __TMS470__ )
  #define __ASM				__asm				/*!< TI CCS߲חpasmܰ */
  #define __STATIC_INLINE	static inline

#elif defined ( __GNUC__ )
  #define __ASM				__asm				/*!< GNU߲חpasmܰ */
  #define __INLINE			inline				/*!< GNU߲חpinlineܰ */
  #define __STATIC_INLINE	static inline

#elif defined ( __TASKING__ )
  #define __ASM				__asm				/*!< TASKING߲חpasmܰ */
  #define __INLINE			inline				/*!< TASKING߲חpinlineܰ */
  #define __STATIC_INLINE	static inline

#endif

/** __FPU_USEDFPUgp邩ۂ܂B̂߁AFPULڼ޽Ɗ֐̎gp̂ɐ旧__FPU_PRESENTׂȂ΂Ȃ܂B
*/
#if defined ( __CC_ARM )
  #if defined __TARGET_FPU_VFP
    #if (__FPU_PRESENT == 1)
      #define __FPU_USED       1
    #else
      #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
      #define __FPU_USED       0
    #endif
  #else
    #define __FPU_USED         0
  #endif

#elif defined ( __ICCARM__ )
  #if defined __ARMVFP__
    #if (__FPU_PRESENT == 1)
      #define __FPU_USED       1
    #else
      #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
      #define __FPU_USED       0
    #endif
  #else
    #define __FPU_USED         0
  #endif

#elif defined ( __TMS470__ )
  #if defined __TI_VFP_SUPPORT__
    #if (__FPU_PRESENT == 1)
      #define __FPU_USED       1
    #else
      #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
      #define __FPU_USED       0
    #endif
  #else
    #define __FPU_USED         0
  #endif

#elif defined ( __GNUC__ )
  #if defined (__VFP_FP__) && !defined(__SOFTFP__)
    #if (__FPU_PRESENT == 1)
      #define __FPU_USED       1
    #else
      #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
      #define __FPU_USED       0
    #endif
  #else
    #define __FPU_USED         0
  #endif

#elif defined ( __TASKING__ )
    /* add preprocessor checks to define __FPU_USED */
    #define __FPU_USED         0
#endif

#include <stdint.h>			/* W^` */
#include <core_cmInstr.h>	/* j߱ */
#include <core_cmFunc.h>	/* j@\ */
#include <core_cm4_simd.h>	/* ߲דLSIMD */

#endif /* __CORE_CM4_H_GENERIC */

#ifndef __CMSIS_GENERIC

#ifndef __CORE_CM4_H_DEPENDANT
#define __CORE_CM4_H_DEPENDANT

/* ޲`Ɗgp */
#if defined __CHECK_DEVICE_DEFINES
  #ifndef __CM4_REV
    #define __CM4_REV               0x0000
    #warning "__CM4_REV not defined in device header file; using default!"
  #endif

  #ifndef __FPU_PRESENT
    #define __FPU_PRESENT             0
    #warning "__FPU_PRESENT not defined in device header file; using default!"
  #endif

  #ifndef __MPU_PRESENT
    #define __MPU_PRESENT             0
    #warning "__MPU_PRESENT not defined in device header file; using default!"
  #endif

  #ifndef __NVIC_PRIO_BITS
    #define __NVIC_PRIO_BITS          4
    #warning "__NVIC_PRIO_BITS not defined in device header file; using default!"
  #endif

  #ifndef __Vendor_SysTickConfig
    #define __Vendor_SysTickConfig    0
    #warning "__Vendor_SysTickConfig not defined in device header file; using default!"
  #endif
#endif

/* I/O`(Ӌ@\ڼ޽ɑ΂鱸) */
/**
    \defgroup CMSIS_glob_defs CMSISS`
 
    <strong>I/O^Cq</strong>͈ȉɎgp܂B
    \li Ӌ@\ϐւ̱w
    \li Ӌ@\ڼ޽ ޯޏ̎
*/
#ifdef __cplusplus
  #define 	__I     volatile		/*!< 'ǂݍݐp'` */
#else
  #define 	__I     volatile const	/*!< 'ǂݍݐp'` */
#endif
#define     __O     volatile		/*!< 'ݐp'` */
#define     __IO    volatile		/*!< 'ǂݏp'` */

/*@} Cortex_M4QI */


/*******************************************************************************
 *                 ڼ޽ۉ
  jڼ޽͈ȉ܂݂܂B:
  - jڼ޽
  - jNVICڼ޽
  - jSCBڼ޽
  - jSysTickڼ޽
  - jDebugڼ޽
  - jMPUڼ޽
  - jFPUڼ޽
 ******************************************************************************/
/** \defgroup CMSIS_core_register `ƌ^`
    \brief Cortex-M۾ɊÂ޲p^`ƒ`
*/

/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_CORE ԂƐڼ޽
    \brief    jڼ޽^`
  @{
 */

/** \brief p۸яڼ޽(APSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
#if (__CORTEX_M != 0x04)
		uint32_t _reserved0:27;				/*!< ޯ 0`26: \ */
#else
		uint32_t _reserved0:16;				/*!< ޯ 0`15: \ */
		uint32_t GE:4;						/*!< ޯ16`19: ȏ׸ */
		uint32_t _reserved1:7;				/*!< ޯ20`26: \ */
#endif
		uint32_t Q:1;						/*!< ޯ    27: Oa׸ */
		uint32_t V:1;						/*!< ޯ    28: Ժ ׸ */
		uint32_t C:1;						/*!< ޯ    29: ذԺ ׸ */
		uint32_t Z:1;						/*!< ޯ    30: ۏԺ ׸ */
		uint32_t N:1;						/*!< ޯ    31: Ժ ׸ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} APSR_Type;


/** \brief 荞۸яڼ޽(IPSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t ISR:9;						/*!< ޯ 0` 8: Oԍ */
		uint32_t _reserved0:23;				/*!< ޯ 9`31: \ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} IPSR_Type;


/** \brief ړI۸яڼ޽(xPSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t ISR:9;						/*!< ޯ 0` 8: Oԍ */
#if (__CORTEX_M != 0x04)
		uint32_t _reserved0:15;				/*!< ޯ 9`23: \ */
#else
		uint32_t _reserved0:7;				/*!< ޯ 9`15: \ */
		uint32_t GE:4;						/*!< ޯ16`19: ȏ׸ */
		uint32_t _reserved1:4;				/*!< ޯ20`23: \ */
#endif
		uint32_t T:1;						/*!< ޯ    24:  ޯ(0ǂ) */
		uint32_t IT:2;						/*!< ޯ25`26: ۑꂽIT(0ǂ) */
		uint32_t Q:1;						/*!< ޯ    27: Oa׸ */
		uint32_t V:1;						/*!< ޯ    28: Ժ ׸ */
		uint32_t C:1;						/*!< ޯ    29: ذԺ ׸ */
		uint32_t Z:1;						/*!< ޯ    30: ۏԺ ׸ */
		uint32_t N:1;						/*!< ޯ    31: Ժ ׸ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} xPSR_Type;


/** \brief ڼ޽(CONTROL)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t nPRIV:1;					/*!< ޯ     0: گޓł̗O */
		uint32_t SPSEL:1;					/*!< ޯ     1: gp */
		uint32_t FPCA:1;					/*!< ޯ     2: FPg׸ */
		uint32_t _reserved0:29;				/*!< ޯ 3`31: \ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} CONTROL_Type;

/*@} CMSIS_COREQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_NVIC q޸^荞ݐ(NVIC)
    \brief    NVICڼ޽p^`
  @{
 */

/** \brief q޸^荞ݐ(NVIC)𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t ISER[8];					/*!< ψ: 0x000 (R/W) 荞ݐݒ苖ڼ޽ */
		 uint32_t RESERVED0[24];
	__IO uint32_t ICER[8];					/*!< ψ: 0x080 (R/W) 荞݉ڼ޽ */
		 uint32_t RSERVED1[24];
	__IO uint32_t ISPR[8];					/*!< ψ: 0x100 (R/W) 荞ݐݒۗڼ޽ */
		 uint32_t RESERVED2[24];
	__IO uint32_t ICPR[8];					/*!< ψ: 0x180 (R/W) 荞݉ۗڼ޽ */
		 uint32_t RESERVED3[24];
	__IO uint32_t IABR[8];					/*!< ψ: 0x200 (R/W) 荞݊ޯ ڼ޽ */
		 uint32_t RESERVED4[56];
	__IO uint8_t  IP[240];					/*!< ψ: 0x300 (R/W) 荞ݗD挠ڼ޽(8ޯĕ) */
		 uint32_t RESERVED5[644];
	__O  uint32_t STIR;						/*!< ψ: 0xE00 ( /W) ĳN荞ڼ޽ */
} NVIC_Type;

/* ĳN荞ڼ޽` */
#define NVIC_STIR_INTID_Pos					0									/*!< STIR: INTLINESNUMʒu */
#define NVIC_STIR_INTID_Msk					(0x1FFUL << NVIC_STIR_INTID_Pos)	/*!< STIR: INTLINESNUMՕ */

/*@} CMSIS_NVICQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_SCB ѐ䕔(SCB)
    \brief    ѐ䕔ڼ޽p^`
  @{
 */

/** \brief ѐ䕔(SCB)𱸾邽߂̍\̌^
 */
typedef struct
{
	__I  uint32_t CPUID;					/*!< ψ: 0x000 (R/ ) CPUIDڼ޽ */
	__IO uint32_t ICSR;						/*!< ψ: 0x004 (R/W) 荞ݐ/ڼ޽ */
	__IO uint32_t VTOR;						/*!< ψ: 0x008 (R/W) ޸\ψڼ޽ */
	__IO uint32_t AIRCR;					/*!< ψ: 0x00C (R/W) p荞݂ؾĐڼ޽ */
	__IO uint32_t SCR;						/*!< ψ: 0x010 (R/W) ѐڼ޽ */
	__IO uint32_t CCR;						/*!< ψ: 0x014 (R/W) `Ԑݒ萧ڼ޽ */
	__IO uint8_t  SHP[12];					/*!< ψ: 0x018 (R/W) яD挠ڼ޽(4-7, 8-11, 12-15) */
	__IO uint32_t SHCSR;					/*!< ψ: 0x024 (R/W) я/ڼ޽ */
	__IO uint32_t CFSR;						/*!< ψ: 0x028 (R/W) `Ԑݒ莸sڼ޽ */
	__IO uint32_t HFSR;						/*!< ψ: 0x02C (R/W) ʰޏQڼ޽ */
	__IO uint32_t DFSR;						/*!< ψ: 0x030 (R/W) ޯޏQڼ޽ */
	__IO uint32_t MMFAR;					/*!< ψ: 0x034 (R/W) MemManageQڽ ڼ޽ */
	__IO uint32_t BFAR;						/*!< ψ: 0x038 (R/W) BusFaultڽ ڼ޽ */
	__IO uint32_t AFSR;						/*!< ψ: 0x03C (R/W) ⏕Qڼ޽ */
	__I  uint32_t PFR[2];					/*!< ψ: 0x040 (R/ ) ۾@\ڼ޽ */
	__I  uint32_t DFR;						/*!< ψ: 0x048 (R/ ) ޯދ@\ڼ޽ */
	__I  uint32_t ADR;						/*!< ψ: 0x04C (R/ ) ⏕@\ڼ޽ */
	__I  uint32_t MMFR[4];					/*!< ψ: 0x050 (R/ ) ؗl@\ڼ޽ */
	__I  uint32_t ISAR[5];					/*!< ψ: 0x060 (R/ ) ߈ꎮڼ޽ */
		 uint32_t RESERVED0[5];
	__IO uint32_t CPACR;					/*!< ψ: 0x088 (R/W) ۾ ڼ޽ */
} SCB_Type;

/* SCB CPUIDڼ޽` */
#define SCB_CPUID_IMPLEMENTER_Pos			24											/*!< SCB CPUID: IMPLEMENTERʒu */
#define SCB_CPUID_IMPLEMENTER_Msk			(0xFFUL << SCB_CPUID_IMPLEMENTER_Pos)		/*!< SCB CPUID: IMPLEMENTERՕ */

#define SCB_CPUID_VARIANT_Pos				20											/*!< SCB CPUID: VARIANTʒu */
#define SCB_CPUID_VARIANT_Msk				(0xFUL << SCB_CPUID_VARIANT_Pos)			/*!< SCB CPUID: VARIANTՕ */

#define SCB_CPUID_ARCHITECTURE_Pos			16											/*!< SCB CPUID: ARCHITECTUREʒu */
#define SCB_CPUID_ARCHITECTURE_Msk			(0xFUL << SCB_CPUID_ARCHITECTURE_Pos)		/*!< SCB CPUID: ARCHITECTUREՕ */

#define SCB_CPUID_PARTNO_Pos				4											/*!< SCB CPUID: PARTNOʒu */
#define SCB_CPUID_PARTNO_Msk				(0xFFFUL << SCB_CPUID_PARTNO_Pos)			/*!< SCB CPUID: PARTNOՕ */

#define SCB_CPUID_REVISION_Pos				0											/*!< SCB CPUID: REVISIONʒu */
#define SCB_CPUID_REVISION_Msk				(0xFUL << SCB_CPUID_REVISION_Pos)			/*!< SCB CPUID: REVISIONՕ */

/* SCB 荞ݐ/ڼ޽` */
#define SCB_ICSR_NMIPENDSET_Pos				31											/*!< SCB ICSR: NMIPENDSETʒu */
#define SCB_ICSR_NMIPENDSET_Msk				(1UL << SCB_ICSR_NMIPENDSET_Pos)			/*!< SCB ICSR: NMIPENDSETՕ */

#define SCB_ICSR_PENDSVSET_Pos				28											/*!< SCB ICSR: PENDSVSETʒu */
#define SCB_ICSR_PENDSVSET_Msk				(1UL << SCB_ICSR_PENDSVSET_Pos)				/*!< SCB ICSR: PENDSVSETՕ */

#define SCB_ICSR_PENDSVCLR_Pos				27											/*!< SCB ICSR: PENDSVCLRʒu */
#define SCB_ICSR_PENDSVCLR_Msk				(1UL << SCB_ICSR_PENDSVCLR_Pos)				/*!< SCB ICSR: PENDSVCLRՕ */

#define SCB_ICSR_PENDSTSET_Pos				26											/*!< SCB ICSR: PENDSTSETʒu */
#define SCB_ICSR_PENDSTSET_Msk				(1UL << SCB_ICSR_PENDSTSET_Pos)				/*!< SCB ICSR: PENDSTSETՕ */

#define SCB_ICSR_PENDSTCLR_Pos				25											/*!< SCB ICSR: PENDSTCLRʒu */
#define SCB_ICSR_PENDSTCLR_Msk				(1UL << SCB_ICSR_PENDSTCLR_Pos)				/*!< SCB ICSR: PENDSTCLRՕ */

#define SCB_ICSR_ISRPREEMPT_Pos				23											/*!< SCB ICSR: ISRPREEMPTʒu */
#define SCB_ICSR_ISRPREEMPT_Msk				(1UL << SCB_ICSR_ISRPREEMPT_Pos)			/*!< SCB ICSR: ISRPREEMPTՕ */

#define SCB_ICSR_ISRPENDING_Pos				22											/*!< SCB ICSR: ISRPENDINGʒu */
#define SCB_ICSR_ISRPENDING_Msk				(1UL << SCB_ICSR_ISRPENDING_Pos)			/*!< SCB ICSR: ISRPENDINGՕ */

#define SCB_ICSR_VECTPENDING_Pos			12											/*!< SCB ICSR: VECTPENDINGʒu */
#define SCB_ICSR_VECTPENDING_Msk			(0x1FFUL << SCB_ICSR_VECTPENDING_Pos)		/*!< SCB ICSR: VECTPENDINGՕ */

#define SCB_ICSR_RETTOBASE_Pos				11											/*!< SCB ICSR: RETTOBASEʒu */
#define SCB_ICSR_RETTOBASE_Msk				(1UL << SCB_ICSR_RETTOBASE_Pos)				/*!< SCB ICSR: RETTOBASEՕ */

#define SCB_ICSR_VECTACTIVE_Pos				0											/*!< SCB ICSR: VECTACTIVEʒu */
#define SCB_ICSR_VECTACTIVE_Msk				(0x1FFUL << SCB_ICSR_VECTACTIVE_Pos)		/*!< SCB ICSR: VECTACTIVEՕ */

/* SCB ޸\ψڼ޽` */
#define SCB_VTOR_TBLOFF_Pos					7											/*!< SCB VTOR: TBLOFFʒu */
#define SCB_VTOR_TBLOFF_Msk					(0x1FFFFFFUL << SCB_VTOR_TBLOFF_Pos)		/*!< SCB VTOR: TBLOFFՕ */

/* SCB p荞݂ؾĐڼ޽` */
#define SCB_AIRCR_VECTKEY_Pos				16											/*!< SCB AIRCR: VECTKEYʒu */
#define SCB_AIRCR_VECTKEY_Msk				(0xFFFFUL << SCB_AIRCR_VECTKEY_Pos)			/*!< SCB AIRCR: VECTKEYՕ */

#define SCB_AIRCR_VECTKEYSTAT_Pos			16											/*!< SCB AIRCR: VECTKEYSTATʒu */
#define SCB_AIRCR_VECTKEYSTAT_Msk			(0xFFFFUL << SCB_AIRCR_VECTKEYSTAT_Pos)		/*!< SCB AIRCR: VECTKEYSTATՕ */

#define SCB_AIRCR_ENDIANESS_Pos				15											/*!< SCB AIRCR: ENDIANESSʒu */
#define SCB_AIRCR_ENDIANESS_Msk				(1UL << SCB_AIRCR_ENDIANESS_Pos)			/*!< SCB AIRCR: ENDIANESSՕ */

#define SCB_AIRCR_PRIGROUP_Pos				8											/*!< SCB AIRCR: PRIGROUPʒu */
#define SCB_AIRCR_PRIGROUP_Msk				(7UL << SCB_AIRCR_PRIGROUP_Pos)				/*!< SCB AIRCR: PRIGROUPՕ */

#define SCB_AIRCR_SYSRESETREQ_Pos			2											/*!< SCB AIRCR: SYSRESETREQʒu */
#define SCB_AIRCR_SYSRESETREQ_Msk			(1UL << SCB_AIRCR_SYSRESETREQ_Pos)			/*!< SCB AIRCR: SYSRESETREQՕ */

#define SCB_AIRCR_VECTCLRACTIVE_Pos			1											/*!< SCB AIRCR: VECTCLRACTIVEʒu */
#define SCB_AIRCR_VECTCLRACTIVE_Msk			(1UL << SCB_AIRCR_VECTCLRACTIVE_Pos)		/*!< SCB AIRCR: VECTCLRACTIVEՕ */

#define SCB_AIRCR_VECTRESET_Pos				0											/*!< SCB AIRCR: VECTRESETʒu */
#define SCB_AIRCR_VECTRESET_Msk				(1UL << SCB_AIRCR_VECTRESET_Pos)			/*!< SCB AIRCR: VECTRESETՕ */

/* SCB ѐڼ޽` */
#define SCB_SCR_SEVONPEND_Pos				4											/*!< SCB SCR: SEVONPENDʒu */
#define SCB_SCR_SEVONPEND_Msk				(1UL << SCB_SCR_SEVONPEND_Pos)				/*!< SCB SCR: SEVONPENDՕ */

#define SCB_SCR_SLEEPDEEP_Pos				2											/*!< SCB SCR: SLEEPDEEPʒu */
#define SCB_SCR_SLEEPDEEP_Msk				(1UL << SCB_SCR_SLEEPDEEP_Pos)				/*!< SCB SCR: SLEEPDEEPՕ */

#define SCB_SCR_SLEEPONEXIT_Pos				1											/*!< SCB SCR: SLEEPONEXITʒu */
#define SCB_SCR_SLEEPONEXIT_Msk				(1UL << SCB_SCR_SLEEPONEXIT_Pos)			/*!< SCB SCR: SLEEPONEXITՕ */

/* SCB `Ԑݒ萧ڼ޽` */
#define SCB_CCR_STKALIGN_Pos				9											/*!< SCB CCR: STKALIGNʒu */
#define SCB_CCR_STKALIGN_Msk				(1UL << SCB_CCR_STKALIGN_Pos)				/*!< SCB CCR: STKALIGNՕ */

#define SCB_CCR_BFHFNMIGN_Pos				8											/*!< SCB CCR: BFHFNMIGNʒu */
#define SCB_CCR_BFHFNMIGN_Msk				(1UL << SCB_CCR_BFHFNMIGN_Pos)				/*!< SCB CCR: BFHFNMIGNՕ */

#define SCB_CCR_DIV_0_TRP_Pos				4											/*!< SCB CCR: DIV_0_TRPʒu */
#define SCB_CCR_DIV_0_TRP_Msk				(1UL << SCB_CCR_DIV_0_TRP_Pos)				/*!< SCB CCR: DIV_0_TRPՕ */

#define SCB_CCR_UNALIGN_TRP_Pos				3											/*!< SCB CCR: UNALIGN_TRPʒu */
#define SCB_CCR_UNALIGN_TRP_Msk				(1UL << SCB_CCR_UNALIGN_TRP_Pos)			/*!< SCB CCR: UNALIGN_TRPՕ */

#define SCB_CCR_USERSETMPEND_Pos			1											/*!< SCB CCR: USERSETMPENDʒu */
#define SCB_CCR_USERSETMPEND_Msk			(1UL << SCB_CCR_USERSETMPEND_Pos)			/*!< SCB CCR: USERSETMPENDՕ */

#define SCB_CCR_NONBASETHRDENA_Pos			0											/*!< SCB CCR: NONBASETHRDENAʒu */
#define SCB_CCR_NONBASETHRDENA_Msk			(1UL << SCB_CCR_NONBASETHRDENA_Pos)			/*!< SCB CCR: NONBASETHRDENAՕ */

/* SCB я/ڼ޽` */
#define SCB_SHCSR_USGFAULTENA_Pos			18											/*!< SCB SHCSR: USGFAULTENAʒu */
#define SCB_SHCSR_USGFAULTENA_Msk			(1UL << SCB_SHCSR_USGFAULTENA_Pos)			/*!< SCB SHCSR: USGFAULTENAՕ */

#define SCB_SHCSR_BUSFAULTENA_Pos			17											/*!< SCB SHCSR: BUSFAULTENAʒu */
#define SCB_SHCSR_BUSFAULTENA_Msk			(1UL << SCB_SHCSR_BUSFAULTENA_Pos)			/*!< SCB SHCSR: BUSFAULTENAՕ */

#define SCB_SHCSR_MEMFAULTENA_Pos			16											/*!< SCB SHCSR: MEMFAULTENAʒu */
#define SCB_SHCSR_MEMFAULTENA_Msk			(1UL << SCB_SHCSR_MEMFAULTENA_Pos)			/*!< SCB SHCSR: MEMFAULTENAՕ */

#define SCB_SHCSR_SVCALLPENDED_Pos			15											/*!< SCB SHCSR: SVCALLPENDEDʒu */
#define SCB_SHCSR_SVCALLPENDED_Msk			(1UL << SCB_SHCSR_SVCALLPENDED_Pos)			/*!< SCB SHCSR: SVCALLPENDEDՕ */

#define SCB_SHCSR_BUSFAULTPENDED_Pos		14											/*!< SCB SHCSR: BUSFAULTPENDEDʒu */
#define SCB_SHCSR_BUSFAULTPENDED_Msk		(1UL << SCB_SHCSR_BUSFAULTPENDED_Pos)		/*!< SCB SHCSR: BUSFAULTPENDEDՕ */

#define SCB_SHCSR_MEMFAULTPENDED_Pos		13											/*!< SCB SHCSR: MEMFAULTPENDEDʒu */
#define SCB_SHCSR_MEMFAULTPENDED_Msk		(1UL << SCB_SHCSR_MEMFAULTPENDED_Pos)		/*!< SCB SHCSR: MEMFAULTPENDEDՕ */

#define SCB_SHCSR_USGFAULTPENDED_Pos		12											/*!< SCB SHCSR: USGFAULTPENDEDʒu */
#define SCB_SHCSR_USGFAULTPENDED_Msk       (1UL << SCB_SHCSR_USGFAULTPENDED_Pos)	/*!< SCB SHCSR: USGFAULTPENDEDՕ */

#define SCB_SHCSR_SYSTICKACT_Pos			11											/*!< SCB SHCSR: SYSTICKACTʒu */
#define SCB_SHCSR_SYSTICKACT_Msk			(1UL << SCB_SHCSR_SYSTICKACT_Pos)			/*!< SCB SHCSR: SYSTICKACTՕ */

#define SCB_SHCSR_PENDSVACT_Pos				10											/*!< SCB SHCSR: PENDSVACTʒu */
#define SCB_SHCSR_PENDSVACT_Msk				(1UL << SCB_SHCSR_PENDSVACT_Pos)			/*!< SCB SHCSR: PENDSVACTՕ */

#define SCB_SHCSR_MONITORACT_Pos			8											/*!< SCB SHCSR: MONITORACTʒu */
#define SCB_SHCSR_MONITORACT_Msk			(1UL << SCB_SHCSR_MONITORACT_Pos)			/*!< SCB SHCSR: MONITORACTՕ */

#define SCB_SHCSR_SVCALLACT_Pos				7											/*!< SCB SHCSR: SVCALLACTʒu */
#define SCB_SHCSR_SVCALLACT_Msk				(1UL << SCB_SHCSR_SVCALLACT_Pos)			/*!< SCB SHCSR: SVCALLACTՕ */

#define SCB_SHCSR_USGFAULTACT_Pos			3											/*!< SCB SHCSR: USGFAULTACTʒu */
#define SCB_SHCSR_USGFAULTACT_Msk			(1UL << SCB_SHCSR_USGFAULTACT_Pos)			/*!< SCB SHCSR: USGFAULTACTՕ */

#define SCB_SHCSR_BUSFAULTACT_Pos			1											/*!< SCB SHCSR: BUSFAULTACTʒu */
#define SCB_SHCSR_BUSFAULTACT_Msk			(1UL << SCB_SHCSR_BUSFAULTACT_Pos)			/*!< SCB SHCSR: BUSFAULTACTՕ */

#define SCB_SHCSR_MEMFAULTACT_Pos			0											/*!< SCB SHCSR: MEMFAULTACTʒu */
#define SCB_SHCSR_MEMFAULTACT_Msk			(1UL << SCB_SHCSR_MEMFAULTACT_Pos)			/*!< SCB SHCSR: MEMFAULTACTՕ */

/* SCB `Ԑݒ莸sڼ޽` */
#define SCB_CFSR_USGFAULTSR_Pos				16											/*!< SCB CFSR: gpQڼ޽ʒu */
#define SCB_CFSR_USGFAULTSR_Msk				(0xFFFFUL << SCB_CFSR_USGFAULTSR_Pos)		/*!< SCB CFSR: gpQڼ޽Օ */

#define SCB_CFSR_BUSFAULTSR_Pos				8											/*!< SCB CFSR: ޽Qڼ޽ʒu */
#define SCB_CFSR_BUSFAULTSR_Msk				(0xFFUL << SCB_CFSR_BUSFAULTSR_Pos)			/*!< SCB CFSR: ޽Qڼ޽Օ */

#define SCB_CFSR_MEMFAULTSR_Pos				0											/*!< SCB CFSR: ؊ǗQڼ޽ʒu */
#define SCB_CFSR_MEMFAULTSR_Msk				(0xFFUL << SCB_CFSR_MEMFAULTSR_Pos)			/*!< SCB CFSR: ؊ǗQڼ޽Օ */

/* SCB ʰޏQڼ޽` */
#define SCB_HFSR_DEBUGEVT_Pos				31											/*!< SCB HFSR: DEBUGEVTʒu */
#define SCB_HFSR_DEBUGEVT_Msk				(1UL << SCB_HFSR_DEBUGEVT_Pos)				/*!< SCB HFSR: DEBUGEVTՕ */

#define SCB_HFSR_FORCED_Pos					30											/*!< SCB HFSR: FORCEDʒu */
#define SCB_HFSR_FORCED_Msk					(1UL << SCB_HFSR_FORCED_Pos)				/*!< SCB HFSR: FORCEDՕ */

#define SCB_HFSR_VECTTBL_Pos				1											/*!< SCB HFSR: VECTTBLʒu */
#define SCB_HFSR_VECTTBL_Msk				(1UL << SCB_HFSR_VECTTBL_Pos)				/*!< SCB HFSR: VECTTBLՕ */

/* SCB ޯޏQڼ޽` */
#define SCB_DFSR_EXTERNAL_Pos				4											/*!< SCB DFSR: EXTERNALʒu */
#define SCB_DFSR_EXTERNAL_Msk				(1UL << SCB_DFSR_EXTERNAL_Pos)				/*!< SCB DFSR: EXTERNALՕ */

#define SCB_DFSR_VCATCH_Pos					3											/*!< SCB DFSR: VCATCHʒu */
#define SCB_DFSR_VCATCH_Msk					(1UL << SCB_DFSR_VCATCH_Pos)				/*!< SCB DFSR: VCATCHՕ */

#define SCB_DFSR_DWTTRAP_Pos				2											/*!< SCB DFSR: DWTTRAPʒu */
#define SCB_DFSR_DWTTRAP_Msk				(1UL << SCB_DFSR_DWTTRAP_Pos)				/*!< SCB DFSR: DWTTRAPՕ */

#define SCB_DFSR_BKPT_Pos					1											/*!< SCB DFSR: BKPTʒu */
#define SCB_DFSR_BKPT_Msk					(1UL << SCB_DFSR_BKPT_Pos)					/*!< SCB DFSR: BKPTՕ */

#define SCB_DFSR_HALTED_Pos					0											/*!< SCB DFSR: HALTEDʒu */
#define SCB_DFSR_HALTED_Msk					(1UL << SCB_DFSR_HALTED_Pos)				/*!< SCB DFSR: HALTEDՕ */

/*@} CMSIS_SCBQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_SCnSCB SCBłȂѐ(SCnSCB)
    \brief    SCBłȂѐIDڼ޽p^`
  @{
 */

/** \brief SCBłȂѐIDڼ޽𱸾邽߂̍\̌^
 */
typedef struct
{
		 uint32_t RESERVED0[1];
	__I  uint32_t ICTR;						/*!< ψ: 0x004 (R/ ) 荞ݐ^ڼ޽ */
	__IO uint32_t ACTLR;					/*!< ψ: 0x008 (R/W) ⏕ڼ޽ */
} SCnSCB_Type;

/* 荞ݐ^ڼ޽` */
#define SCnSCB_ICTR_INTLINESNUM_Pos			0											/*!< ICTR: INTLINESNUMʒu */
#define SCnSCB_ICTR_INTLINESNUM_Msk			(0xFUL << SCnSCB_ICTR_INTLINESNUM_Pos)		/*!< ICTR: INTLINESNUMՕ */

/* ⏕ڼ޽` */
#define SCnSCB_ACTLR_DISOOFP_Pos			9											/*!< ACTLR: DISOOFPʒu */
#define SCnSCB_ACTLR_DISOOFP_Msk			(1UL << SCnSCB_ACTLR_DISOOFP_Pos)			/*!< ACTLR: DISOOFPՕ */

#define SCnSCB_ACTLR_DISFPCA_Pos			8											/*!< ACTLR: DISFPCAʒu */
#define SCnSCB_ACTLR_DISFPCA_Msk			(1UL << SCnSCB_ACTLR_DISFPCA_Pos)			/*!< ACTLR: DISFPCAՕ */

#define SCnSCB_ACTLR_DISFOLD_Pos			2											/*!< ACTLR: DISFOLDʒu */
#define SCnSCB_ACTLR_DISFOLD_Msk			(1UL << SCnSCB_ACTLR_DISFOLD_Pos)			/*!< ACTLR: DISFOLDՕ */

#define SCnSCB_ACTLR_DISDEFWBUF_Pos			1											/*!< ACTLR: DISDEFWBUFʒu */
#define SCnSCB_ACTLR_DISDEFWBUF_Msk			(1UL << SCnSCB_ACTLR_DISDEFWBUF_Pos)		/*!< ACTLR: DISDEFWBUFՕ */

#define SCnSCB_ACTLR_DISMCYCINT_Pos			0											/*!< ACTLR: DISMCYCINTʒu */
#define SCnSCB_ACTLR_DISMCYCINT_Msk			(1UL << SCnSCB_ACTLR_DISMCYCINT_Pos)		/*!< ACTLR: DISMCYCINTՕ */

/*@} CMSIS_SCnotSCBQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_SysTick эv(SysTick)
    \brief    эvp^`
  @{
 */

/** \brief эv𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t CTRL;						/*!< ψ: 0x000 (R/W) SysTick/ڼ޽ */
	__IO uint32_t LOAD;						/*!< ψ: 0x004 (R/W) SysTickĐݒlڼ޽ */
	__IO uint32_t VAL;						/*!< ψ: 0x008 (R/W) SysTickݒlڼ޽ */
	__I  uint32_t CALIB;					/*!< ψ: 0x00C (R/ ) SysTickZڼ޽ */
} SysTick_Type;

/* SysTick /ڼ޽` */
#define SysTick_CTRL_COUNTFLAG_Pos			16											/*!< SysTick CTRL: COUNTFLAGʒu */
#define SysTick_CTRL_COUNTFLAG_Msk			(1UL << SysTick_CTRL_COUNTFLAG_Pos)			/*!< SysTick CTRL: COUNTFLAGՕ */

#define SysTick_CTRL_CLKSOURCE_Pos			2											/*!< SysTick CTRL: CLKSOURCEʒu */
#define SysTick_CTRL_CLKSOURCE_Msk			(1UL << SysTick_CTRL_CLKSOURCE_Pos)			/*!< SysTick CTRL: CLKSOURCEՕ */

#define SysTick_CTRL_TICKINT_Pos			1											/*!< SysTick CTRL: TICKINTʒu */
#define SysTick_CTRL_TICKINT_Msk			(1UL << SysTick_CTRL_TICKINT_Pos)			/*!< SysTick CTRL: TICKINTՕ */

#define SysTick_CTRL_ENABLE_Pos				0											/*!< SysTick CTRL: ENABLEʒu */
#define SysTick_CTRL_ENABLE_Msk				(1UL << SysTick_CTRL_ENABLE_Pos)			/*!< SysTick CTRL: ENABLEՕ */

/* SysTick Đݒlڼ޽` */
#define SysTick_LOAD_RELOAD_Pos				0											/*!< SysTick LOAD: RELOADʒu */
#define SysTick_LOAD_RELOAD_Msk				(0xFFFFFFUL << SysTick_LOAD_RELOAD_Pos)		/*!< SysTick LOAD: RELOADՕ */

/* SysTick ݒlڼ޽` */
#define SysTick_VAL_CURRENT_Pos				0											/*!< SysTick VAL: CURRENTʒu */
#define SysTick_VAL_CURRENT_Msk				(0xFFFFFFUL << SysTick_VAL_CURRENT_Pos)		/*!< SysTick VAL: CURRENTՕ */

/* SysTick Zڼ޽` */
#define SysTick_CALIB_NOREF_Pos				31											/*!< SysTick CALIB: NOREFʒu */
#define SysTick_CALIB_NOREF_Msk				(1UL << SysTick_CALIB_NOREF_Pos)			/*!< SysTick CALIB: NOREFՕ */

#define SysTick_CALIB_SKEW_Pos				30											/*!< SysTick CALIB: SKEWʒu */
#define SysTick_CALIB_SKEW_Msk				(1UL << SysTick_CALIB_SKEW_Pos)				/*!< SysTick CALIB: SKEWՕ */

#define SysTick_CALIB_TENMS_Pos				0											/*!< SysTick CALIB: TENMSʒu */
#define SysTick_CALIB_TENMS_Msk				(0xFFFFFFUL << SysTick_VAL_CURRENT_Pos)		/*!< SysTick CALIB: TENMSՕ */

/*@} CMSIS_SysTickQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_ITM vǐϸ۾(ITM)
    \brief    vǐϸ۾(ITM)p^`
  @{
 */

/** \brief vǐϸ۾(ITM)ڼ޽𱸾邽߂̍\̌^
 */
typedef struct
{
	__O  union
	{
		__O  uint8_t    u8;					/*!< ψ: 0x000 ( /W) ITMh߰8ޯ */
		__O  uint16_t   u16;				/*!< ψ: 0x000 ( /W) ITMh߰16ޯ */
		__O  uint32_t   u32;				/*!< ψ: 0x000 ( /W) ITMh߰32ޯ */
	} PORT [32];							/*!< ψ: 0x000 ( /W) ITMh߰ ڼ޽ */
		 uint32_t RESERVED0[864];
	__IO uint32_t TER;						/*!< ψ: 0xE00 (R/W) ITMǐՋڼ޽ */
		 uint32_t RESERVED1[15];
	__IO uint32_t TPR;						/*!< ψ: 0xE40 (R/W) ITMǐՓڼ޽ */
		 uint32_t RESERVED2[15];
	__IO uint32_t TCR;						/*!< ψ: 0xE80 (R/W) ITMǐՐڼ޽ */
} ITM_Type;

/* ITM ǐՓڼ޽` */
#define ITM_TPR_PRIVMASK_Pos				0											/*!< ITM TPR: PRIVMASKʒu */
#define ITM_TPR_PRIVMASK_Msk				(0xFUL << ITM_TPR_PRIVMASK_Pos)				/*!< ITM TPR: PRIVMASKՕ */

/* ITM ǐՐڼ޽` */
#define ITM_TCR_BUSY_Pos					23											/*!< ITM TCR: BUSYʒu */
#define ITM_TCR_BUSY_Msk					(1UL << ITM_TCR_BUSY_Pos)					/*!< ITM TCR: BUSYՕ */

#define ITM_TCR_TraceBusID_Pos				16											/*!< ITM TCR: ATBIDʒu */
#define ITM_TCR_TraceBusID_Msk				(0x7FUL << ITM_TCR_TraceBusID_Pos)			/*!< ITM TCR: ATBIDՕ */

#define ITM_TCR_GTSFREQ_Pos					10											/*!< ITM TCR: S̓IȎgʒu */
#define ITM_TCR_GTSFREQ_Msk					(3UL << ITM_TCR_GTSFREQ_Pos)				/*!< ITM TCR: S̓IȎgՕ */

#define ITM_TCR_TSPrescale_Pos				8											/*!< ITM TCR: TSPrescaleʒu */
#define ITM_TCR_TSPrescale_Msk				(3UL << ITM_TCR_TSPrescale_Pos)				/*!< ITM TCR: TSPrescaleՕ */

#define ITM_TCR_SWOENA_Pos					4											/*!< ITM TCR: SWOENAʒu */
#define ITM_TCR_SWOENA_Msk					(1UL << ITM_TCR_SWOENA_Pos)					/*!< ITM TCR: SWOENAՕ */

#define ITM_TCR_TXENA_Pos					3											/*!< ITM TCR: TXENAʒu */
#define ITM_TCR_TXENA_Msk					(1UL << ITM_TCR_TXENA_Pos)					/*!< ITM TCR: TXENAՕ */

#define ITM_TCR_SYNCENA_Pos					2											/*!< ITM TCR: SYNCENAʒu */
#define ITM_TCR_SYNCENA_Msk					(1UL << ITM_TCR_SYNCENA_Pos)				/*!< ITM TCR: SYNCENAՕ */

#define ITM_TCR_TSENA_Pos					1											/*!< ITM TCR: TSENAʒu */
#define ITM_TCR_TSENA_Msk					(1UL << ITM_TCR_TSENA_Pos)					/*!< ITM TCR: TSENAՕ */

#define ITM_TCR_ITMENA_Pos					0											/*!< ITM TCR: ITMޯĈʒu */
#define ITM_TCR_ITMENA_Msk					(1UL << ITM_TCR_ITMENA_Pos)					/*!< ITM TCR: ITMޯĎՕ */

/*@}*/ /* CMSIS_ITMQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_DWT ްĎ_ƒǐ(DWT)
    \brief    ްĎ_ƒǐ(DWT)p^`
  @{
 */

/** \brief ްĎ_ƒǐ(DWT)ڼ޽𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t CTRL;						/*!< ψ: 0x000 (R/W) ڼ޽ */
	__IO uint32_t CYCCNT;					/*!< ψ: 0x004 (R/W) vڼ޽ */
	__IO uint32_t CPICNT;					/*!< ψ: 0x008 (R/W) CPIvڼ޽ */
	__IO uint32_t EXCCNT;					/*!< ψ: 0x00C (R/W) Ot׌vڼ޽ */
	__IO uint32_t SLEEPCNT;					/*!< ψ: 0x010 (R/W) x~vڼ޽ */
	__IO uint32_t LSUCNT;					/*!< ψ: 0x014 (R/W) LSUvڼ޽ */
	__IO uint32_t FOLDCNT;					/*!< ψ: 0x018 (R/W) ߌvڼ޽ */
	__I  uint32_t PCSR;						/*!< ψ: 0x01C (R/ ) ۸ьv̎ڼ޽ */
	__IO uint32_t COMP0;					/*!< ψ: 0x020 (R/W) rڼ޽0 */
	__IO uint32_t MASK0;					/*!< ψ: 0x024 (R/W) Օڼ޽0 */
	__IO uint32_t FUNCTION0;				/*!< ψ: 0x028 (R/W) @\ڼ޽0 */
		 uint32_t RESERVED0[1];
	__IO uint32_t COMP1;					/*!< ψ: 0x030 (R/W) rڼ޽1 */
	__IO uint32_t MASK1;					/*!< ψ: 0x034 (R/W) Օڼ޽1 */
	__IO uint32_t FUNCTION1;				/*!< ψ: 0x038 (R/W) @\ڼ޽1 */
		 uint32_t RESERVED1[1];
	__IO uint32_t COMP2;					/*!< ψ: 0x040 (R/W) rڼ޽2 */
	__IO uint32_t MASK2;					/*!< ψ: 0x044 (R/W) Օڼ޽2 */
	__IO uint32_t FUNCTION2;				/*!< ψ: 0x048 (R/W) @\ڼ޽2 */
		 uint32_t RESERVED2[1];
	__IO uint32_t COMP3;					/*!< ψ: 0x050 (R/W) rڼ޽3 */
	__IO uint32_t MASK3;					/*!< ψ: 0x054 (R/W) Օڼ޽3 */
	__IO uint32_t FUNCTION3;				/*!< ψ: 0x058 (R/W) @\ڼ޽3 */
} DWT_Type;

/* DWT ڼ޽` */
#define DWT_CTRL_NUMCOMP_Pos				28											/*!< DWT CTRL: NUMCOMPʒu */
#define DWT_CTRL_NUMCOMP_Msk				(0xFUL << DWT_CTRL_NUMCOMP_Pos)				/*!< DWT CTRL: NUMCOMPՕ */

#define DWT_CTRL_NOTRCPKT_Pos				27											/*!< DWT CTRL: NOTRCPKTʒu */
#define DWT_CTRL_NOTRCPKT_Msk				(0x1UL << DWT_CTRL_NOTRCPKT_Pos)			/*!< DWT CTRL: NOTRCPKTՕ */

#define DWT_CTRL_NOEXTTRIG_Pos				26											/*!< DWT CTRL: NOEXTTRIGʒu */
#define DWT_CTRL_NOEXTTRIG_Msk				(0x1UL << DWT_CTRL_NOEXTTRIG_Pos)			/*!< DWT CTRL: NOEXTTRIGՕ */

#define DWT_CTRL_NOCYCCNT_Pos				25											/*!< DWT CTRL: NOCYCCNTʒu */
#define DWT_CTRL_NOCYCCNT_Msk				(0x1UL << DWT_CTRL_NOCYCCNT_Pos)			/*!< DWT CTRL: NOCYCCNTՕ */

#define DWT_CTRL_NOPRFCNT_Pos				24											/*!< DWT CTRL: NOPRFCNTʒu */
#define DWT_CTRL_NOPRFCNT_Msk				(0x1UL << DWT_CTRL_NOPRFCNT_Pos)			/*!< DWT CTRL: NOPRFCNTՕ */

#define DWT_CTRL_CYCEVTENA_Pos				22											/*!< DWT CTRL: CYCEVTENAʒu */
#define DWT_CTRL_CYCEVTENA_Msk				(0x1UL << DWT_CTRL_CYCEVTENA_Pos)			/*!< DWT CTRL: CYCEVTENAՕ */

#define DWT_CTRL_FOLDEVTENA_Pos				21											/*!< DWT CTRL: FOLDEVTENAʒu */
#define DWT_CTRL_FOLDEVTENA_Msk				(0x1UL << DWT_CTRL_FOLDEVTENA_Pos)			/*!< DWT CTRL: FOLDEVTENAՕ */

#define DWT_CTRL_LSUEVTENA_Pos				20											/*!< DWT CTRL: LSUEVTENAʒu */
#define DWT_CTRL_LSUEVTENA_Msk				(0x1UL << DWT_CTRL_LSUEVTENA_Pos)			/*!< DWT CTRL: LSUEVTENAՕ */

#define DWT_CTRL_SLEEPEVTENA_Pos			19											/*!< DWT CTRL: SLEEPEVTENAʒu */
#define DWT_CTRL_SLEEPEVTENA_Msk			(0x1UL << DWT_CTRL_SLEEPEVTENA_Pos)			/*!< DWT CTRL: SLEEPEVTENAՕ */

#define DWT_CTRL_EXCEVTENA_Pos				18											/*!< DWT CTRL: EXCEVTENAʒu */
#define DWT_CTRL_EXCEVTENA_Msk				(0x1UL << DWT_CTRL_EXCEVTENA_Pos)			/*!< DWT CTRL: EXCEVTENAՕ */

#define DWT_CTRL_CPIEVTENA_Pos				17											/*!< DWT CTRL: CPIEVTENAʒu */
#define DWT_CTRL_CPIEVTENA_Msk				(0x1UL << DWT_CTRL_CPIEVTENA_Pos)			/*!< DWT CTRL: CPIEVTENAՕ */

#define DWT_CTRL_EXCTRCENA_Pos				16											/*!< DWT CTRL: EXCTRCENAʒu */
#define DWT_CTRL_EXCTRCENA_Msk				(0x1UL << DWT_CTRL_EXCTRCENA_Pos)			/*!< DWT CTRL: EXCTRCENAՕ */

#define DWT_CTRL_PCSAMPLENA_Pos				12											/*!< DWT CTRL: PCSAMPLENAʒu */
#define DWT_CTRL_PCSAMPLENA_Msk				(0x1UL << DWT_CTRL_PCSAMPLENA_Pos)			/*!< DWT CTRL: PCSAMPLENAՕ */

#define DWT_CTRL_SYNCTAP_Pos				10											/*!< DWT CTRL: SYNCTAPʒu */
#define DWT_CTRL_SYNCTAP_Msk				(0x3UL << DWT_CTRL_SYNCTAP_Pos)				/*!< DWT CTRL: SYNCTAPՕ */

#define DWT_CTRL_CYCTAP_Pos					9											/*!< DWT CTRL: CYCTAPʒu */
#define DWT_CTRL_CYCTAP_Msk					(0x1UL << DWT_CTRL_CYCTAP_Pos)				/*!< DWT CTRL: CYCTAPՕ */

#define DWT_CTRL_POSTINIT_Pos				5											/*!< DWT CTRL: POSTINITʒu */
#define DWT_CTRL_POSTINIT_Msk				(0xFUL << DWT_CTRL_POSTINIT_Pos)			/*!< DWT CTRL: POSTINITՕ */

#define DWT_CTRL_POSTPRESET_Pos				1											/*!< DWT CTRL: POSTPRESETʒu */
#define DWT_CTRL_POSTPRESET_Msk				(0xFUL << DWT_CTRL_POSTPRESET_Pos)			/*!< DWT CTRL: POSTPRESETՕ */

#define DWT_CTRL_CYCCNTENA_Pos				0											/*!< DWT CTRL: CYCCNTENAʒu */
#define DWT_CTRL_CYCCNTENA_Msk				(0x1UL << DWT_CTRL_CYCCNTENA_Pos)			/*!< DWT CTRL: CYCCNTENAՕ */

/* DWT CPIvڼ޽` */
#define DWT_CPICNT_CPICNT_Pos				0											/*!< DWT CPICNT: CPICNTʒu */
#define DWT_CPICNT_CPICNT_Msk				(0xFFUL << DWT_CPICNT_CPICNT_Pos)			/*!< DWT CPICNT: CPICNTՕ */

/* DWT Ot׌vڼ޽` */
#define DWT_EXCCNT_EXCCNT_Pos				0											/*!< DWT EXCCNT: EXCCNTʒu */
#define DWT_EXCCNT_EXCCNT_Msk				(0xFFUL << DWT_EXCCNT_EXCCNT_Pos)			/*!< DWT EXCCNT: EXCCNTՕ */

/* DWT x~vڼ޽` */
#define DWT_SLEEPCNT_SLEEPCNT_Pos			0											/*!< DWT SLEEPCNT: SLEEPCNTʒu */
#define DWT_SLEEPCNT_SLEEPCNT_Msk			(0xFFUL << DWT_SLEEPCNT_SLEEPCNT_Pos)		/*!< DWT SLEEPCNT: SLEEPCNTՕ */

/* DWT LSUvڼ޽` */
#define DWT_LSUCNT_LSUCNT_Pos				0											/*!< DWT LSUCNT: LSUCNTʒu */
#define DWT_LSUCNT_LSUCNT_Msk				(0xFFUL << DWT_LSUCNT_LSUCNT_Pos)			/*!< DWT LSUCNT: LSUCNTՕ */

/* DWT ߌvڼ޽` */
#define DWT_FOLDCNT_FOLDCNT_Pos				0											/*!< DWT FOLDCNT: FOLDCNTʒu */
#define DWT_FOLDCNT_FOLDCNT_Msk				(0xFFUL << DWT_FOLDCNT_FOLDCNT_Pos)			/*!< DWT FOLDCNT: FOLDCNTՕ */

/* DWT rՕڼ޽` */
#define DWT_MASK_MASK_Pos					0											/*!< DWT MASK: MASKʒu */
#define DWT_MASK_MASK_Msk					(0x1FUL << DWT_MASK_MASK_Pos)				/*!< DWT MASK: MASKՕ */

/* DWT r@\ڼ޽` */
#define DWT_FUNCTION_MATCHED_Pos			24											/*!< DWT FUNCTION: MATCHEDʒu */
#define DWT_FUNCTION_MATCHED_Msk			(0x1UL << DWT_FUNCTION_MATCHED_Pos)			/*!< DWT FUNCTION: MATCHEDՕ */

#define DWT_FUNCTION_DATAVADDR1_Pos			16											/*!< DWT FUNCTION: DATAVADDR1ʒu */
#define DWT_FUNCTION_DATAVADDR1_Msk			(0xFUL << DWT_FUNCTION_DATAVADDR1_Pos)		/*!< DWT FUNCTION: DATAVADDR1Օ */

#define DWT_FUNCTION_DATAVADDR0_Pos			12											/*!< DWT FUNCTION: DATAVADDR0ʒu */
#define DWT_FUNCTION_DATAVADDR0_Msk			(0xFUL << DWT_FUNCTION_DATAVADDR0_Pos)		/*!< DWT FUNCTION: DATAVADDR0Օ */

#define DWT_FUNCTION_DATAVSIZE_Pos			10											/*!< DWT FUNCTION: DATAVSIZEʒu */
#define DWT_FUNCTION_DATAVSIZE_Msk			(0x3UL << DWT_FUNCTION_DATAVSIZE_Pos)		/*!< DWT FUNCTION: DATAVSIZEՕ */

#define DWT_FUNCTION_LNK1ENA_Pos			9											/*!< DWT FUNCTION: LNK1ENAʒu */
#define DWT_FUNCTION_LNK1ENA_Msk			(0x1UL << DWT_FUNCTION_LNK1ENA_Pos)			/*!< DWT FUNCTION: LNK1ENAՕ */

#define DWT_FUNCTION_DATAVMATCH_Pos			8											/*!< DWT FUNCTION: DATAVMATCHʒu */
#define DWT_FUNCTION_DATAVMATCH_Msk			(0x1UL << DWT_FUNCTION_DATAVMATCH_Pos)		/*!< DWT FUNCTION: DATAVMATCHՕ */

#define DWT_FUNCTION_CYCMATCH_Pos			7											/*!< DWT FUNCTION: CYCMATCHʒu */
#define DWT_FUNCTION_CYCMATCH_Msk			(0x1UL << DWT_FUNCTION_CYCMATCH_Pos)		/*!< DWT FUNCTION: CYCMATCHՕ */

#define DWT_FUNCTION_EMITRANGE_Pos			5											/*!< DWT FUNCTION: EMITRANGEʒu */
#define DWT_FUNCTION_EMITRANGE_Msk			(0x1UL << DWT_FUNCTION_EMITRANGE_Pos)		/*!< DWT FUNCTION: EMITRANGEՕ */

#define DWT_FUNCTION_FUNCTION_Pos			0											/*!< DWT FUNCTION: FUNCTIONʒu */
#define DWT_FUNCTION_FUNCTION_Msk			(0xFUL << DWT_FUNCTION_FUNCTION_Pos)		/*!< DWT FUNCTION: FUNCTIONՕ */

/*@}*/ /* CMSIS_DWTQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_TPI ǐ߰ ̪(TPI)
    \brief    ǐ߰ ̪(TPI)p^`
  @{
 */

/** \brief ǐ߰ ̪ ޽(TPI)𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t SSPSR;					/*!< ψ: 0x000 (R/ ) x߰đ傫ڼ޽ */
	__IO uint32_t CSPSR;					/*!< ψ: 0x004 (R/W) ݂߰̕đ傫ڼ޽ */
		 uint32_t RESERVED0[2];
	__IO uint32_t ACPR; 					/*!< ψ: 0x010 (R/W) 񓯊ۯOuڼ޽ */
		 uint32_t RESERVED1[55];
	__IO uint32_t SPPR; 					/*!< ψ: 0x0F0 (R/W) I݋Kڼ޽ */
		 uint32_t RESERVED2[131];
	__I  uint32_t FFSR;						/*!< ψ: 0x300 (R/ ) `Ɣjڼ޽ */
	__IO uint32_t FFCR;						/*!< ψ: 0x304 (R/W) `Ɣjڼ޽ */
	__I  uint32_t FSCR;						/*!< ψ: 0x308 (R/ ) `vڼ޽ */
		 uint32_t RESERVED3[759];
	__I  uint32_t TRIGGER;					/*!< ψ: 0xEE8 (R/ ) TRIGGER */
	__I  uint32_t FIFO0;					/*!< ψ: 0xEEC (R/ ) ETMް */
	__I  uint32_t ITATBCTR2;				/*!< ψ: 0xEF0 (R/ ) ITATBCTR2 */
		 uint32_t RESERVED4[1];
	__I  uint32_t ITATBCTR0;				/*!< ψ: 0xEF8 (R/ ) ITATBCTR0 */
	__I  uint32_t FIFO1;					/*!< ψ: 0xEFC (R/ ) ITMް */
	__IO uint32_t ITCTRL;					/*!< ψ: 0xF00 (R/W) 쐧 */
		 uint32_t RESERVED5[39];
	__IO uint32_t CLAIMSET;					/*!< ψ: 0xFA0 (R/W) ؐݒ */
	__IO uint32_t CLAIMCLR;					/*!< ψ: 0xFA4 (R/W) ؉ */
		 uint32_t RESERVED7[8];
	__I  uint32_t DEVID;					/*!< ψ: 0xFC8 (R/ ) TPIU_DEVID */
	__I  uint32_t DEVTYPE;					/*!< ψ: 0xFCC (R/ ) TPIU_DEVTYPE */
} TPI_Type;

/* TPI 񓯊ۯOuڼ޽` */
#define TPI_ACPR_PRESCALER_Pos				0											/*!< TPI ACPR: PRESCALERʒu */
#define TPI_ACPR_PRESCALER_Msk				(0x1FFFUL << TPI_ACPR_PRESCALER_Pos)		/*!< TPI ACPR: PRESCALERՕ */

/* TPI I݋Kڼ޽` */
#define TPI_SPPR_TXMODE_Pos					0											/*!< TPI SPPR: TXMODEʒu */
#define TPI_SPPR_TXMODE_Msk					(0x3UL << TPI_SPPR_TXMODE_Pos)				/*!< TPI SPPR: TXMODEՕ */

/* TPI `Ɣjڼ޽` */
#define TPI_FFSR_FtNonStop_Pos				3											/*!< TPI FFSR: FtNonStopʒu */
#define TPI_FFSR_FtNonStop_Msk				(0x1UL << TPI_FFSR_FtNonStop_Pos)			/*!< TPI FFSR: FtNonStopՕ */

#define TPI_FFSR_TCPresent_Pos				2											/*!< TPI FFSR: TCPresentʒu */
#define TPI_FFSR_TCPresent_Msk				(0x1UL << TPI_FFSR_TCPresent_Pos)			/*!< TPI FFSR: TCPresentՕ */

#define TPI_FFSR_FtStopped_Pos				1											/*!< TPI FFSR: FtStoppedʒu */
#define TPI_FFSR_FtStopped_Msk				(0x1UL << TPI_FFSR_FtStopped_Pos)			/*!< TPI FFSR: FtStoppedՕ */

#define TPI_FFSR_FlInProg_Pos				0											/*!< TPI FFSR: FlInProgʒu */
#define TPI_FFSR_FlInProg_Msk				(0x1UL << TPI_FFSR_FlInProg_Pos)			/*!< TPI FFSR: FlInProgՕ */

/* TPI `Ɣjڼ޽` */
#define TPI_FFCR_TrigIn_Pos					8											/*!< TPI FFCR: TrigInʒu */
#define TPI_FFCR_TrigIn_Msk					(0x1UL << TPI_FFCR_TrigIn_Pos)				/*!< TPI FFCR: TrigInՕ */

#define TPI_FFCR_EnFCont_Pos				1											/*!< TPI FFCR: EnFContʒu */
#define TPI_FFCR_EnFCont_Msk				(0x1UL << TPI_FFCR_EnFCont_Pos)				/*!< TPI FFCR: EnFContՕ */

/* TPI TRIGGERڼ޽` */
#define TPI_TRIGGER_TRIGGER_Pos				0											/*!< TPI TRIGGER: TRIGGERʒu */
#define TPI_TRIGGER_TRIGGER_Msk				(0x1UL << TPI_TRIGGER_TRIGGER_Pos)			/*!< TPI TRIGGER: TRIGGERՕ */

/* TPI ETMް ڼ޽`(FIFO0) */
#define TPI_FIFO0_ITM_ATVALID_Pos			29											/*!< TPI FIFO0: ITM_ATVALIDʒu */
#define TPI_FIFO0_ITM_ATVALID_Msk			(0x3UL << TPI_FIFO0_ITM_ATVALID_Pos)		/*!< TPI FIFO0: ITM_ATVALIDՕ */

#define TPI_FIFO0_ITM_bytecount_Pos			27											/*!< TPI FIFO0: ITM_bytecountʒu */
#define TPI_FIFO0_ITM_bytecount_Msk			(0x3UL << TPI_FIFO0_ITM_bytecount_Pos)		/*!< TPI FIFO0: ITM_bytecountՕ */

#define TPI_FIFO0_ETM_ATVALID_Pos			26											/*!< TPI FIFO0: ETM_ATVALIDʒu */
#define TPI_FIFO0_ETM_ATVALID_Msk			(0x3UL << TPI_FIFO0_ETM_ATVALID_Pos)		/*!< TPI FIFO0: ETM_ATVALIDՕ */

#define TPI_FIFO0_ETM_bytecount_Pos			24											/*!< TPI FIFO0: ETM_bytecountʒu */
#define TPI_FIFO0_ETM_bytecount_Msk			(0x3UL << TPI_FIFO0_ETM_bytecount_Pos)		/*!< TPI FIFO0: ETM_bytecountՕ */

#define TPI_FIFO0_ETM2_Pos					16											/*!< TPI FIFO0: ETM2ʒu */
#define TPI_FIFO0_ETM2_Msk					(0xFFUL << TPI_FIFO0_ETM2_Pos)				/*!< TPI FIFO0: ETM2Օ */

#define TPI_FIFO0_ETM1_Pos					8											/*!< TPI FIFO0: ETM1ʒu */
#define TPI_FIFO0_ETM1_Msk					(0xFFUL << TPI_FIFO0_ETM1_Pos)				/*!< TPI FIFO0: ETM1Օ */

#define TPI_FIFO0_ETM0_Pos					0											/*!< TPI FIFO0: ETM0ʒu */
#define TPI_FIFO0_ETM0_Msk					(0xFFUL << TPI_FIFO0_ETM0_Pos)				/*!< TPI FIFO0: ETM0Օ */

/* TPI ITATBCTR2ڼ޽` */
#define TPI_ITATBCTR2_ATREADY_Pos			0											/*!< TPI ITATBCTR2: ATREADYʒu */
#define TPI_ITATBCTR2_ATREADY_Msk			(0x1UL << TPI_ITATBCTR2_ATREADY_Pos)		/*!< TPI ITATBCTR2: ATREADYՕ */

/* TPI ITMް ڼ޽`(FIFO1) */
#define TPI_FIFO1_ITM_ATVALID_Pos			29											/*!< TPI FIFO1: ITM_ATVALIDʒu */
#define TPI_FIFO1_ITM_ATVALID_Msk			(0x3UL << TPI_FIFO1_ITM_ATVALID_Pos)		/*!< TPI FIFO1: ITM_ATVALIDՕ */

#define TPI_FIFO1_ITM_bytecount_Pos			27											/*!< TPI FIFO1: ITM_bytecountʒu */
#define TPI_FIFO1_ITM_bytecount_Msk			(0x3UL << TPI_FIFO1_ITM_bytecount_Pos)		/*!< TPI FIFO1: ITM_bytecountՕ */

#define TPI_FIFO1_ETM_ATVALID_Pos			26											/*!< TPI FIFO1: ETM_ATVALIDʒu */
#define TPI_FIFO1_ETM_ATVALID_Msk			(0x3UL << TPI_FIFO1_ETM_ATVALID_Pos)		/*!< TPI FIFO1: ETM_ATVALIDՕ */

#define TPI_FIFO1_ETM_bytecount_Pos			24											/*!< TPI FIFO1: ETM_bytecountʒu */
#define TPI_FIFO1_ETM_bytecount_Msk			(0x3UL << TPI_FIFO1_ETM_bytecount_Pos)		/*!< TPI FIFO1: ETM_bytecountՕ */

#define TPI_FIFO1_ITM2_Pos					16											/*!< TPI FIFO1: ITM2ʒu */
#define TPI_FIFO1_ITM2_Msk					(0xFFUL << TPI_FIFO1_ITM2_Pos)				/*!< TPI FIFO1: ITM2Օ */

#define TPI_FIFO1_ITM1_Pos					8											/*!< TPI FIFO1: ITM1ʒu */
#define TPI_FIFO1_ITM1_Msk					(0xFFUL << TPI_FIFO1_ITM1_Pos)				/*!< TPI FIFO1: ITM1Օ */

#define TPI_FIFO1_ITM0_Pos					0											/*!< TPI FIFO1: ITM0ʒu */
#define TPI_FIFO1_ITM0_Msk					(0xFFUL << TPI_FIFO1_ITM0_Pos)				/*!< TPI FIFO1: ITM0Օ */

/* TPI ITATBCTR0ڼ޽` */
#define TPI_ITATBCTR0_ATREADY_Pos			0											/*!< TPI ITATBCTR0: ATREADYʒu */
#define TPI_ITATBCTR0_ATREADY_Msk			(0x1UL << TPI_ITATBCTR0_ATREADY_Pos)		/*!< TPI ITATBCTR0: ATREADYՕ */

/* TPI 쐧ڼ޽` */
#define TPI_ITCTRL_Mode_Pos					0											/*!< TPI ITCTRL: Modeʒu */
#define TPI_ITCTRL_Mode_Msk					(0x1UL << TPI_ITCTRL_Mode_Pos)				/*!< TPI ITCTRL: ModeՕ */

/* TPI DEVIDڼ޽` */
#define TPI_DEVID_NRZVALID_Pos				11											/*!< TPI DEVID: NRZVALIDʒu */
#define TPI_DEVID_NRZVALID_Msk				(0x1UL << TPI_DEVID_NRZVALID_Pos)			/*!< TPI DEVID: NRZVALIDՕ */

#define TPI_DEVID_MANCVALID_Pos				10											/*!< TPI DEVID: MANCVALIDʒu */
#define TPI_DEVID_MANCVALID_Msk				(0x1UL << TPI_DEVID_MANCVALID_Pos)			/*!< TPI DEVID: MANCVALIDՕ */

#define TPI_DEVID_PTINVALID_Pos				9											/*!< TPI DEVID: PTINVALIDʒu */
#define TPI_DEVID_PTINVALID_Msk				(0x1UL << TPI_DEVID_PTINVALID_Pos)			/*!< TPI DEVID: PTINVALIDՕ */

#define TPI_DEVID_MinBufSz_Pos				6											/*!< TPI DEVID: MinBufSzʒu */
#define TPI_DEVID_MinBufSz_Msk				(0x7UL << TPI_DEVID_MinBufSz_Pos)			/*!< TPI DEVID: MinBufSzՕ */

#define TPI_DEVID_AsynClkIn_Pos				5											/*!< TPI DEVID: AsynClkInʒu */
#define TPI_DEVID_AsynClkIn_Msk				(0x1UL << TPI_DEVID_AsynClkIn_Pos)			/*!< TPI DEVID: AsynClkInՕ */

#define TPI_DEVID_NrTraceInput_Pos			0											/*!< TPI DEVID: NrTraceInputʒu */
#define TPI_DEVID_NrTraceInput_Msk			(0x1FUL << TPI_DEVID_NrTraceInput_Pos)		/*!< TPI DEVID: NrTraceInputՕ */

/* TPI DEVTYPEڼ޽` */
#define TPI_DEVTYPE_SubType_Pos				0											/*!< TPI DEVTYPE: SubTypeʒu */
#define TPI_DEVTYPE_SubType_Msk				(0xFUL << TPI_DEVTYPE_SubType_Pos)			/*!< TPI DEVTYPE: SubTypeՕ */

#define TPI_DEVTYPE_MajorType_Pos			4											/*!< TPI DEVTYPE: MajorTypeʒu */
#define TPI_DEVTYPE_MajorType_Msk			(0xFUL << TPI_DEVTYPE_MajorType_Pos)		/*!< TPI DEVTYPE: MajorTypeՕ */

/*@}*/ /* CMSIS_TPIQI */


#if (__MPU_PRESENT == 1)
/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_MPU ؕی암(MPU)
    \brief    ؕی암(MPU)p^`
  @{
 */

/** \brief ؕی암(MPU)𱸾邽߂̍\̌^
 */
typedef struct
{
	__I  uint32_t TYPE;						/*!< ψ: 0x000 (R/ )  MPU `ڼ޽ */
	__IO uint32_t CTRL;						/*!< ψ: 0x004 (R/W)  MPU ڼ޽ */
	__IO uint32_t RNR; 						/*!< ψ: 0x008 (R/W)  MPU ̈RNRberڼ޽ */
	__IO uint32_t RBAR;						/*!< ψ: 0x00C (R/W)  MPU ̈ڽ ڼ޽ */
	__IO uint32_t RASR;						/*!< ψ: 0x010 (R/W)  MPU ̈摮/eڼ޽ */
	__IO uint32_t RBAR_A1;					/*!< ψ: 0x014 (R/W)  MPU ʖ1̈ڽ ڼ޽ */
	__IO uint32_t RASR_A1;					/*!< ψ: 0x018 (R/W)  MPU ʖ1̈摮/eڼ޽ */
	__IO uint32_t RBAR_A2;					/*!< ψ: 0x01C (R/W)  MPU ʖ2̈ڽ ڼ޽ */
	__IO uint32_t RASR_A2;					/*!< ψ: 0x020 (R/W)  MPU ʖ2̈摮/eڼ޽ */
	__IO uint32_t RBAR_A3;					/*!< ψ: 0x024 (R/W)  MPU ʖ3̈ڽ ڼ޽ */
	__IO uint32_t RASR_A3;					/*!< ψ: 0x028 (R/W)  MPU ʖ3̈摮/eڼ޽ */
} MPU_Type;

/* MPU `ڼ޽ */
#define MPU_TYPE_IREGION_Pos				16   										/*!< MPU TYPE: IREGIONʒu */
#define MPU_TYPE_IREGION_Msk				(0xFFUL << MPU_TYPE_IREGION_Pos)			/*!< MPU TYPE: IREGIONՕ */

#define MPU_TYPE_DREGION_Pos				8   										/*!< MPU TYPE: DREGIONʒu */
#define MPU_TYPE_DREGION_Msk				(0xFFUL << MPU_TYPE_DREGION_Pos)			/*!< MPU TYPE: DREGIONՕ */

#define MPU_TYPE_SEPARATE_Pos				0   										/*!< MPU TYPE: SEPARATEʒu */
#define MPU_TYPE_SEPARATE_Msk				(1UL << MPU_TYPE_SEPARATE_Pos)				/*!< MPU TYPE: SEPARATEՕ */

/* MPU ڼ޽ */
#define MPU_CTRL_PRIVDEFENA_Pos				2   										/*!< MPU CTRL: PRIVDEFENAʒu */
#define MPU_CTRL_PRIVDEFENA_Msk				(1UL << MPU_CTRL_PRIVDEFENA_Pos)			/*!< MPU CTRL: PRIVDEFENAՕ */

#define MPU_CTRL_HFNMIENA_Pos				1   										/*!< MPU CTRL: HFNMIENAʒu */
#define MPU_CTRL_HFNMIENA_Msk				(1UL << MPU_CTRL_HFNMIENA_Pos)				/*!< MPU CTRL: HFNMIENAՕ */

#define MPU_CTRL_ENABLE_Pos					0   										/*!< MPU CTRL: ENABLEʒu */
#define MPU_CTRL_ENABLE_Msk					(1UL << MPU_CTRL_ENABLE_Pos)				/*!< MPU CTRL: ENABLEՕ */

/* MPU ̈ԍڼ޽ */
#define MPU_RNR_REGION_Pos					0   										/*!< MPU RNR: REGIONʒu */
#define MPU_RNR_REGION_Msk					(0xFFUL << MPU_RNR_REGION_Pos)				/*!< MPU RNR: REGIONՕ */

/* MPU ̈ڽ ڼ޽ */
#define MPU_RBAR_ADDR_Pos					5   										/*!< MPU RBAR: ADDRʒu */
#define MPU_RBAR_ADDR_Msk					(0x7FFFFFFUL << MPU_RBAR_ADDR_Pos)			/*!< MPU RBAR: ADDRՕ */

#define MPU_RBAR_VALID_Pos					4   										/*!< MPU RBAR: VALIDʒu */
#define MPU_RBAR_VALID_Msk					(1UL << MPU_RBAR_VALID_Pos)					/*!< MPU RBAR: VALIDՕ */

#define MPU_RBAR_REGION_Pos					0   										/*!< MPU RBAR: REGIONʒu */
#define MPU_RBAR_REGION_Msk					(0xFUL << MPU_RBAR_REGION_Pos)				/*!< MPU RBAR: REGIONՕ */

/* MPU ̈摮/eڼ޽ */
#define MPU_RASR_ATTRS_Pos					16   										/*!< MPU RASR: MPU ̈摮̈ʒu */
#define MPU_RASR_ATTRS_Msk					(0xFFFFUL << MPU_RASR_ATTRS_Pos)			/*!< MPU RASR: MPU ̈摮̈Օ */

#define MPU_RASR_SRD_Pos					8   										/*!< MPU RASR: ̈֎~ʒu */
#define MPU_RASR_SRD_Msk					(0xFFUL << MPU_RASR_SRD_Pos)				/*!< MPU RASR: ̈֎~Օ */

#define MPU_RASR_SIZE_Pos					1   										/*!< MPU RASR: ̈eʗ̈ʒu */
#define MPU_RASR_SIZE_Msk					(0x1FUL << MPU_RASR_SIZE_Pos)				/*!< MPU RASR: ̈eʗ̈Օ */

#define MPU_RASR_ENABLE_Pos					0   										/*!< MPU RASR: ̈拖ޯĈʒu */
#define MPU_RASR_ENABLE_Msk					(1UL << MPU_RASR_ENABLE_Pos)				/*!< MPU RASR: ̈拖ޯĎՕ */

/*@} CMSIS_MPUQI */
#endif


#if (__FPU_PRESENT == 1)
/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_FPU _(FPU)
    \brief    _(FPU)p^`
  @{
 */

/** \brief _(FPU)𱸾邽߂̍\̌^
 */
typedef struct
{
		 uint32_t RESERVED0[1];
	__IO uint32_t FPCCR;					/*!< ψ: 0x004 (R/W) _ڼ޽ */
	__IO uint32_t FPCAR;					/*!< ψ: 0x008 (R/W) _ڽ ڼ޽ */
	__IO uint32_t FPDSCR;					/*!< ψ: 0x00C (R/W) _Ԑڼ޽ */
	__I  uint32_t MVFR0;					/*!< ψ: 0x010 (R/ ) }̂FP@\ڼ޽0 */
	__I  uint32_t MVFR1;					/*!< ψ: 0x014 (R/ ) }̂FP@\ڼ޽1 */
} FPU_Type;

/* _ڼ޽ */
#define FPU_FPCCR_ASPEN_Pos					31   										/*!< FPCCR: ASPENޯĈʒu */
#define FPU_FPCCR_ASPEN_Msk					(1UL << FPU_FPCCR_ASPEN_Pos)				/*!< FPCCR: ASPENޯĎՕ */

#define FPU_FPCCR_LSPEN_Pos					30   										/*!< FPCCR: LSPENʒu */
#define FPU_FPCCR_LSPEN_Msk					(1UL << FPU_FPCCR_LSPEN_Pos)				/*!< FPCCR: LSPENޯĎՕ */

#define FPU_FPCCR_MONRDY_Pos				8   										/*!< FPCCR: MONRDYʒu */
#define FPU_FPCCR_MONRDY_Msk				(1UL << FPU_FPCCR_MONRDY_Pos)				/*!< FPCCR: MONRDYޯĎՕ */

#define FPU_FPCCR_BFRDY_Pos					6   										/*!< FPCCR: BFRDYʒu */
#define FPU_FPCCR_BFRDY_Msk					(1UL << FPU_FPCCR_BFRDY_Pos)				/*!< FPCCR: BFRDYޯĎՕ */

#define FPU_FPCCR_MMRDY_Pos					5   										/*!< FPCCR: MMRDYʒu */
#define FPU_FPCCR_MMRDY_Msk					(1UL << FPU_FPCCR_MMRDY_Pos)				/*!< FPCCR: MMRDYޯĎՕ */

#define FPU_FPCCR_HFRDY_Pos					4   										/*!< FPCCR: HFRDYʒu */
#define FPU_FPCCR_HFRDY_Msk					(1UL << FPU_FPCCR_HFRDY_Pos)				/*!< FPCCR: HFRDYޯĎՕ */

#define FPU_FPCCR_THREAD_Pos				3   										/*!< FPCCR: ۾ޯĈʒu */
#define FPU_FPCCR_THREAD_Msk				(1UL << FPU_FPCCR_THREAD_Pos)				/*!< FPCCR: ۾슈ޯĎՕ */

#define FPU_FPCCR_USER_Pos					1   										/*!< FPCCR: ޯĈʒu */
#define FPU_FPCCR_USER_Msk					(1UL << FPU_FPCCR_USER_Pos)					/*!< FPCCR: ޯĎՕ */

#define FPU_FPCCR_LSPACT_Pos				0   										/*!< FPCCR: ݏdԖh~ޯĈʒu */
#define FPU_FPCCR_LSPACT_Msk				(1UL << FPU_FPCCR_LSPACT_Pos)				/*!< FPCCR: ݏdԖh~ޯĎՕ */

/* _ڽ ڼ޽ */
#define FPU_FPCAR_ADDRESS_Pos				3   										/*!< FPCAR: ADDRESSޯĈʒu */
#define FPU_FPCAR_ADDRESS_Msk				(0x1FFFFFFFUL << FPU_FPCAR_ADDRESS_Pos)		/*!< FPCAR: ADDRESSޯĎՕ */

/* _Ԑڼ޽ */
#define FPU_FPDSCR_AHP_Pos					26   										/*!< FPDSCR: AHPޯĈʒu */
#define FPU_FPDSCR_AHP_Msk					(1UL << FPU_FPDSCR_AHP_Pos) 				/*!< FPDSCR: AHPޯĎՕ */

#define FPU_FPDSCR_DN_Pos					25   										/*!< FPDSCR: DNޯĈʒu */
#define FPU_FPDSCR_DN_Msk					(1UL << FPU_FPDSCR_DN_Pos)					/*!< FPDSCR: DNޯĎՕ */

#define FPU_FPDSCR_FZ_Pos					24   										/*!< FPDSCR: FZޯĈʒu */
#define FPU_FPDSCR_FZ_Msk					(1UL << FPU_FPDSCR_FZ_Pos)					/*!< FPDSCR: FZޯĎՕ */

#define FPU_FPDSCR_RMode_Pos				22   										/*!< FPDSCR: RModeޯĈʒu */
#define FPU_FPDSCR_RMode_Msk				(3UL << FPU_FPDSCR_RMode_Pos)				/*!< FPDSCR: RModeޯĎՕ */

/* }̂FP@\ڼ޽0 */
#define FPU_MVFR0_FP_rounding_modes_Pos		28   										/*!< MVFR0: FPۂߓ`ޯĈʒu */
#define FPU_MVFR0_FP_rounding_modes_Msk		(0xFUL << FPU_MVFR0_FP_rounding_modes_Pos)	/*!< MVFR0: FPۂߓ`ޯĎՕ */

#define FPU_MVFR0_Short_vectors_Pos			24   										/*!< MVFR0: Z޸ ޯĈʒu */
#define FPU_MVFR0_Short_vectors_Msk			(0xFUL << FPU_MVFR0_Short_vectors_Pos)		/*!< MVFR0: Z޸ ޯĎՕ */

#define FPU_MVFR0_Square_root_Pos			20   										/*!< MVFR0: ޯĈʒu */
#define FPU_MVFR0_Square_root_Msk			(0xFUL << FPU_MVFR0_Square_root_Pos)		/*!< MVFR0: ޯĎՕ */

#define FPU_MVFR0_Divide_Pos				16   										/*!< MVFR0: ZޯĈʒu */
#define FPU_MVFR0_Divide_Msk				(0xFUL << FPU_MVFR0_Divide_Pos)				/*!< MVFR0: ZޯĎՕ */

#define FPU_MVFR0_FP_excep_trapping_Pos		12   										/*!< MVFR0: FPOߑޯĈʒu */
#define FPU_MVFR0_FP_excep_trapping_Msk		(0xFUL << FPU_MVFR0_FP_excep_trapping_Pos)	/*!< MVFR0: FPOߑޯĎՕ */

#define FPU_MVFR0_Double_precision_Pos		8   										/*!< MVFR0: {xޯĈʒu */
#define FPU_MVFR0_Double_precision_Msk		(0xFUL << FPU_MVFR0_Double_precision_Pos)	/*!< MVFR0: {xޯĎՕ */

#define FPU_MVFR0_Single_precision_Pos		4   										/*!< MVFR0: PxޯĈʒu */
#define FPU_MVFR0_Single_precision_Msk		(0xFUL << FPU_MVFR0_Single_precision_Pos)	/*!< MVFR0: PxޯĎՕ */

#define FPU_MVFR0_A_SIMD_registers_Pos		0   										/*!< MVFR0: A_SIMDڼ޽ ޯĈʒu */
#define FPU_MVFR0_A_SIMD_registers_Msk		(0xFUL << FPU_MVFR0_A_SIMD_registers_Pos)	/*!< MVFR0: A_SIMDڼ޽ ޯĎՕ */

/* }̂FP@\ڼ޽1 */
#define FPU_MVFR1_FP_fused_MAC_Pos			28   										/*!< MVFR1: FPMACޯĈʒu */
#define FPU_MVFR1_FP_fused_MAC_Msk			(0xFUL << FPU_MVFR1_FP_fused_MAC_Pos)		/*!< MVFR1: FPMACޯĎՕ */

#define FPU_MVFR1_FP_HPFP_Pos				24   										/*!< MVFR1: FP HPFPޯĈʒu */
#define FPU_MVFR1_FP_HPFP_Msk				(0xFUL << FPU_MVFR1_FP_HPFP_Pos)			/*!< MVFR1: FP HPFPޯĎՕ */

#define FPU_MVFR1_D_NaN_mode_Pos			4   										/*!< MVFR1: D_NaN`ޯĈʒu */
#define FPU_MVFR1_D_NaN_mode_Msk			(0xFUL << FPU_MVFR1_D_NaN_mode_Pos)			/*!< MVFR1: D_NaN`ޯĎՕ */

#define FPU_MVFR1_FtZ_mode_Pos				0   										/*!< MVFR1: FtZ`ޯĈʒu */
#define FPU_MVFR1_FtZ_mode_Msk				(0xFUL << FPU_MVFR1_FtZ_mode_Pos)			/*!< MVFR1: FtZ`ޯĎՕ */

/*@} CMSIS_FPUQI */
#endif


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_CoreDebug jޯ ڼ޽(CoreDebug)
    \brief    jޯ ڼ޽p^`
  @{
 */

/** \brief jޯ ڼ޽(CoreDebug)𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t DHCSR;					/*!< ψ: 0x000 (R/W) ޯޒ~/ڼ޽ */
  __O  uint32_t DCRSR;						/*!< ψ: 0x004 ( /W) ޯފjڼ޽Iڼ޽ */
	__IO uint32_t DCRDR;					/*!< ψ: 0x008 (R/W) ޯފjڼ޽ ް ڼ޽ */
	__IO uint32_t DEMCR;					/*!< ψ: 0x00C (R/W) ޯޗO/ڼ޽ */
} CoreDebug_Type;

/* ޯޒ~/ڼ޽ */
#define CoreDebug_DHCSR_DBGKEY_Pos			16   										/*!< CoreDebug DHCSR: DBGKEYʒu */
#define CoreDebug_DHCSR_DBGKEY_Msk			(0xFFFFUL << CoreDebug_DHCSR_DBGKEY_Pos)	/*!< CoreDebug DHCSR: DBGKEYՕ */

#define CoreDebug_DHCSR_S_RESET_ST_Pos		25   										/*!< CoreDebug DHCSR: S_RESET_STʒu */
#define CoreDebug_DHCSR_S_RESET_ST_Msk		(1UL << CoreDebug_DHCSR_S_RESET_ST_Pos)		/*!< CoreDebug DHCSR: S_RESET_STՕ */

#define CoreDebug_DHCSR_S_RETIRE_ST_Pos		24   										/*!< CoreDebug DHCSR: S_RETIRE_STʒu */
#define CoreDebug_DHCSR_S_RETIRE_ST_Msk		(1UL << CoreDebug_DHCSR_S_RETIRE_ST_Pos)	/*!< CoreDebug DHCSR: S_RETIRE_STՕ */

#define CoreDebug_DHCSR_S_LOCKUP_Pos		19   										/*!< CoreDebug DHCSR: S_LOCKUPʒu */
#define CoreDebug_DHCSR_S_LOCKUP_Msk		(1UL << CoreDebug_DHCSR_S_LOCKUP_Pos)		/*!< CoreDebug DHCSR: S_LOCKUPՕ */

#define CoreDebug_DHCSR_S_SLEEP_Pos			18   										/*!< CoreDebug DHCSR: S_SLEEPʒu */
#define CoreDebug_DHCSR_S_SLEEP_Msk			(1UL << CoreDebug_DHCSR_S_SLEEP_Pos)		/*!< CoreDebug DHCSR: S_SLEEPՕ */

#define CoreDebug_DHCSR_S_HALT_Pos			17   										/*!< CoreDebug DHCSR: S_HALTʒu */
#define CoreDebug_DHCSR_S_HALT_Msk			(1UL << CoreDebug_DHCSR_S_HALT_Pos)			/*!< CoreDebug DHCSR: S_HALTՕ */

#define CoreDebug_DHCSR_S_REGRDY_Pos		16   										/*!< CoreDebug DHCSR: S_REGRDYʒu */
#define CoreDebug_DHCSR_S_REGRDY_Msk		(1UL << CoreDebug_DHCSR_S_REGRDY_Pos)		/*!< CoreDebug DHCSR: S_REGRDYՕ */

#define CoreDebug_DHCSR_C_SNAPSTALL_Pos		5   										/*!< CoreDebug DHCSR: C_SNAPSTALLʒu */
#define CoreDebug_DHCSR_C_SNAPSTALL_Msk		(1UL << CoreDebug_DHCSR_C_SNAPSTALL_Pos)	/*!< CoreDebug DHCSR: C_SNAPSTALLՕ */

#define CoreDebug_DHCSR_C_MASKINTS_Pos		3   										/*!< CoreDebug DHCSR: C_MASKINTSʒu */
#define CoreDebug_DHCSR_C_MASKINTS_Msk		(1UL << CoreDebug_DHCSR_C_MASKINTS_Pos)		/*!< CoreDebug DHCSR: C_MASKINTSՕ */

#define CoreDebug_DHCSR_C_STEP_Pos			2   										/*!< CoreDebug DHCSR: C_STEPʒu */
#define CoreDebug_DHCSR_C_STEP_Msk			(1UL << CoreDebug_DHCSR_C_STEP_Pos)			/*!< CoreDebug DHCSR: C_STEPՕ */

#define CoreDebug_DHCSR_C_HALT_Pos			1   										/*!< CoreDebug DHCSR: C_HALTʒu */
#define CoreDebug_DHCSR_C_HALT_Msk			(1UL << CoreDebug_DHCSR_C_HALT_Pos)			/*!< CoreDebug DHCSR: C_HALTՕ */

#define CoreDebug_DHCSR_C_DEBUGEN_Pos		0   										/*!< CoreDebug DHCSR: C_DEBUGENʒu */
#define CoreDebug_DHCSR_C_DEBUGEN_Msk		(1UL << CoreDebug_DHCSR_C_DEBUGEN_Pos)		/*!< CoreDebug DHCSR: C_DEBUGENՕ */

/* ޯފjڼ޽Iڼ޽ */
#define CoreDebug_DCRSR_REGWnR_Pos			16   										/*!< CoreDebug DCRSR: REGWnRʒu */
#define CoreDebug_DCRSR_REGWnR_Msk			(1UL << CoreDebug_DCRSR_REGWnR_Pos)			/*!< CoreDebug DCRSR: REGWnRՕ */

#define CoreDebug_DCRSR_REGSEL_Pos			0   										/*!< CoreDebug DCRSR: REGSELʒu */
#define CoreDebug_DCRSR_REGSEL_Msk			(0x1FUL << CoreDebug_DCRSR_REGSEL_Pos)		/*!< CoreDebug DCRSR: REGSELՕ */

/* ޯޗO/ڼ޽ */
#define CoreDebug_DEMCR_TRCENA_Pos			24   										/*!< CoreDebug DEMCR: TRCENAʒu */
#define CoreDebug_DEMCR_TRCENA_Msk			(1UL << CoreDebug_DEMCR_TRCENA_Pos)			/*!< CoreDebug DEMCR: TRCENAՕ */

#define CoreDebug_DEMCR_MON_REQ_Pos			19   										/*!< CoreDebug DEMCR: MON_REQʒu */
#define CoreDebug_DEMCR_MON_REQ_Msk			(1UL << CoreDebug_DEMCR_MON_REQ_Pos)		/*!< CoreDebug DEMCR: MON_REQՕ */

#define CoreDebug_DEMCR_MON_STEP_Pos		18   										/*!< CoreDebug DEMCR: MON_STEPʒu */
#define CoreDebug_DEMCR_MON_STEP_Msk		(1UL << CoreDebug_DEMCR_MON_STEP_Pos)		/*!< CoreDebug DEMCR: MON_STEPՕ */

#define CoreDebug_DEMCR_MON_PEND_Pos		17   										/*!< CoreDebug DEMCR: MON_PENDʒu */
#define CoreDebug_DEMCR_MON_PEND_Msk		(1UL << CoreDebug_DEMCR_MON_PEND_Pos)		/*!< CoreDebug DEMCR: MON_PENDՕ */

#define CoreDebug_DEMCR_MON_EN_Pos			16   										/*!< CoreDebug DEMCR: MON_ENʒu */
#define CoreDebug_DEMCR_MON_EN_Msk			(1UL << CoreDebug_DEMCR_MON_EN_Pos)			/*!< CoreDebug DEMCR: MON_ENՕ */

#define CoreDebug_DEMCR_VC_HARDERR_Pos		10   										/*!< CoreDebug DEMCR: VC_HARDERRʒu */
#define CoreDebug_DEMCR_VC_HARDERR_Msk		(1UL << CoreDebug_DEMCR_VC_HARDERR_Pos)		/*!< CoreDebug DEMCR: VC_HARDERRՕ */

#define CoreDebug_DEMCR_VC_INTERR_Pos		9   										/*!< CoreDebug DEMCR: VC_INTERRʒu */
#define CoreDebug_DEMCR_VC_INTERR_Msk		(1UL << CoreDebug_DEMCR_VC_INTERR_Pos)		/*!< CoreDebug DEMCR: VC_INTERRՕ */

#define CoreDebug_DEMCR_VC_BUSERR_Pos		8   										/*!< CoreDebug DEMCR: VC_BUSERRʒu */
#define CoreDebug_DEMCR_VC_BUSERR_Msk		(1UL << CoreDebug_DEMCR_VC_BUSERR_Pos)		/*!< CoreDebug DEMCR: VC_BUSERRՕ */

#define CoreDebug_DEMCR_VC_STATERR_Pos		7   										/*!< CoreDebug DEMCR: VC_STATERRʒu */
#define CoreDebug_DEMCR_VC_STATERR_Msk		(1UL << CoreDebug_DEMCR_VC_STATERR_Pos)		/*!< CoreDebug DEMCR: VC_STATERRՕ */

#define CoreDebug_DEMCR_VC_CHKERR_Pos		6   										/*!< CoreDebug DEMCR: VC_CHKERRʒu */
#define CoreDebug_DEMCR_VC_CHKERR_Msk		(1UL << CoreDebug_DEMCR_VC_CHKERR_Pos)		/*!< CoreDebug DEMCR: VC_CHKERRՕ */

#define CoreDebug_DEMCR_VC_NOCPERR_Pos		5   										/*!< CoreDebug DEMCR: VC_NOCPERRʒu */
#define CoreDebug_DEMCR_VC_NOCPERR_Msk		(1UL << CoreDebug_DEMCR_VC_NOCPERR_Pos)		/*!< CoreDebug DEMCR: VC_NOCPERRՕ */

#define CoreDebug_DEMCR_VC_MMERR_Pos		4   										/*!< CoreDebug DEMCR: VC_MMERRʒu */
#define CoreDebug_DEMCR_VC_MMERR_Msk		(1UL << CoreDebug_DEMCR_VC_MMERR_Pos)		/*!< CoreDebug DEMCR: VC_MMERRՕ */

#define CoreDebug_DEMCR_VC_CORERESET_Pos	0   										/*!< CoreDebug DEMCR: VC_CORERESETʒu */
#define CoreDebug_DEMCR_VC_CORERESET_Msk	(1UL << CoreDebug_DEMCR_VC_CORERESET_Pos)	/*!< CoreDebug DEMCR: VC_CORERESETՕ */

/*@} CMSIS_CoreDebugQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_core_base j`
    \brief    ڽAṕA\̗p`
  @{
 */

/* Cortex-M4ʰ޳؊蓖 */
#define SCS_BASE			(0xE000E000UL)							/*!< ѐڽ */
#define ITM_BASE			(0xE0000000UL)							/*!< ITMڽ */
#define DWT_BASE			(0xE0001000UL)							/*!< DWTڽ */
#define TPI_BASE			(0xE0040000UL)							/*!< TPIڽ */
#define CoreDebug_BASE		(0xE000EDF0UL)							/*!< jޯފڽ */
#define SysTick_BASE		(SCS_BASE +  0x0010UL)					/*!< SysTickڽ */
#define NVIC_BASE			(SCS_BASE +  0x0100UL)					/*!< NVICڽ */
#define SCB_BASE			(SCS_BASE +  0x0D00UL)					/*!< ѐ䕔ڽ */

#define SCnSCB				((SCnSCB_Type    *)     SCS_BASE      )	/*!< SCBłȂѐڼ޽ */
#define SCB					((SCB_Type       *)     SCB_BASE      )	/*!< SCB`Ԑݒ\ */
#define SysTick				((SysTick_Type   *)     SysTick_BASE  )	/*!< SysTick`Ԑݒ\ */
#define NVIC				((NVIC_Type      *)     NVIC_BASE     )	/*!< NVIC`Ԑݒ\ */
#define ITM					((ITM_Type       *)     ITM_BASE      )	/*!< ITM`Ԑݒ\ */
#define DWT					((DWT_Type       *)     DWT_BASE      )	/*!< DWT`Ԑݒ\ */
#define TPI					((TPI_Type       *)     TPI_BASE      )	/*!< TPI`Ԑݒ\ */
#define CoreDebug			((CoreDebug_Type *)     CoreDebug_BASE)	/*!< jޯތ`Ԑݒ\ */

#if (__MPU_PRESENT == 1)
  #define MPU_BASE			(SCS_BASE +  0x0D90UL)					/*!< ؕی암 */
  #define MPU				((MPU_Type       *)     MPU_BASE      )	/*!< ؕی암 */
#endif

#if (__FPU_PRESENT == 1)
  #define FPU_BASE			(SCS_BASE +  0x0F30UL)					/*!< _ */
  #define FPU				((FPU_Type       *)     FPU_BASE      )	/*!< _ */
#endif

/*@} */


/*******************************************************************************
 *                ʰ޳ۑw
  j@\̪͈ȉ܂݂܂B:
  - jNVIC֐
  - jSysTick֐
  - jޯފ֐
  - jڼ޽ ֐
 ******************************************************************************/
/** \defgroup CMSIS_Core_FunctionInterface @\Ɩ߂̊
*/


/* ##########################   NVIC֐  #################################### */
/** \ingroup  CMSIS_Core_FunctionInterface
    \defgroup CMSIS_Core_NVICFunctions NVIC֐
    \brief    NVICoRŊ荞݂ƗOǗ֐
    @{
 */

/** \brief D挠Qݒ

  ֐͕KvƂ菇pėD挠Q̈ݒ肵܂BPriorityGroup
  ҰSCB->AIRCR [10:8] PRIGROUP̈蓖Ă܂B0`7̒lgp܂B
  D挠QƗp\ȗD挠ޯ(__NVIC_PRIO_BITS)Ԃł̏Փ˂̏ꍇAł
  \ȗD挠Qݒ肳܂B

    \param[in]  PriorityGroup D挠Q̈
 */
__STATIC_INLINE void NVIC_SetPriorityGrouping(uint32_t PriorityGroup)
{
	uint32_t reg_value;
	uint32_t PriorityGroupTmp = (PriorityGroup & (uint32_t)0x07);	/* 0`7̒lgp܂B */

	reg_value  =  SCB->AIRCR;										/* Âڼ޽`Ԑݒǂݍ */
	reg_value &= ~(SCB_AIRCR_VECTKEY_Msk | SCB_AIRCR_PRIGROUP_Msk);	/* ύX邽߂ޯĉ */
	reg_value  =  (reg_value                                 |
				  ((uint32_t)0x5FA << SCB_AIRCR_VECTKEY_Pos) |
				  (PriorityGroupTmp << 8));							/* ݌ƗD挠Q} */
	SCB->AIRCR =  reg_value;
}


/** \brief D挠Q擾

    ֐NVIC荞ݐ킩D挠Q̈ǂ݂܂B

    \return D挠Q̈(SCB->AIRCR [10:8] PRIGROUP̈)
 */
__STATIC_INLINE uint32_t NVIC_GetPriorityGrouping(void)
{
	return ((SCB->AIRCR & SCB_AIRCR_PRIGROUP_Msk) >> SCB_AIRCR_PRIGROUP_Pos);	/* D挠Q̈ǂݍ */
}

/** \brief O荞݋

    ֐NVIC荞ݐ޲L荞݂܂B

    \param[in]  IRQn O荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_EnableIRQ(IRQn_Type IRQn)
{
/*  NVIC->ISER[((uint32_t)(IRQn) >> 5)] = (1 << ((uint32_t)(IRQn) & 0x1F));  enable interrupt */
	NVIC->ISER[(uint32_t)((int32_t)IRQn) >> 5] = (uint32_t)(1 << ((uint32_t)((int32_t)IRQn) & (uint32_t)0x1F));	/* 荞݋ */
}

/** \brief O荞݋֎~

    ֐NVIC荞ݐ޲L荞݂֎~܂B

    \param[in]  IRQn O荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_DisableIRQ(IRQn_Type IRQn)
{
	NVIC->ICER[((uint32_t)(IRQn) >> 5)] = (1 << ((uint32_t)(IRQn) & 0x1F));	/* 荞݋֎~ */
}

/** \brief ۗ荞݂擾

    ֐NVICŕۗڼ޽ǂŎw肳ꂽ荞݂ɑ΂ۗޯĂԂ܂B

    \param[in]  IRQn 荞ݔԍ

    \return     0    荞݂̏Ԃ͕ۗłȂB
    \return     1    荞݂̏Ԃ͕ۗ
 */
__STATIC_INLINE uint32_t NVIC_GetPendingIRQ(IRQn_Type IRQn)
{
  return((uint32_t) ((NVIC->ISPR[(uint32_t)(IRQn) >> 5] & (1 << ((uint32_t)(IRQn) & 0x1F)))?1:0)); /* ۗȂ1AłȂ0ԂB */
}

/** \brief ۗ荞ݐݒ

    ֐͊O荞݂ۗ̕ޯĂݒ肵܂B

    \param[in]  IRQn 荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_SetPendingIRQ(IRQn_Type IRQn)
{
	NVIC->ISPR[((uint32_t)(IRQn) >> 5)] = (1 << ((uint32_t)(IRQn) & 0x1F));	/* 荞ݕۗݒ */
}


/** \brief ۗ荞݉

    ֐͊O荞݂ۗ̕ޯĂ܂B

    \param[in]  IRQn 荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_ClearPendingIRQ(IRQn_Type IRQn)
{
	NVIC->ICPR[((uint32_t)(IRQn) >> 5)] = (1 << ((uint32_t)(IRQn) & 0x1F));	/* 荞ݕۗ */
}


/** \brief Ȋ荞݂擾

    ֐NVICŊڼ޽ǂŊޯĂԂ܂B

    \param[in]  IRQn 荞ݔԍ

    \return     0    荞݂̏Ԃ͊łȂ
    \return     1    荞݂̏Ԃ͊
 */
__STATIC_INLINE uint32_t NVIC_GetActive(IRQn_Type IRQn)
{
	return((uint32_t)((NVIC->IABR[(uint32_t)(IRQn) >> 5] & (1 << ((uint32_t)(IRQn) & 0x1F)))?1:0));	/* Ȃ1AłȂ0ԂB */
}

/** \brief 荞ݗD挠ݒ

    ֐͊荞݂̗D挠ݒ肵܂B

    \note D挠͑SĂ̊j荞݂ɑ΂Đݒłł͂܂B

    \param[in]  IRQn     荞ݔԍ
    \param[in]  priority ݒ肷D挠
 */
__STATIC_INLINE void NVIC_SetPriority(IRQn_Type IRQn, uint32_t priority)
{
	if(IRQn < 0) {
		SCB->SHP[((uint32_t)(IRQn) & 0xF)-4] = ((priority << (8 - __NVIC_PRIO_BITS)) & 0xff); }	/* Cortex-Mъ荞ݗpD挠ݒ */
	else {
		NVIC->IP[(uint32_t)(IRQn)] = ((priority << (8 - __NVIC_PRIO_BITS)) & 0xff);    }		/* ޲L荞ݗpD挠ݒ */
}

/** \brief 荞ݗD挠擾

    ֐͊荞݂̗D挠ǂ݂܂B荞ݔԍ͊O(޲L)荞݂
    w肷̂ɐɁA(j)荞݂w肷̂ɕɂ邱Ƃł܂B

    \param[in]  IRQn ֒ݔԍ
    \return          荞ݗD挠Blϲ ۰ׂ̎ꂽD挠ޯĂɎ
                     Iɐ񂳂܂B
 */
__STATIC_INLINE uint32_t NVIC_GetPriority(IRQn_Type IRQn)
{

	if(IRQn < 0) {
		return((uint32_t)(SCB->SHP[((uint32_t)(IRQn) & 0xF)-4] >> (8 - __NVIC_PRIO_BITS)));  }	/* Cortex-Mъ荞ݗpD挠擾 */
	else {
		return((uint32_t)(NVIC->IP[(uint32_t)(IRQn)]           >> (8 - __NVIC_PRIO_BITS)));  }	/* ޲L荞ݗpD挠擾 */
}

/** \brief D挠

    ֐͗^ꂽD挠QAD挠lAD挠lŊ荞݂ɑ΂D
    𕄍܂BD挠QƗp\ȗD挠ޯ(__NVIC_PRIO_BITS)Ԃł
    Փ˂̏ꍇAł\ȗD挠Qݒ肳܂B

    \param[in]  PriorityGroup   gpD挠Q
    \param[in]  PreemptPriority (0n܂)D挠l
    \param[in]  SubPriority     (0n܂)D挠l
    \return                     D挠Bl\ref NVIC_SetPriority()֐Ŏgp邱Ƃł܂B
 */
__STATIC_INLINE uint32_t NVIC_EncodePriority (uint32_t PriorityGroup, uint32_t PreemptPriority, uint32_t SubPriority)
{
	uint32_t PriorityGroupTmp = (PriorityGroup & 0x07);		/* 0`7̒lgp܂B */
	uint32_t PreemptPriorityBits;
	uint32_t SubPriorityBits;

	PreemptPriorityBits = ((7 - PriorityGroupTmp) > __NVIC_PRIO_BITS) ? __NVIC_PRIO_BITS : 7 - PriorityGroupTmp;
	SubPriorityBits     = ((PriorityGroupTmp + __NVIC_PRIO_BITS) < 7) ? 0 : PriorityGroupTmp - 7 + __NVIC_PRIO_BITS;

	return (
			((PreemptPriority & ((1 << (PreemptPriorityBits)) - 1)) << SubPriorityBits) |
			((SubPriority     & ((1 << (SubPriorityBits    )) - 1)))
		   );
}

/** \brief D挠

    ֐͗^ꂽD挠QAD挠lAD挠lŊ荞ݗD挠l
    ܂BD挠QƗp\ȗD挠ޯ(__NVIC_PRIO_BITS)Ԃł̏Փ˂̏
    Ał\ȗD挠Qݒ肳܂B

    \param[in]   Priority         \ref NVIC_GetPriority()֐Ŏ擾邱ƂłD挠l
    \param[in]   PriorityGroup    gpD挠Q
    \param[out]  pPreemptPriority (0n܂)D挠l
    \param[out]  pSubPriority     (0n܂)D挠l
 */
__STATIC_INLINE void NVIC_DecodePriority (uint32_t Priority, uint32_t PriorityGroup, uint32_t* pPreemptPriority, uint32_t* pSubPriority)
{
	uint32_t PriorityGroupTmp = (PriorityGroup & 0x07);		/* 0`7̒lgp܂B */
	uint32_t PreemptPriorityBits;
	uint32_t SubPriorityBits;

	PreemptPriorityBits = ((7 - PriorityGroupTmp) > __NVIC_PRIO_BITS) ? __NVIC_PRIO_BITS : 7 - PriorityGroupTmp;
	SubPriorityBits     = ((PriorityGroupTmp + __NVIC_PRIO_BITS) < 7) ? 0 : PriorityGroupTmp - 7 + __NVIC_PRIO_BITS;

	*pPreemptPriority = (Priority >> SubPriorityBits) & ((1 << (PreemptPriorityBits)) - 1);
	*pSubPriority     = (Priority                   ) & ((1 << (SubPriorityBits    )) - 1);
}

/** \brief  ؾ

    ֐MCUؾĂ邽߂ɼ ؾėvn߂܂B
 */
__STATIC_INLINE void NVIC_SystemReset(void)
{
	__DSB();												/* ؾđOɊɏՂꂽ݂܂ޑSĂ̖ ̂ۏ */
	SCB->AIRCR  = ((0x5FA << SCB_AIRCR_VECTKEY_Pos)      |
				   (SCB->AIRCR & SCB_AIRCR_PRIGROUP_Msk) |
				   SCB_AIRCR_SYSRESETREQ_Msk);				/* ωD挠Qێ */
	__DSB();												/*  ̊ۏ */
	while(1);												/* ؾđ҂ */
}

/*@} CMSIS_Core_NVICFunctionsI */



/* ##################################    SysTick֐  ############################################ */
/** \ingroup  CMSIS_Core_FunctionInterface
    \defgroup CMSIS_Core_SysTickFunctions SysTick֐
    \brief    ь`Ԑݒ֐
  @{
 */

#if (__Vendor_SysTickConfig == 0)

/** \brief э`Ԑݒ

    ֐ͼьvƂ̊荞݂AэvJn܂Bv
    ͎IȊ荞݂𐶐邽߂ɎRsłB

    \param[in]  ticks 2̊荞݊Ԃ̍

    \return     0     ֐
    \return     1     ֐s

    \note <b>__Vendor_SysTickConfig</b>ϐ1ɐݒ肳ƁA<b>SysTick_Config
          </b>֐Ͳݸٰނ܂B̏ꍇA<b><i>device</i>.h</b>̧ق͂
          ̊֐̋ғL܂܂Ȃ΂Ȃ܂B

 */
__STATIC_INLINE uint32_t SysTick_Config(uint32_t ticks)
{
	if (ticks > SysTick_LOAD_RELOAD_Msk)  return (1);			/* Đݒls\ */

	SysTick->LOAD  = (ticks & SysTick_LOAD_RELOAD_Msk) - 1;		/* Đݒڼ޽ݒ */
	NVIC_SetPriority (SysTick_IRQn, (1<<__NVIC_PRIO_BITS) - 1);	/* Systick荞ݗpD挠ݒ */
	SysTick->VAL   = 0;											/* SysTickvlݒ */
	SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |
					 SysTick_CTRL_TICKINT_Msk   |
					 SysTick_CTRL_ENABLE_Msk;					/* SysTick荞݂SysTickv */
	return (0);													/* ֐ */
}

#endif

/*@} CMSIS_Core_SysTickFunctionsI */


/* ##################################### ޯޓ/o͊֐ ########################################### */
/** \ingroup  CMSIS_Core_FunctionInterface
    \defgroup CMSIS_core_DebugFunctions ITM֐
    \brief    ITMޯ ̪𱸾֐
  @{
 */

extern volatile int32_t ITM_RxBuffer;					/*!< 󂯎Oϐ */
#define                 ITM_RXBUFFER_EMPTY	0x5AA55AA5	/*!< \ref ITM_RxBufferʂl͎̏̕Ă܂B */


/** \brief ITM M

    ֐TIM0oRŕ𑗐MA
    \li ޯނo͂\肵Ȃޯނɐڑ鎞͒Pɖ߂܂B
    \li ޯނڑ邯ǂAO̕MĂȂ͖W܂B

    \param[in]  ch M镶

    \returns       M镶
 */
__STATIC_INLINE uint32_t ITM_SendChar (uint32_t ch)
{
	if ((ITM->TCR & ITM_TCR_ITMENA_Msk) &&		/* ITM */
	   (ITM->TER & (1UL << 0)        )     )	/* ITM߰#0 */
	{
		while (ITM->PORT[0].u32 == 0);
		ITM->PORT[0].u8 = (uint8_t) ch;
	}
	return (ch);
}

/** \brief  ITM M

    ֐\ref ITM_RxBufferOϐoRŕ͂܂B

    \return  M
    \return  -1       ۗȂ
 */
__STATIC_INLINE int32_t ITM_ReceiveChar (void) {
	int32_t ch = -1;							/* p\ȕȂ */

	if (ITM_RxBuffer != ITM_RXBUFFER_EMPTY) {
		ch = ITM_RxBuffer;
		ITM_RxBuffer = ITM_RXBUFFER_EMPTY;		/* ̕ */
	}

	return (ch);
}

/** \brief ITM 

    ֐͕\ref ITM_RxBufferϐœǂގɑ΂ĕۗǂׂ܂B

    \return  0 p\ȕȂ
    \return  1 p\
 */
__STATIC_INLINE int32_t ITM_CheckChar (void) {

	if (ITM_RxBuffer == ITM_RXBUFFER_EMPTY) {
		return (0);								/* p\ȕȂ */
	} else {
		return (1);								/* p\ */
	}
}

/*@} CMSIS_core_DebugFunctionsI */

#endif /* __CORE_CM4_H_DEPENDANT */

#endif /* __CMSIS_GENERIC */

#ifdef __cplusplus
}
#endif
