/**
 * \file
 *
 * \brief AVR XMEGA XCL(XMEGA_H)쓮
 *
 *
 * 쌠 (C) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _XCL_H_
#define _XCL_H_

#include "compiler.h"
#include "parts.h"
#include "sysclk.h"
#include "sleepmgr.h"
#include "xcl_glue_logic.h"
#include "xcl_timer.h"

#ifdef __cplusplus
extern "C" {
#endif

extern bool xcl_is_synchronous;

/**
 * \defgroup xcl_group XMEGA_H(XCL)
 *
 * See \ref xmega_xcl_quickstart
 *
 * AVR XMEGA_H(XCL)pײނłBXCLPʕ̋A
 * ~A`Ԑݒp̊֐񋟂܂B
 *
 * \image html xcl_block.png
 *
 * XCL2̎ȋ@\ō܂B
 * - \ref xcl_tc_group
 * - \ref xcl_gl_group
 *
 * \section xmega_xcl_common XCL`Ԑݒ
 * XCL/܂͐ڑp_H⏕Pʕ̂ǂ炩̋@\`Ԑݒ܂
 * ͎gp܂
 * XCLײނ͈ȉ̂߂̍\ݒ֐񋟂܂B
 * - xcl_enable()XCL̋
 * - xcl_disable()XCL̋֎~
 * - xcl_port()XCLPʕɐڑXMEGA߰Ă̑I
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - Ӹۯp\ref sysclk_group
 * - ꂽx~̐ݒp\ref sleepmgr_group
 * - dvȺޗ̈Ԃ̊荞݂ISR`Ƌ֎~p\ref interrupt_group
 *
 * @{
 */

/* ! XCL⏕Pʕ̎g */
enum xcl_sub_module_used_t {
	XCL_ASYNCHRONOUS = 1,	/* !< XCL͔񓯊LUT⏕@\gp(gݍ킹) */
	XCL_SYNCHRONOUS  = 2,	/* !< XCL͓@\gp(x܂͌vLUT) */
};

/* ! XCL߰Č`Ԑݒ */
enum xcl_port_sel_t {
	PC = XCL_PORTSEL_PC_gc,	/* !< XCL߰Cɐڑ */
	PD = XCL_PORTSEL_PD_gc,	/* !< XCL߰Dɐڑ */
};

/**
 * \brief XCLPʕ
 *
 * ̊֐͕KvƂXCLۯAҰƂēnXCLgp
 * I(ۂ)ɏ]ĕKvƂx~x~ǗɊ蓖Ă܂BI
 * xcl_disable()֐x~̊蓖ĉ悤ɓ
 * IɊi[܂B
 *
 * \param  mode \ref xcl_sub_module_used_t񋓂gpXCL̓(܂
 *              ͔񓯊)
 */
static inline void xcl_enable(enum xcl_sub_module_used_t mode)
{
	sysclk_enable_peripheral_clock(&XCL);
	if (mode == XCL_ASYNCHRONOUS) {
		sleepmgr_lock_mode(SLEEPMGR_PDOWN);
		xcl_is_synchronous = false;
	} else if (mode == XCL_SYNCHRONOUS) {
		sleepmgr_lock_mode(SLEEPMGR_IDLE);
		xcl_is_synchronous = true;
	}
}

/**
 * \brief XCLPʕ֎~
 *
 * ̊֐XCLۯ֎~Axcl_enable()őI΂ė\ߎ{ꂽx~
 * ̊蓖Ă܂B
 */
static inline void xcl_disable(void)
{
	sysclk_disable_peripheral_clock(&XCL);
	if (xcl_is_synchronous) {
		sleepmgr_unlock_mode(SLEEPMGR_IDLE);
	} else {
		sleepmgr_unlock_mode(SLEEPMGR_PDOWN);
	}
}

/**
 * \brief XCL߰đI
 *
 * ̊֐͑I߰Ăgp悤XCLPʕ`Ԑݒ肵܂B
 *
 * \param  port \ref xcl_port_sel_t񋓂XCLPʕ蓖Ă邽߂XMEGA߰
 */
static inline void xcl_port(enum xcl_port_sel_t port)
{
	XCL.CTRLA &= ~XCL_PORTSEL_gm;
	XCL.CTRLA |= port;
}

/** @} */

#ifdef __cplusplus
}
#endif

/**
 * \page xmega_xcl_quickstart XMEGA XCLײޗpJn̎
 *
 * ͓̎gpʂɑ΂ײނ̌`ԐݒƎgp̕@̒iKIȎxł 
 * \ref xcl_group pJn̎łBޗ͗Ⴆ΁AXCL𐧌䂷邱ƂK
 * vȎ剞pJԂ⑼̉ꂩ̊֐ɕʂ邱Ƃł܂B
 *
 * XCLPʕ2̎vȕ⏕Pʕ琬܂B
 * - \ref xcl_tc_group
 * - \ref xcl_gl_group
 *
 * ̑Jn͐p̎gpʂŗ̕⏕Pʕ̎gԗ܂Begp
 * ʂ͕⏕Pʕ̎gԗ܂Apœɗ̕⏕Pʕ
 * Ɏgp꓾܂B
 *
 *
 * \image html xcl_block.png
 *
 * \section xmega_xcl_qs_use_cases ⏕PʕJn
 * - \subpage xmega_xcl_qs_lut
 * - \subpage xmega_xcl_qs_tc
 */

/** 
 * \page xmega_xcl_qs_lut XORs邽߂XCLڑ_H̎g
 *
 * XCLڑ_H⏕Pʕ͌`Ԑݒ\ȒxvfD^دۯ߂Dׯ̂悤
 * Ȓ_H@\2̐^l\ōĂ܂BXCL2̐ݒ\
 * Qƕ\(LUT)܂BeLUT2̓͊Ԃ̘_IȏɑΉ^l\
 * `܂Bǂ̑gݍ킹@\_H\łBLUT͂I/O݂܂͎
 * ۼтقɐڑ邱Ƃł܂BLUTARSׯA2̔퉉ZqԂ̑gݍ
 * 킹_HƋ̐ڑƂł܂BāAeLUT̓͂܂͏o͂
 * ǂ炩Œxvf(DLY)(ʒuƎ)`Ԑݒ肷邱Ƃł܂BXCL TC
 * ׂāALUTܰ޳ݓ܂őSĂ̋x~œ܂B
 *
 * XCLڑ_Hײފ֐ꎮ͈ȉ̂̕⏕PʕɊ֘ASĂ̗vf̌`
 * Ԑݒ܂B
 * - LUT`I
 * - LUT͂Əo͂̌`Ԑݒ
 * - LUTx`Ԑݒ
 * - LUT@\`Ԑݒ(AND,NAND,OR,NOR,XOR,XNOR,NOT...)
 *
 * ȉ̎gpʂ2̊O݊ԂŘ_XOR@\s悤XCL\ݒ
 * ܂B
 * \image html xcl_example1.png
 *
 * \section xmega_xcl_qs_lut_setup \ݒiK
 *
 * \subsection xmega_xcl_qs_lut_usage_prereq OKv
 *
 * ̒Pʕ \ref clk_group  \ref sleepmgr_group xKvƂ܂B
 * \ref sleepmgr_group x~Ǘ޽̎gp͔CӂłAd͏炷
 * ɐ܂B
 *
 * ȉނɒǉ܂B
 * \code
 *     sysclk_init();
 *     board_init();
 *     sleepmgr_init(); // CӑI
 * \endcode
 * 屲ٌJԂɒǉ܂B
 * \code
 *     sleepmgr_enter_sleep(); // CӑI
 * \endcode
 *
 * \subsection xmega_xcl_qs_lut_setup_code ޗ
 *
 * XCLPʕ̎gpɐ旧A̒Pʕ͋ĐXMEGA߰Ăɐڑ
 * łBxvfSgpꂸALUT`ǂclk_perۯgpȂ
 * ɁAXCLxcl_enable()֐pXCL_ASYNCHRONOUSŋ邱Ƃł
 * ܂Bxcl_port()֐͓XMEGA߰ĂXCLPʕ蓖Ă`Ԑݒ
 * B
 *
 * \code
 * xcl_enable(XCL_ASYNCHRONOUS);
 * xcl_port(PD);
 * \endcode
 * ̌XCLڑ_H`Ԑݒ肷邱Ƃł܂B
 * \code
 * xcl_lut_type(LUT_2LUT2IN);
 * xcl_lut_in0(LUT_IN_PINL);
 * xcl_lut_in1(LUT_IN_PINL);
 * xcl_lut0_output(LUT0_OUT_PIN4);
 * xcl_lut_config_delay(DLY11, LUT_DLY_DISABLE, LUT_DLY_DISABLE);
 * xcl_lut0_truth(XOR);
 * // Őڑ_H̏܂B
 * while(1) {
 *     sleepmgr_enter_sleep(); // CӑI
 * }
 * \endcode
 *
 * \subsection xmega_xcl_qs_lut_setup_code_workflow Ƃ̗
 *
 * -# 񓯊XCLPʕ܂B
 *  - \code xcl_enable(XCL_ASYNCHRONOUS); \endcode
 *  - \note ͕KvƂȂA̒Pʕp̸ۯ т܂B
 * -# XMEGA߰Dg悤XCL`Ԑݒ肵܂B
 *  - \code xcl_port(PD); \endcode
 * -# 2̓Ɨ͂2LUTƂXCLLUT`Ԑݒ肵܂B
 *  - \code xcl_lut_type(LUT_2LUT2IN); \endcode
 *  - \note ̔ďʂł1LUT(LUT0)gpA2LUT(LUT1)͖܂B
 * -# XMEGA߰D̉قgp悤XCLLUT0(IN0IN1)`Ԑݒ肵܂B
 *  - \code xcl_lut_in0(LUT_IN_PINL); \endcode
 *  - \code xcl_lut_in1(LUT_IN_PINL); \endcode
 *  - \note ݔԍ޲ݔzuɂĎw肳܂(ްĂ)B߰D̗:
 *    - ّI: IN0=PD2,IN1=PD0,IN2=PD1,IN3=PD3.
 *    - ّI: IN0=PD6,IN1=PD4,IN2=PD5,IN3=PD7.
 * -# XCLLUTO0o͂XMEGA߰D4݂ƂČ`Ԑݒ肵܂B
 *  - \code xcl_lut0_output(LUT0_OUT_PIN4); \endcode
 * -# XCLxvf(LUT0LUT1ł̒xȂ)`Ԑݒ肵܂B
 *  - \code xcl_lut_config_delay(DLY11, LUT_DLY_DISABLE, LUT_DLY_DISABLE); \endcode
 * -# XCLLUT0XORsɌ`Ԑݒ肵܂B
 *  - \code  xcl_lut0_truth(XOR); \endcode
 * -# XCLڑ_H͂ǂCPUۯ̎gpȂwʂœ܂B
 *  - \code  while(1) {
 *     sleepmgr_enter_sleep(); // CӑI
 * } \endcode
 */

/**
 * \page xmega_xcl_qs_tc ꊄ荞݂𐶐邽߂XCLv⏕Pʕ̎g
 *
 * XCLTC͍L`(WAߊĺAPWMA16ޯĘA/AӋ@\v
 * (PEC)A`)̈ꎮŌ`Ԑݒ肷邱Ƃł28ޯ /łłĂ
 * B
 * 
 * XCLTCײފ֐ꎮ͈ȉ̂̕⏕PʕɊ֘ASĂ̗vf̌`Ԑݒ
 * ܂B
 * - XCLTC`Ƌۯ̌`Ԑݒ
 * - SĂ̓`Ԃł̊荞(Aߊl)Ǘ
 * - vƕߊlḻ
 *
 * ̎gpʂXCLTC16ޯĘA/(BTC16)Ō`Ԑݒ肵Ả
 * ꊄ荞݂gpҒ`Ăі߂֐ĂԂ悤Ɍ`Ԑݒ肵܂B
 *
 * \section xmega_xcl_qs_tc_setup \ݒiK
 *
 * \subsection xmega_xcl_qs_tc_usage_prereq OKv
 *
 * ̒Pʕ \ref clk_group  \ref sleepmgr_group.xKvłB
 * \ref sleepmgr_group sleepmgr ޽̎gp͔CӂłAd͏炷߂
 * ܂B܂A荞݂͂̎gpʂɑ΂ċȂ΂Ȃ܂
 * B
 *
 * ނɈȉǉ܂B
 * \code
 *     sysclk_init();
 *     board_init();
 *     irq_initialize_vectors();
 *     cpu_irq_enable();
 *     sleepmgr_init(); // CӑI
 * \endcode
 * 屲ٌJԂɈȉǉ܂B
 * \code
 *     sleepmgr_enter_sleep(); // CӑI
 * \endcode

 *
 * \subsection xmega_xcl_qs_tc_setup_code ޗ
 *
 * conf_xcl.h̓e:
 * \code
 * #define CONFIG_XCL_CALLBACK_ENABLE
 * \endcode
 *
 * Ăі߂֐ǉ܂B
 * \code
 * static void my_xcl_tc16_interrupt_callback(void)
 * {
 *   // Ȃ̺ނɒǉĂB
 *   // ̺ނXCLBTC16vŉꊄ荞݂N鎞Ɏs܂B
 * }
 * \endcode
 *
 * Ⴆ΁ApÇقŎJԂɒǉ܂B
 * \code
 * void main(void)
 * {
 *   sysclk_init();
 *   board_init();
 *   irq_initialize_vectors();
 *   cpu_irq_enable();
 *
 *   xcl_enable(XCL_SYNCHRONOUS);
 *   xcl_port(PD);
 *   xcl_tc_type(TC16);
 *   xcl_set_unf_interrupt_callback(my_xcl_tc16_interrupt_callback);
 *   xcl_tc_set_underflow_interrupt_level(XCL_INT_LVL_LO);
 *   xcl_tc_set_resolution(7800);
 *   xcl_tc16_set_period(0x7FFF);
 *   xcl_tc16_set_count(0x7FFF);
 *   xcl_tc16_enable_underflow_interrupt();
 *
 *   while(1) {
 *   }
 * }
 * \endcode
 *
 * \subsection xmega_xcl_qs_tc_code_workflow Ƃ̗
 *
 * -# 荞ݏٰ(ISR)錾XCLĂі߂֐߁AXCLײނXCLP
 * ײޓłISRgp悤Ɍ`Ԑݒ肳ׂłB͈ȉ̒`
 * conf_xcl.ḩقɒǉ邱ƂŒB܂B
 *   - \code #define CONFIG_XCL_CALLBACK_ENABLE \endcode
 * -# ꊄ荞ݔɎsĂі߂֐ǉ܂B
 *   - \code static void my_xcl_tc16_interrupt_callback(void) { ... } \endcode
 * -# XCLPʕ𓯊ŋ܂B
 *  - \code xcl_enable(XCL_SYNCHRONOUS); \endcode
 *  - \note ͕KvƂȂA̒Pʕp̸ۯ т܂B
 * -# XMEGA߰Dg悤XCL`Ԑݒ肵܂B
 *  - \code xcl_port(PD); \endcode
 * -# 16ޯBTC16XCLTC`Ԑݒ肵܂B
 *  - \code xcl_tc_type(TC16); \endcode
 * -# ꊄ荞݂ɑ΂ČĂі߂֐ݒ肵܂B
 *  - \code xcl_set_unf_interrupt_callback(my_xcl_tc16_interrupt_callback); \endcode
 * -# XCLTCꊄ荞ق`Ԑݒ肵܂B
 *  - \code xcl_tc_set_underflow_interrupt_level(XCL_INT_LVL_LO); \endcode
 * -# XCLTC̎()Əvݒ肵܂B
 *  - \code xcl_tc16_set_period(0x7FFF); \endcode
 *  - \code xcl_tc16_set_count(0x7FFF); \endcode
 * -# vꂽ\B悤XCLTCۯݒ肵܂B
 *  - \code real_resolution = xcl_tc_set_resolution(7800); \endcode
 *  - \warning ۯݒ肳ƁAv킪vJn܂B
 * -# XCLTC16ꊄ荞݂܂B
 *  - \code xcl_tc16_enable_underflow_interrupt(); \endcode
 * -# v͔wʂősAĂі߂֐ŏꂽނ͖̌vꖈɎ
 *    s܂B
 *  - \code  while(1) {} \endcode
 */

#endif  /* _XCL_H_ */
