/**
 * \file
 *
 * \brief DALIԋ@\
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_hal.h"
#include "dali_top.h"
#include "dali_cmd.h"

/* ԂŎgp鎞 */
#define DALI_MAX_RX_TIME	(35 * MS_TICK)

/* DALIڰшُ팟oAPC0x55 0xAA𑗏o */
#define FRAME_ERROR_BYTE0	0x55
#define FRAME_ERROR_BYTE1	0xAA

/* я */
enum {STATE_INIT, STATE_WAITING, USART_RX, DALI_TX, DALI_RX, USART_TX, DALI_MONITOR};

uint8_t state;

void dali_state_init(void)
{
	state = STATE_INIT;
}

void dali_process_state(void)
{
	switch (state) {
	case STATE_INIT:
		/* 悸 */
		dali_hal_disable_state_timer_interrupt();
		/* ԕ\LEDOFF */
		ioport_set_pin_low(LED_STATE);
		/* PC̎M */
		dali_hal_enable_usart_rx();
		/* DALI */
		dali_hal_enable_dali_decode();
		state = STATE_WAITING;
		break;
		
	case STATE_WAITING:
		if (master_info.dali_rx_flag != RX_IDLE) {
			/* ԕ\LEDON */
			ioport_set_pin_high(LED_STATE);
			/* EDMAA֍sB */
			state = DALI_MONITOR;
		} else if (master_info.usart_rx_count != 0){
			ioport_set_pin_high(LED_STATE);
			/* PC USARTްM */
			state = USART_RX;
			/* DALI֎~ */
			dali_hal_disable_dali_decode();
		}
		break;

	case USART_RX:
		if (master_info.usart_rx_count == USART_RX_MAX) {
			master_info.usart_rx_count = 0;
			/* PC̎M֎~ */
			dali_hal_disable_usart_rx();
			master_info.dali_send_status = SENDING_START;
			state = DALI_TX;
		} else {
			/* sԍPCްM */
			state = STATE_INIT;
		}
		break;

	case DALI_TX:
		if(master_info.dali_send_status == SENDING_STOP){
			/* ꖽ */
			if ((master_info.usart_rx_buf[0] >= TERMINATE) && (master_info.usart_rx_buf[0] <= WRITE_MEMORY_LOCATION)) {
				if((master_info.usart_rx_buf[0] == COMPARE) || (master_info.usart_rx_buf[0] == VERIFY_SHORT_ADDRESS)
					||(master_info.usart_rx_buf[0] == QUERY_SHORT_ADDRESS)) {
					state = DALI_RX;
				}
			} else if (((master_info.usart_rx_buf[1] >= QUERY_STATUS) && (master_info.usart_rx_buf[1] <= READ_MEMORY_LOCATION))
				|| ((master_info.usart_rx_buf[1] >= QUERY_GEAR_TYPE) && (master_info.usart_rx_buf[1] <= QUERY_EXTENDED_VERSION_NUMBER))) {
					state = DALI_RX;
			}
			/* DALI USART𑗐MMԂ֕ϊ */
			dali_hal_set_dali_decode();
			if(state == DALI_RX) {
				master_info.state_time = 0;
				dali_hal_enable_state_timer_interrupt();
				dali_hal_enable_dali_decode();
			} else {
				/* tڰѕsv */
				state = STATE_INIT;
			}
		};
		break;

	case DALI_RX:
		if (master_info.state_time > DALI_MAX_RX_TIME){
			/* DALIްMȂ */
			state = STATE_INIT;
		} else if (master_info.dali_rx_flag != RX_IDLE) {
			state = USART_TX;
		}
		break;

	case USART_TX:
		if (master_info.dali_rx_flag == RX_ONE_BYTE){
			/* tڰёo */
			usart_putchar(USART_COMM, master_info.dali_rx_byte[0]);
		} else {
			/* ڰшُүޑo */
			usart_putchar(USART_COMM, FRAME_ERROR_BYTE0);
			usart_putchar(USART_COMM, FRAME_ERROR_BYTE1);
		}
		master_info.dali_rx_flag = RX_IDLE;
		while (!usart_tx_is_complete(USART_COMM));
		usart_clear_tx_complete(USART_COMM);
		state = STATE_INIT;
		break;

	case DALI_MONITOR:
		/* DALI޽ްPCɑo */
		if (master_info.dali_rx_flag == RX_ONE_BYTE){
			usart_putchar(USART_COMM, master_info.dali_rx_byte[0]);
		} else if (master_info.dali_rx_flag == RX_TWO_BYTES){
			usart_putchar(USART_COMM,  master_info.dali_rx_byte[0]);
			usart_putchar(USART_COMM,  master_info.dali_rx_byte[1]);
		} else  {
			usart_putchar(USART_COMM, FRAME_ERROR_BYTE0);
			usart_putchar(USART_COMM, FRAME_ERROR_BYTE1);
		}
		while (!usart_tx_is_complete(USART_COMM));
		usart_clear_tx_complete(USART_COMM);
		master_info.dali_rx_flag = RX_IDLE;
		state = STATE_INIT;
		break;

	default:
		break;
	}
}

void dali_state_time_inc(void)
{
	master_info.state_time++;
}